/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:30 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "deg2dms.h"
#include "libmatlbm.h"
#include "mat2dms.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

static mxChar _array3_[49] = { 'I', 'm', 'a', 'g', 'i', 'n', 'a', 'r', 'y', ' ',
                               'p', 'a', 'r', 't', 's', ' ', 'o', 'f', ' ', 'c',
                               'o', 'm', 'p', 'l', 'e', 'x', ' ', 'A', 'N', 'G',
                               'L', 'E', ' ', 'a', 'r', 'g', 'u', 'm', 'e', 'n',
                               't', ' ', 'i', 'g', 'n', 'o', 'r', 'e', 'd' };
static mxArray * _mxarray2_;
static mxArray * _mxarray4_;
static mxArray * _mxarray5_;
static mxArray * _mxarray6_;

void InitializeModule_deg2dms(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeString(49, _array3_);
    _mxarray4_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray5_ = mclInitializeDouble(0.0);
    _mxarray6_ = mclInitializeDouble(60.0);
}

void TerminateModule_deg2dms(void) {
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mdeg2dms(int nargout_, mxArray * deg);

_mexLocalFunctionTable _local_function_table_deg2dms
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfDeg2dms" contains the normal interface for the "deg2dms"
 * M-function from file "c:\matlab6p5\toolbox\map\map\deg2dms.m" (lines 1-59).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfDeg2dms(mxArray * deg) {
    int nargout = 1;
    mxArray * dms = NULL;
    mlfEnterNewContext(0, 1, deg);
    dms = Mdeg2dms(nargout, deg);
    mlfRestorePreviousContext(0, 1, deg);
    return mlfReturnValue(dms);
}

/*
 * The function "mlxDeg2dms" contains the feval interface for the "deg2dms"
 * M-function from file "c:\matlab6p5\toolbox\map\map\deg2dms.m" (lines 1-59).
 * The feval function calls the implementation version of deg2dms through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxDeg2dms(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: deg2dms Line: 1 Column: "
            "1 The function \"deg2dms\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: deg2dms Line: 1 Column:"
            " 1 The function \"deg2dms\" was called with m"
            "ore than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mdeg2dms(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mdeg2dms" is the implementation version of the "deg2dms"
 * M-function from file "c:\matlab6p5\toolbox\map\map\deg2dms.m" (lines 1-59).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function dms=deg2dms(deg)
 */
static mxArray * Mdeg2dms(int nargout_, mxArray * deg) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_deg2dms);
    int nargin_ = mclNargin(1, deg, NULL);
    mxArray * dms = NULL;
    mxArray * ssign = NULL;
    mxArray * msign = NULL;
    mxArray * dsign = NULL;
    mxArray * s = NULL;
    mxArray * m = NULL;
    mxArray * ms = NULL;
    mxArray * d = NULL;
    mxArray * signvec = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&deg);
    /*
     * 
     * %DEG2DMS Converts angles from degrees to deg:min:sec vector format
     * %
     * %  dms = DEG2DM(deg) converts angles from degrees to deg:min:sec vector
     * %  format.
     * %
     * %  See also DMS2DEG, DEG2RAD, MAT2DMS, DMS2MAT, ANGLEDIM, ANGL2STR
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.10 $    $Date: 2002/03/20 21:24:58 $
     * 
     * 
     * if nargin==0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif ~isreal(deg)
     */
    } else if (mclNotBool(mlfIsreal(mclVa(deg, "deg")))) {
        /*
         * warning('Imaginary parts of complex ANGLE argument ignored')
         */
        mclPrintAns(&ans, mlfNWarning(0, NULL, _mxarray2_, NULL));
        /*
         * deg = real(deg);
         */
        mlfAssign(&deg, mlfReal(mclVa(deg, "deg")));
    /*
     * end
     */
    }
    /*
     * 
     * %  Test for empty inputs
     * 
     * if isempty(deg);     dms = [];   return;   end
     */
    if (mlfTobool(mlfIsempty(mclVa(deg, "deg")))) {
        mlfAssign(&dms, _mxarray4_);
        goto return_;
    }
    /*
     * 
     * %  Construct a sign vector which has +1 when deg >= 0 and -1 when deg < 0.
     * 
     * signvec = sign(deg);
     */
    mlfAssign(&signvec, mlfSign(mclVa(deg, "deg")));
    /*
     * signvec = signvec + (signvec == 0);    %  Enforce +1 when deg == 0
     */
    mlfAssign(
      &signvec,
      mclPlus(
        mclVv(signvec, "signvec"),
        mclEq(mclVv(signvec, "signvec"), _mxarray5_)));
    /*
     * 
     * %  Compute the degrees, minutes and seconds
     * 
     * 
     * deg = abs(deg);             %  Work in absolute value.  Signvec will set sign later
     */
    mlfAssign(&deg, mlfAbs(mclVa(deg, "deg")));
    /*
     * d   = fix(deg);             %  Degrees
     */
    mlfAssign(&d, mlfFix(mclVa(deg, "deg")));
    /*
     * ms  = 60*(deg - d);         %  Minutes and seconds
     */
    mlfAssign(
      &ms, mclMtimes(_mxarray6_, mclMinus(mclVa(deg, "deg"), mclVv(d, "d"))));
    /*
     * m   = fix(ms);              %  Minutes
     */
    mlfAssign(&m, mlfFix(mclVv(ms, "ms")));
    /*
     * s   = 60*(ms - m);          %  Seconds
     */
    mlfAssign(
      &s, mclMtimes(_mxarray6_, mclMinus(mclVv(ms, "ms"), mclVv(m, "m"))));
    /*
     * 
     * %  Determine where to store the sign of the angle.  It should be
     * %  associated with the largest nonzero component of d:m:s.
     * 
     * dsign = signvec .* (d~=0);                %  Associate with degrees
     */
    mlfAssign(
      &dsign,
      mclTimes(mclVv(signvec, "signvec"), mclNe(mclVv(d, "d"), _mxarray5_)));
    /*
     * msign = signvec .* (d==0 & m~=0);         %  Assoicate with minutes (d = 0)
     */
    mlfAssign(
      &msign,
      mclTimes(
        mclVv(signvec, "signvec"),
        mclAnd(
          mclEq(mclVv(d, "d"), _mxarray5_), mclNe(mclVv(m, "m"), _mxarray5_))));
    /*
     * ssign = signvec .* (d==0 & m==0 & s~=0);  %  Associate with seconds (d = m = 0)
     */
    mlfAssign(
      &ssign,
      mclTimes(
        mclVv(signvec, "signvec"),
        mclAnd(
          mclAnd(
            mclEq(mclVv(d, "d"), _mxarray5_), mclEq(mclVv(m, "m"), _mxarray5_)),
          mclNe(mclVv(s, "s"), _mxarray5_))));
    /*
     * 
     * %  In the application of signs below, the comparison with 0 is used so that
     * %  the sign vector contains only +1 and -1.  Any zero occurances causes
     * %  data to be lost when the sign has been applied to a higher component
     * %  of d:m:s.
     * 
     * d = ((dsign==0) + dsign).*d;      %  Apply signs to the degrees
     */
    mlfAssign(
      &d,
      mclTimes(
        mclPlus(
          mclEq(mclVv(dsign, "dsign"), _mxarray5_), mclVv(dsign, "dsign")),
        mclVv(d, "d")));
    /*
     * m = ((msign==0) + msign).*m;      %  Apply signs to minutes
     */
    mlfAssign(
      &m,
      mclTimes(
        mclPlus(
          mclEq(mclVv(msign, "msign"), _mxarray5_), mclVv(msign, "msign")),
        mclVv(m, "m")));
    /*
     * s = ((ssign==0) + ssign).*s;      %  Apply signs to seconds
     */
    mlfAssign(
      &s,
      mclTimes(
        mclPlus(
          mclEq(mclVv(ssign, "ssign"), _mxarray5_), mclVv(ssign, "ssign")),
        mclVv(s, "s")));
    /*
     * 
     * dms = mat2dms(d,m,s);     %  Construct the dms vector for output
     */
    mlfAssign(
      &dms, mlfMat2dms(mclVv(d, "d"), mclVv(m, "m"), mclVv(s, "s"), NULL));
    /*
     * 
     * 
     */
    return_:
    mclValidateOutput(dms, 1, nargout_, "dms", "deg2dms");
    mxDestroyArray(ans);
    mxDestroyArray(signvec);
    mxDestroyArray(d);
    mxDestroyArray(ms);
    mxDestroyArray(m);
    mxDestroyArray(s);
    mxDestroyArray(dsign);
    mxDestroyArray(msign);
    mxDestroyArray(ssign);
    mxDestroyArray(deg);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return dms;
}
