/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:33 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "degchar.h"
#include "libmatlbm.h"

static mxChar _array1_[8] = { '^', '{', 0x005c, 'c', 'i', 'r', 'c', '}' };
static mxArray * _mxarray0_;

void InitializeModule_degchar(void) {
    _mxarray0_ = mclInitializeString(8, _array1_);
}

void TerminateModule_degchar(void) {
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mdegchar(int nargout_);

_mexLocalFunctionTable _local_function_table_degchar
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfDegchar" contains the normal interface for the "degchar"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\degchar.m" (lines
 * 1-26). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfDegchar(void) {
    int nargout = 1;
    mxArray * str = NULL;
    mlfEnterNewContext(0, 0);
    str = Mdegchar(nargout);
    mlfRestorePreviousContext(0, 0);
    return mlfReturnValue(str);
}

/*
 * The function "mlxDegchar" contains the feval interface for the "degchar"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\degchar.m" (lines
 * 1-26). The feval function calls the implementation version of degchar
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxDegchar(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: degchar Line: 1 Column: "
            "1 The function \"degchar\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 0) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: degchar Line: 1 Column:"
            " 1 The function \"degchar\" was called with m"
            "ore than the declared number of inputs (0)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    mlfEnterNewContext(0, 0);
    mplhs[0] = Mdegchar(nlhs);
    mlfRestorePreviousContext(0, 0);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mdegchar" is the implementation version of the "degchar"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\degchar.m" (lines
 * 1-26). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function str = degchar
 */
static mxArray * Mdegchar(int nargout_) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_degchar);
    mxArray * str = NULL;
    /*
     * 
     * %DEGCHAR  Sets the degree symbol character
     * %
     * %  str = DEGCHAR sets the degree symbol character in a LaTeX format.
     * %  The text interpreter must be set to LaTeX to have this symbol
     * %  properly displayed.
     * %
     * %  See also ANGL2STR
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * % $Revision: 1.8 $
     * %  Written by:  E. Byrns, E. Brown, W. Stumpf
     * 
     * 
     * 
     * %
     * % Old approach was to set the ascii code to a value which would
     * % map to the degree character for the font encoding of each platform.
     * % Now that LaTeX commands are understood by matlab displayed text commands,
     * % we can make use of them to create the degree symbol in a platform-
     * % independent way.
     * %
     * 
     * str = '^{\circ}';
     */
    mlfAssign(&str, _mxarray0_);
    mclValidateOutput(str, 1, nargout_, "str", "degchar");
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return str;
}
