/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:30 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "dms2deg.h"
#include "dms2mat.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

static mxChar _array3_[34] = { 'I', 'n', 'c', 'o', 'n', 's', 'i', 's', 't',
                               'e', 'n', 't', ' ', 'd', 'i', 'm', 'e', 'n',
                               's', 'i', 'o', 'n', 's', ' ', 'f', 'o', 'r',
                               ' ', 'i', 'n', 'p', 'u', 't', 's' };
static mxArray * _mxarray2_;

static mxChar _array5_[49] = { 'I', 'm', 'a', 'g', 'i', 'n', 'a', 'r', 'y', ' ',
                               'p', 'a', 'r', 't', 's', ' ', 'o', 'f', ' ', 'c',
                               'o', 'm', 'p', 'l', 'e', 'x', ' ', 'A', 'N', 'G',
                               'L', 'E', ' ', 'a', 'r', 'g', 'u', 'm', 'e', 'n',
                               't', ' ', 'i', 'g', 'n', 'o', 'r', 'e', 'd' };
static mxArray * _mxarray4_;
static mxArray * _mxarray6_;

static mxChar _array8_[48] = { 'M', 'u', 'l', 't', 'i', 'p', 'l', 'e', ' ', 'n',
                               'e', 'g', 'a', 't', 'i', 'v', 'e', ' ', 'e', 'n',
                               't', 'r', 'i', 'e', 's', ' ', 'i', 'n', ' ', 'a',
                               ' ', 'D', 'M', 'S', ' ', 's', 'p', 'e', 'c', 'i',
                               'f', 'i', 'c', 'a', 't', 'i', 'o', 'n' };
static mxArray * _mxarray7_;
static mxArray * _mxarray9_;
static mxArray * _mxarray10_;

void InitializeModule_dms2deg(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeString(34, _array3_);
    _mxarray4_ = mclInitializeString(49, _array5_);
    _mxarray6_ = mclInitializeDouble(0.0);
    _mxarray7_ = mclInitializeString(48, _array8_);
    _mxarray9_ = mclInitializeDouble(60.0);
    _mxarray10_ = mclInitializeDouble(3600.0);
}

void TerminateModule_dms2deg(void) {
    mxDestroyArray(_mxarray10_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mdms2deg(int nargout_,
                          mxArray * dms,
                          mxArray * in2,
                          mxArray * in3);

_mexLocalFunctionTable _local_function_table_dms2deg
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfDms2deg" contains the normal interface for the "dms2deg"
 * M-function from file "c:\matlab6p5\toolbox\map\map\dms2deg.m" (lines 1-52).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfDms2deg(mxArray * dms, mxArray * in2, mxArray * in3) {
    int nargout = 1;
    mxArray * deg = NULL;
    mlfEnterNewContext(0, 3, dms, in2, in3);
    deg = Mdms2deg(nargout, dms, in2, in3);
    mlfRestorePreviousContext(0, 3, dms, in2, in3);
    return mlfReturnValue(deg);
}

/*
 * The function "mlxDms2deg" contains the feval interface for the "dms2deg"
 * M-function from file "c:\matlab6p5\toolbox\map\map\dms2deg.m" (lines 1-52).
 * The feval function calls the implementation version of dms2deg through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxDms2deg(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[3];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: dms2deg Line: 1 Column: "
            "1 The function \"dms2deg\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: dms2deg Line: 1 Column:"
            " 1 The function \"dms2deg\" was called with m"
            "ore than the declared number of inputs (3)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 3 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 3; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    mplhs[0] = Mdms2deg(nlhs, mprhs[0], mprhs[1], mprhs[2]);
    mlfRestorePreviousContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mdms2deg" is the implementation version of the "dms2deg"
 * M-function from file "c:\matlab6p5\toolbox\map\map\dms2deg.m" (lines 1-52).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function deg=dms2deg(dms, in2, in3)
 */
static mxArray * Mdms2deg(int nargout_,
                          mxArray * dms,
                          mxArray * in2,
                          mxArray * in3) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_dms2deg);
    int nargin_ = mclNargin(3, dms, in2, in3, NULL);
    mxArray * deg = NULL;
    mxArray * signvec = NULL;
    mxArray * negvec = NULL;
    mxArray * s = NULL;
    mxArray * m = NULL;
    mxArray * d = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&dms);
    mclCopyArray(&in2);
    mclCopyArray(&in3);
    /*
     * 
     * %DMS2DEG Converts angles from deg:min:sec to degrees
     * %
     * %  deg = DMS2DEG(dms) converts from the deg:min:sec vector format
     * %  to degrees.
     * %
     * %  deg = DMS2DEG(d,m,s) converts from degree (d), minute (m) and
     * %  second (s) format to degrees.  The input matrices d, m and s must
     * %  be of equal size.  Minutes and seconds must be between 0 and 60.
     * %
     * %  See also DEG2DMS, DMS2RAD, DMS2VEC, DMS2MAT, ANGLEDIM, ANGL2STR
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.10 $    $Date: 2002/03/20 21:25:05 $
     * 
     * if nargin == 0 | nargin == 2
     */
    if (nargin_ == 0 || nargin_ == 2) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif nargin == 1
     */
    } else if (nargin_ == 1) {
        /*
         * [d,m,s] = dms2mat(dms);
         */
        mlfAssign(&d, mlfNDms2mat(3, &m, &s, mclVa(dms, "dms"), NULL));
    /*
     * elseif nargin == 3
     */
    } else if (nargin_ == 3) {
        /*
         * d = dms;   m = in2;    s = in3;
         */
        mlfAssign(&d, mclVa(dms, "dms"));
        mlfAssign(&m, mclVa(in2, "in2"));
        mlfAssign(&s, mclVa(in3, "in3"));
    /*
     * end
     */
    }
    /*
     * 
     * %  Dimension test
     * 
     * if ~isequal(size(d),size(m),size(s))
     */
    if (mclNotBool(
          mlfIsequal(
            mlfSize(mclValueVarargout(), mclVv(d, "d"), NULL),
            mlfSize(mclValueVarargout(), mclVv(m, "m"), NULL),
            mlfSize(mclValueVarargout(), mclVv(s, "s"), NULL),
            NULL))) {
        /*
         * error('Inconsistent dimensions for inputs')
         */
        mlfError(_mxarray2_, NULL);
    /*
     * elseif any([~isreal(d) ~isreal(m) ~isreal(s)])  %  Avoid concat of [d m s]
     */
    } else if (mlfTobool(
                 mlfAny(
                   mlfHorzcat(
                     mclNot(mlfIsreal(mclVv(d, "d"))),
                     mclNot(mlfIsreal(mclVv(m, "m"))),
                     mclNot(mlfIsreal(mclVv(s, "s"))),
                     NULL),
                   NULL))) {
        /*
         * warning('Imaginary parts of complex ANGLE argument ignored')
         */
        mclPrintAns(&ans, mlfNWarning(0, NULL, _mxarray4_, NULL));
        /*
         * d = real(d);    m = real(m);    s = real(s);
         */
        mlfAssign(&d, mlfReal(mclVv(d, "d")));
        mlfAssign(&m, mlfReal(mclVv(m, "m")));
        mlfAssign(&s, mlfReal(mclVv(s, "s")));
    /*
     * end
     */
    }
    /*
     * 
     * %  Ensure that only one negative sign is present
     * 
     * if any((s<0 & m<0) | (s<0 & d<0) | (m<0 & d<0) )
     */
    if (mlfTobool(
          mlfAny(
            mclOr(
              mclOr(
                mclAnd(
                  mclLt(mclVv(s, "s"), _mxarray6_),
                  mclLt(mclVv(m, "m"), _mxarray6_)),
                mclAnd(
                  mclLt(mclVv(s, "s"), _mxarray6_),
                  mclLt(mclVv(d, "d"), _mxarray6_))),
              mclAnd(
                mclLt(mclVv(m, "m"), _mxarray6_),
                mclLt(mclVv(d, "d"), _mxarray6_))),
            NULL))) {
        /*
         * error('Multiple negative entries in a DMS specification')
         */
        mlfError(_mxarray7_, NULL);
    /*
     * end
     */
    }
    /*
     * 
     * %  Construct a sign vector which has +1 when
     * %  angle >= 0 and -1 when angle < 0.  Note that the sign of the
     * %  angle is associated with the largest nonzero component of d:m:s
     * 
     * negvec = (d<0) | (m<0) | (s<0);
     */
    mlfAssign(
      &negvec,
      mclOr(
        mclOr(
          mclLt(mclVv(d, "d"), _mxarray6_), mclLt(mclVv(m, "m"), _mxarray6_)),
        mclLt(mclVv(s, "s"), _mxarray6_)));
    /*
     * signvec = ~negvec - negvec;
     */
    mlfAssign(
      &signvec,
      mclMinus(mclNot(mclVv(negvec, "negvec")), mclVv(negvec, "negvec")));
    /*
     * 
     * 
     * %  Compute the angle in degrees
     * 
     * deg  = signvec.*( abs(d) + abs(m)/60 + abs(s)/3600 );
     */
    mlfAssign(
      &deg,
      mclTimes(
        mclVv(signvec, "signvec"),
        mclPlus(
          mclPlus(
            mlfAbs(mclVv(d, "d")),
            mclMrdivide(mlfAbs(mclVv(m, "m")), _mxarray9_)),
          mclMrdivide(mlfAbs(mclVv(s, "s")), _mxarray10_))));
    mclValidateOutput(deg, 1, nargout_, "deg", "dms2deg");
    mxDestroyArray(ans);
    mxDestroyArray(d);
    mxDestroyArray(m);
    mxDestroyArray(s);
    mxDestroyArray(negvec);
    mxDestroyArray(signvec);
    mxDestroyArray(in3);
    mxDestroyArray(in2);
    mxDestroyArray(dms);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return deg;
}
