/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:31 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "flat2ecc.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;
static mxArray * _mxarray3_;

static mxChar _array5_[43] = { 'I', 'm', 'a', 'g', 'i', 'n', 'a', 'r', 'y',
                               ' ', 'p', 'a', 'r', 't', 's', ' ', 'o', 'f',
                               ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', ' ',
                               'i', 'g', 'n', 'o', 'r', 'e', 'd' };
static mxArray * _mxarray4_;

void InitializeModule_flat2ecc(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDouble(2.0);
    _mxarray3_ = mclInitializeDouble(1.0);
    _mxarray4_ = mclInitializeString(43, _array5_);
}

void TerminateModule_flat2ecc(void) {
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mflat2ecc(int nargout_, mxArray * parm);

_mexLocalFunctionTable _local_function_table_flat2ecc
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfFlat2ecc" contains the normal interface for the "flat2ecc"
 * M-function from file "c:\matlab6p5\toolbox\map\map\flat2ecc.m" (lines 1-45).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfFlat2ecc(mxArray * parm) {
    int nargout = 1;
    mxArray * eccent = NULL;
    mlfEnterNewContext(0, 1, parm);
    eccent = Mflat2ecc(nargout, parm);
    mlfRestorePreviousContext(0, 1, parm);
    return mlfReturnValue(eccent);
}

/*
 * The function "mlxFlat2ecc" contains the feval interface for the "flat2ecc"
 * M-function from file "c:\matlab6p5\toolbox\map\map\flat2ecc.m" (lines 1-45).
 * The feval function calls the implementation version of flat2ecc through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxFlat2ecc(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: flat2ecc Line: 1 Column:"
            " 1 The function \"flat2ecc\" was called with m"
            "ore than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: flat2ecc Line: 1 Column:"
            " 1 The function \"flat2ecc\" was called with m"
            "ore than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mflat2ecc(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mflat2ecc" is the implementation version of the "flat2ecc"
 * M-function from file "c:\matlab6p5\toolbox\map\map\flat2ecc.m" (lines 1-45).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function eccent = flat2ecc(parm)
 */
static mxArray * Mflat2ecc(int nargout_, mxArray * parm) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_flat2ecc);
    int nargin_ = mclNargin(1, parm, NULL);
    mxArray * eccent = NULL;
    mxArray * flat = NULL;
    mxArray * col = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&parm);
    /*
     * 
     * %FLAT2ECC  Computes the eccentricity of an ellipse given a flattening
     * %
     * %  e = FLAT2ECC(mat) computes the eccentricity of an ellipse (or
     * %  ellipsoid of revolution) given the flattening.  If the
     * %  input is a column vector, then each input is assumed to be a
     * %  flattening.  If the input has two columns, then the second
     * %  column is assumed to be the flattening.  If the input is a
     * %  n x m matrix, where m ~= 2, then each element is assumed to be a
     * %  flattening and the corresponding eccentricity is calculated.
     * %
     * %  See also:  ECC2FLAT, N2ECC, AXES2ECC
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:25:17 $
     * 
     * 
     * if nargin == 0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * end
     */
    }
    /*
     * 
     * %  Dimension tests
     * 
     * if min(size(parm)) == 1 & ndims(parm) <= 2
     */
    {
        mxArray * a_
          = mclInitialize(
              mclEq(
                mlfMin(
                  NULL,
                  mlfSize(mclValueVarargout(), mclVa(parm, "parm"), NULL),
                  NULL,
                  NULL),
                _mxarray3_));
        if (mlfTobool(a_)
            && mlfTobool(
                 mclAnd(
                   a_, mclLe(mlfNdims(mclVa(parm, "parm")), _mxarray2_)))) {
            mxDestroyArray(a_);
            /*
             * 
             * col = min(size(parm,2), 2);   % Select first or second column
             */
            mlfAssign(
              &col,
              mlfMin(
                NULL,
                mlfSize(mclValueVarargout(), mclVa(parm, "parm"), _mxarray2_),
                _mxarray2_,
                NULL));
            /*
             * flat = parm(:,col);           % First col if single vector input
             */
            mlfAssign(
              &flat,
              mclArrayRef2(
                mclVa(parm, "parm"), mlfCreateColonIndex(), mclVv(col, "col")));
        /*
         * % Second col if two column inputs (eg. geoid vecs)
         * else
         */
        } else {
            mxDestroyArray(a_);
            /*
             * flat = parm;        %  General matrix input
             */
            mlfAssign(&flat, mclVa(parm, "parm"));
        }
    /*
     * end
     */
    }
    /*
     * 
     * %  Ensure real inputs
     * 
     * if ~isreal(flat)
     */
    if (mclNotBool(mlfIsreal(mclVv(flat, "flat")))) {
        /*
         * warning('Imaginary parts of complex argument ignored')
         */
        mclPrintAns(&ans, mlfNWarning(0, NULL, _mxarray4_, NULL));
        /*
         * flat = real(flat);
         */
        mlfAssign(&flat, mlfReal(mclVv(flat, "flat")));
    /*
     * end
     */
    }
    /*
     * 
     * %  Compute the eccentricity
     * 
     * eccent = sqrt(2*flat - flat.^2);
     */
    mlfAssign(
      &eccent,
      mlfSqrt(
        mclMinus(
          mclMtimes(_mxarray2_, mclVv(flat, "flat")),
          mlfPower(mclVv(flat, "flat"), _mxarray2_))));
    mclValidateOutput(eccent, 1, nargout_, "eccent", "flat2ecc");
    mxDestroyArray(ans);
    mxDestroyArray(col);
    mxDestroyArray(flat);
    mxDestroyArray(parm);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return eccent;
}
