/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:33 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "gcpmap.h"
#include "ismap.h"
#include "libmatlbm.h"
#include "minvtran.h"
static mxArray * _mxarray0_;

static mxChar _array2_[13] = { 'C', 'u', 'r', 'r', 'e', 'n', 't',
                               'F', 'i', 'g', 'u', 'r', 'e' };
static mxArray * _mxarray1_;

static mxChar _array4_[11] = { 'C', 'u', 'r', 'r', 'e', 'n',
                               't', 'A', 'x', 'e', 's' };
static mxArray * _mxarray3_;

static mxChar _array6_[25] = { 'N', 'o', ' ', 'a', 'x', 'e', 's', ' ', 'i',
                               'n', ' ', 'c', 'u', 'r', 'r', 'e', 'n', 't',
                               ' ', 'f', 'i', 'g', 'u', 'r', 'e' };
static mxArray * _mxarray5_;

static mxChar _array8_[12] = { 'C', 'u', 'r', 'r', 'e', 'n',
                               't', 'P', 'o', 'i', 'n', 't' };
static mxArray * _mxarray7_;
static mxArray * _mxarray9_;
static mxArray * _mxarray10_;
static mxArray * _mxarray11_;

void InitializeModule_gcpmap(void) {
    _mxarray0_ = mclInitializeDouble(0.0);
    _mxarray1_ = mclInitializeString(13, _array2_);
    _mxarray3_ = mclInitializeString(11, _array4_);
    _mxarray5_ = mclInitializeString(25, _array6_);
    _mxarray7_ = mclInitializeString(12, _array8_);
    _mxarray9_ = mclInitializeDouble(1.0);
    _mxarray10_ = mclInitializeDouble(2.0);
    _mxarray11_ = mclInitializeDouble(3.0);
}

void TerminateModule_gcpmap(void) {
    mxDestroyArray(_mxarray11_);
    mxDestroyArray(_mxarray10_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mgcpmap(int nargout_, mxArray * hndl);

_mexLocalFunctionTable _local_function_table_gcpmap
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfGcpmap" contains the normal interface for the "gcpmap"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\gcpmap.m" (lines
 * 1-45). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfGcpmap(mxArray * hndl) {
    int nargout = 1;
    mxArray * pt = NULL;
    mlfEnterNewContext(0, 1, hndl);
    pt = Mgcpmap(nargout, hndl);
    mlfRestorePreviousContext(0, 1, hndl);
    return mlfReturnValue(pt);
}

/*
 * The function "mlxGcpmap" contains the feval interface for the "gcpmap"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\gcpmap.m" (lines
 * 1-45). The feval function calls the implementation version of gcpmap through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
void mlxGcpmap(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: gcpmap Line: 1 Column: "
            "1 The function \"gcpmap\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: gcpmap Line: 1 Column: "
            "1 The function \"gcpmap\" was called with mor"
            "e than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mgcpmap(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mgcpmap" is the implementation version of the "gcpmap"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\gcpmap.m" (lines
 * 1-45). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function pt = gcpmap(hndl)
 */
static mxArray * Mgcpmap(int nargout_, mxArray * hndl) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_gcpmap);
    int nargin_ = mclNargin(1, hndl, NULL);
    mxArray * pt = NULL;
    mxArray * long0 = NULL;
    mxArray * lat = NULL;
    mxArray * z = NULL;
    mxArray * y = NULL;
    mxArray * x = NULL;
    mxArray * msg = NULL;
    mxArray * mflag = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&hndl);
    /*
     * 
     * %GCPMAP  Gets the current point from a map
     * %
     * %  mat = GCPMAP will compute the current point on a map axes
     * %  in Greenwich coordinates.  GCPMAP works much like
     * %  get(gca,'CurrentPoint') except that the returned
     * %  matrix is [lat lon z], not [x y z].
     * %
     * %  mat = GCPMAP(h) returns the current map point from the axes
     * %  specified by the handle h.
     * %
     * %  See also  INPUTM, AXES ('CurrentPoint' property)
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * % $Revision: 1.9 $
     * %  Written by:  E. Byrns, E. Brown
     * 
     * 
     * 
     * if nargin == 0
     */
    if (nargin_ == 0) {
        /*
         * hndl = get(get(0,'CurrentFigure'),'CurrentAxes');
         */
        mlfAssign(
          &hndl,
          mlfNGet(
            1, mlfNGet(1, _mxarray0_, _mxarray1_, NULL), _mxarray3_, NULL));
        /*
         * if isempty(hndl);  error('No axes in current figure');  end
         */
        if (mlfTobool(mlfIsempty(mclVa(hndl, "hndl")))) {
            mlfError(_mxarray5_, NULL);
        }
    /*
     * end
     */
    }
    /*
     * 
     * %  Ensure that handle object is an axes.
     * 
     * [mflag,msg] = ismap(hndl);
     */
    mlfAssign(&mflag, mlfIsmap(&msg, mclVa(hndl, "hndl")));
    /*
     * if ~mflag;  error(msg);   end
     */
    if (mclNotBool(mclVv(mflag, "mflag"))) {
        mlfError(mclVv(msg, "msg"), NULL);
    }
    /*
     * 
     * %  Get the current point
     * 
     * pt = get(hndl,'CurrentPoint');
     */
    mlfAssign(&pt, mlfNGet(1, mclVa(hndl, "hndl"), _mxarray7_, NULL));
    /*
     * x = pt(:,1);     y = pt(:,2);    z = pt(:,3);
     */
    mlfAssign(
      &x, mclArrayRef2(mclVv(pt, "pt"), mlfCreateColonIndex(), _mxarray9_));
    mlfAssign(
      &y, mclArrayRef2(mclVv(pt, "pt"), mlfCreateColonIndex(), _mxarray10_));
    mlfAssign(
      &z, mclArrayRef2(mclVv(pt, "pt"), mlfCreateColonIndex(), _mxarray11_));
    /*
     * 
     * %  Compute the inverse transformation for the selected projection
     * %  Use text as an object to represent a point calculation
     * 
     * [lat,long] = minvtran(x,y,z);
     */
    mlfAssign(
      &lat,
      mlfMinvtran(
        &long0, NULL, mclVv(x, "x"), mclVv(y, "y"), mclVv(z, "z"), NULL));
    /*
     * 
     * %  Set the output matrix
     * 
     * pt = [lat long pt(:,3)];
     */
    mlfAssign(
      &pt,
      mlfHorzcat(
        mclVv(lat, "lat"),
        mclVv(long0, "long"),
        mclArrayRef2(mclVv(pt, "pt"), mlfCreateColonIndex(), _mxarray11_),
        NULL));
    mclValidateOutput(pt, 1, nargout_, "pt", "gcpmap");
    mxDestroyArray(ans);
    mxDestroyArray(mflag);
    mxDestroyArray(msg);
    mxDestroyArray(x);
    mxDestroyArray(y);
    mxDestroyArray(z);
    mxDestroyArray(lat);
    mxDestroyArray(long0);
    mxDestroyArray(hndl);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return pt;
    /*
     * 
     */
}
