/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:36 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "geod2cnf.h"
#include "almanac.h"
#include "angledim.h"
#include "geoidtst.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;

static mxChar _array4_[7] = { 'd', 'e', 'g', 'r', 'e', 'e', 's' };
static mxArray * _mxarray3_;

static mxChar _array6_[5] = { 'e', 'a', 'r', 't', 'h' };
static mxArray * _mxarray5_;

static mxChar _array8_[5] = { 'g', 'e', 'o', 'i', 'd' };
static mxArray * _mxarray7_;

static mxChar _array10_[7] = { 'r', 'a', 'd', 'i', 'a', 'n', 's' };
static mxArray * _mxarray9_;
static mxArray * _mxarray11_;
static mxArray * _mxarray12_;
static mxArray * _mxarray13_;
static mxArray * _mxarray14_;
static mxArray * _mxarray15_;
static double _ieee_nan_;
static mxArray * _mxarray16_;

void InitializeModule_geod2cnf(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray3_ = mclInitializeString(7, _array4_);
    _mxarray5_ = mclInitializeString(5, _array6_);
    _mxarray7_ = mclInitializeString(5, _array8_);
    _mxarray9_ = mclInitializeString(7, _array10_);
    _mxarray11_ = mclInitializeDouble(1.0);
    _mxarray12_ = mclInitializeDouble(0.0);
    _mxarray13_ = mclInitializeDouble(2.220446049250313e-16);
    _mxarray14_ = mclInitializeDouble(2.0);
    _mxarray15_ = mclInitializeDouble(1.5707963267948966);
    _ieee_nan_ = mclGetNaN();
    _mxarray16_ = mclInitializeDouble(_ieee_nan_);
}

void TerminateModule_geod2cnf(void) {
    mxDestroyArray(_mxarray16_);
    mxDestroyArray(_mxarray15_);
    mxDestroyArray(_mxarray14_);
    mxDestroyArray(_mxarray13_);
    mxDestroyArray(_mxarray12_);
    mxDestroyArray(_mxarray11_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mgeod2cnf(int nargout_,
                           mxArray * latin,
                           mxArray * geoid,
                           mxArray * units);

_mexLocalFunctionTable _local_function_table_geod2cnf
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfGeod2cnf" contains the normal interface for the "geod2cnf"
 * M-function from file "c:\matlab6p5\toolbox\map\map\geod2cnf.m" (lines 1-85).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfGeod2cnf(mxArray * latin, mxArray * geoid, mxArray * units) {
    int nargout = 1;
    mxArray * latout = NULL;
    mlfEnterNewContext(0, 3, latin, geoid, units);
    latout = Mgeod2cnf(nargout, latin, geoid, units);
    mlfRestorePreviousContext(0, 3, latin, geoid, units);
    return mlfReturnValue(latout);
}

/*
 * The function "mlxGeod2cnf" contains the feval interface for the "geod2cnf"
 * M-function from file "c:\matlab6p5\toolbox\map\map\geod2cnf.m" (lines 1-85).
 * The feval function calls the implementation version of geod2cnf through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxGeod2cnf(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[3];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: geod2cnf Line: 1 Column:"
            " 1 The function \"geod2cnf\" was called with m"
            "ore than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: geod2cnf Line: 1 Column:"
            " 1 The function \"geod2cnf\" was called with m"
            "ore than the declared number of inputs (3)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 3 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 3; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    mplhs[0] = Mgeod2cnf(nlhs, mprhs[0], mprhs[1], mprhs[2]);
    mlfRestorePreviousContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mgeod2cnf" is the implementation version of the "geod2cnf"
 * M-function from file "c:\matlab6p5\toolbox\map\map\geod2cnf.m" (lines 1-85).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function latout = geod2cnf(latin,geoid,units)
 */
static mxArray * Mgeod2cnf(int nargout_,
                           mxArray * latin,
                           mxArray * geoid,
                           mxArray * units) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_geod2cnf);
    int nargin_ = mclNargin(3, latin, geoid, units, NULL);
    mxArray * latout = NULL;
    mxArray * indx = NULL;
    mxArray * fact4 = NULL;
    mxArray * fact3 = NULL;
    mxArray * fact2 = NULL;
    mxArray * fact1 = NULL;
    mxArray * e = NULL;
    mxArray * msg = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&latin);
    mclCopyArray(&geoid);
    mclCopyArray(&units);
    /*
     * 
     * %GEOD2CNF  Converts from geodetic latitude to conformal latitude
     * %
     * %  lat = GEOD2CNF(lat0) converts from the geodetic latitude to the
     * %  conformal latitude.  The conformal latitude is used to map an
     * %  ellipsoid conformally onto a sphere. Conformal latitudes are used
     * %  in place of the geodetic latitudes when projecting the ellipsoid
     * %  using a conformal projection.  The geodetic latitude is the angle
     * %  which a line perpendicular to the surface of the ellipsoid at the
     * %  given point makes with the equatorial plane.
     * %
     * %  lat = GEOD2CNF(lat0,geoid) uses the ellipsoid definition given in
     * %  the input vector geoid.  Geoid can be determined from the ALMANAC
     * %  function.  If omitted, the default Earth geoid is assumed.
     * %
     * %  lat = GEOD2CNF(lat0,'units') uses the units defined by the input string
     * %  'units'.  If omitted, default units of degrees are assumed.
     * %
     * %  lat = GEOD2CNF(lat0,geoid,'units') uses the geoid and 'units'
     * %  definitions provided by the corresponding inputs.
     * %
     * %  See also:  CNF2GEOD, GEOD2AUT, GEOD2CEN, GEOD2ISO,
     * %             GEOD2PAR, GEOD2REC, ALMANAC
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.10 $    $Date: 2002/03/20 21:25:25 $
     * 
     * %   The formulae employed were taken from:  J. P. Snyder,
     * %   "Map Projections - A Working Manual,"  US Geological
     * %   Survey Professional Paper 1395, US Government Printing
     * %   Office, Washington, DC, 1987, pp. 13-18.
     * 
     * if nargin == 0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif nargin == 1
     */
    } else if (nargin_ == 1) {
        /*
         * units = [];     geoid = [];
         */
        mlfAssign(&units, _mxarray2_);
        mlfAssign(&geoid, _mxarray2_);
    /*
     * elseif nargin == 2
     */
    } else if (nargin_ == 2) {
        /*
         * if isstr(geoid);    units = geoid;    geoid = [];
         */
        if (mlfTobool(mlfIsstr(mclVa(geoid, "geoid")))) {
            mlfAssign(&units, mclVa(geoid, "geoid"));
            mlfAssign(&geoid, _mxarray2_);
        /*
         * else;          units = 'degrees';
         */
        } else {
            mlfAssign(&units, _mxarray3_);
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * 
     * %  Empty argument tests
     * 
     * if isempty(units);   units = 'degrees';       end
     */
    if (mlfTobool(mlfIsempty(mclVa(units, "units")))) {
        mlfAssign(&units, _mxarray3_);
    }
    /*
     * if isempty(geoid);   geoid = almanac('earth','geoid');  end
     */
    if (mlfTobool(mlfIsempty(mclVa(geoid, "geoid")))) {
        mlfAssign(&geoid, mlfAlmanac(_mxarray5_, _mxarray7_, NULL, NULL));
    }
    /*
     * 
     * %  Test the geoid input
     * 
     * [geoid,msg] = geoidtst(geoid);
     */
    mlfAssign(&geoid, mlfNGeoidtst(2, &msg, mclVa(geoid, "geoid")));
    /*
     * if ~isempty(msg);   error(msg);   end
     */
    if (mclNotBool(mlfIsempty(mclVv(msg, "msg")))) {
        mlfError(mclVv(msg, "msg"), NULL);
    }
    /*
     * e = geoid(2);
     */
    mlfAssign(&e, mclIntArrayRef1(mclVa(geoid, "geoid"), 2));
    /*
     * 
     * 
     * latin = angledim(latin,units,'radians');   %  Convert to radians
     */
    mlfAssign(
      &latin,
      mlfAngledim(mclVa(latin, "latin"), mclVa(units, "units"), _mxarray9_));
    /*
     * 
     * %  Compute the transformation
     * 
     * fact1  = 1 - e*sin(latin);     fact2 = 1 + e*sin(latin);
     */
    mlfAssign(
      &fact1,
      mclMinus(
        _mxarray11_, mclMtimes(mclVv(e, "e"), mlfSin(mclVa(latin, "latin")))));
    mlfAssign(
      &fact2,
      mclPlus(
        _mxarray11_, mclMtimes(mclVv(e, "e"), mlfSin(mclVa(latin, "latin")))));
    /*
     * fact3  = 1 - sin(latin);       fact4 = 1 + sin(latin);
     */
    mlfAssign(&fact3, mclMinus(_mxarray11_, mlfSin(mclVa(latin, "latin"))));
    mlfAssign(&fact4, mclPlus(_mxarray11_, mlfSin(mclVa(latin, "latin"))));
    /*
     * 
     * %  Eliminate any divide by zeros.  Points exactly at +90
     * 
     * if ~isempty(fact3)            %  Input matrix may be empty
     */
    if (mclNotBool(mlfIsempty(mclVv(fact3, "fact3")))) {
        /*
         * indx = find(fact3 == 0);  %  when called from places like reckon
         */
        mlfAssign(
          &indx,
          mlfFind(NULL, NULL, mclEq(mclVv(fact3, "fact3"), _mxarray12_)));
        /*
         * if ~isempty(indx);   fact3(indx) = eps;   end
         */
        if (mclNotBool(mlfIsempty(mclVv(indx, "indx")))) {
            mclArrayAssign1(&fact3, _mxarray13_, mclVv(indx, "indx"));
        }
    /*
     * else
     */
    } else {
        /*
         * indx = [];
         */
        mlfAssign(&indx, _mxarray2_);
    /*
     * end
     */
    }
    /*
     * 
     * %  Conformal latitudes
     * 
     * latout = 2 * atan(sqrt((fact4./fact3) .* ((fact1./fact2).^e)) ) - pi/2;
     */
    mlfAssign(
      &latout,
      mclMinus(
        mclMtimes(
          _mxarray14_,
          mlfAtan(
            mlfSqrt(
              mclTimes(
                mclRdivide(mclVv(fact4, "fact4"), mclVv(fact3, "fact3")),
                mlfPower(
                  mclRdivide(mclVv(fact1, "fact1"), mclVv(fact2, "fact2")),
                  mclVv(e, "e")))))),
        _mxarray15_));
    /*
     * 
     * %  Correct for points at +90;
     * 
     * if ~isempty(indx);    latout(indx) = pi/2;    end
     */
    if (mclNotBool(mlfIsempty(mclVv(indx, "indx")))) {
        mclArrayAssign1(&latout, _mxarray15_, mclVv(indx, "indx"));
    }
    /*
     * 
     * indx = find(isnan(latout));               % operations on NaNs produce
     */
    mlfAssign(&indx, mlfFind(NULL, NULL, mlfIsnan(mclVv(latout, "latout"))));
    /*
     * if ~isempty(indx); latout(indx)=NaN; end  % unwanted complex results
     */
    if (mclNotBool(mlfIsempty(mclVv(indx, "indx")))) {
        mclArrayAssign1(&latout, _mxarray16_, mclVv(indx, "indx"));
    }
    /*
     * 
     * latout = angledim(latout,'radians',units);  %  Convert to output units
     */
    mlfAssign(
      &latout,
      mlfAngledim(mclVv(latout, "latout"), _mxarray9_, mclVa(units, "units")));
    mclValidateOutput(latout, 1, nargout_, "latout", "geod2cnf");
    mxDestroyArray(ans);
    mxDestroyArray(msg);
    mxDestroyArray(e);
    mxDestroyArray(fact1);
    mxDestroyArray(fact2);
    mxDestroyArray(fact3);
    mxDestroyArray(fact4);
    mxDestroyArray(indx);
    mxDestroyArray(units);
    mxDestroyArray(geoid);
    mxDestroyArray(latin);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return latout;
}
