/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:34 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "geod2iso.h"
#include "almanac.h"
#include "angledim.h"
#include "geod2cnf.h"
#include "geoidtst.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;

static mxChar _array4_[7] = { 'd', 'e', 'g', 'r', 'e', 'e', 's' };
static mxArray * _mxarray3_;

static mxChar _array6_[5] = { 'e', 'a', 'r', 't', 'h' };
static mxArray * _mxarray5_;

static mxChar _array8_[5] = { 'g', 'e', 'o', 'i', 'd' };
static mxArray * _mxarray7_;

static mxChar _array10_[7] = { 'r', 'a', 'd', 'i', 'a', 'n', 's' };
static mxArray * _mxarray9_;
static mxArray * _mxarray11_;
static mxArray * _mxarray12_;
static mxArray * _mxarray13_;
static mxArray * _mxarray14_;
static double _ieee_nan_;
static mxArray * _mxarray15_;

void InitializeModule_geod2iso(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray3_ = mclInitializeString(7, _array4_);
    _mxarray5_ = mclInitializeString(5, _array6_);
    _mxarray7_ = mclInitializeString(5, _array8_);
    _mxarray9_ = mclInitializeString(7, _array10_);
    _mxarray11_ = mclInitializeDouble(1.5707963267948966);
    _mxarray12_ = mclInitializeDouble(2.220446049250313e-16);
    _mxarray13_ = mclInitializeDouble(.7853981633974483);
    _mxarray14_ = mclInitializeDouble(2.0);
    _ieee_nan_ = mclGetNaN();
    _mxarray15_ = mclInitializeDouble(_ieee_nan_);
}

void TerminateModule_geod2iso(void) {
    mxDestroyArray(_mxarray15_);
    mxDestroyArray(_mxarray14_);
    mxDestroyArray(_mxarray13_);
    mxDestroyArray(_mxarray12_);
    mxDestroyArray(_mxarray11_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mgeod2iso(int nargout_,
                           mxArray * latin,
                           mxArray * geoid,
                           mxArray * units);

_mexLocalFunctionTable _local_function_table_geod2iso
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfGeod2iso" contains the normal interface for the "geod2iso"
 * M-function from file "c:\matlab6p5\toolbox\map\map\geod2iso.m" (lines 1-79).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfGeod2iso(mxArray * latin, mxArray * geoid, mxArray * units) {
    int nargout = 1;
    mxArray * latout = NULL;
    mlfEnterNewContext(0, 3, latin, geoid, units);
    latout = Mgeod2iso(nargout, latin, geoid, units);
    mlfRestorePreviousContext(0, 3, latin, geoid, units);
    return mlfReturnValue(latout);
}

/*
 * The function "mlxGeod2iso" contains the feval interface for the "geod2iso"
 * M-function from file "c:\matlab6p5\toolbox\map\map\geod2iso.m" (lines 1-79).
 * The feval function calls the implementation version of geod2iso through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxGeod2iso(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[3];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: geod2iso Line: 1 Column:"
            " 1 The function \"geod2iso\" was called with m"
            "ore than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: geod2iso Line: 1 Column:"
            " 1 The function \"geod2iso\" was called with m"
            "ore than the declared number of inputs (3)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 3 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 3; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    mplhs[0] = Mgeod2iso(nlhs, mprhs[0], mprhs[1], mprhs[2]);
    mlfRestorePreviousContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mgeod2iso" is the implementation version of the "geod2iso"
 * M-function from file "c:\matlab6p5\toolbox\map\map\geod2iso.m" (lines 1-79).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function latout = geod2iso(latin,geoid,units)
 */
static mxArray * Mgeod2iso(int nargout_,
                           mxArray * latin,
                           mxArray * geoid,
                           mxArray * units) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_geod2iso);
    int nargin_ = mclNargin(3, latin, geoid, units, NULL);
    mxArray * latout = NULL;
    mxArray * latcnf = NULL;
    mxArray * indx = NULL;
    mxArray * e = NULL;
    mxArray * msg = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&latin);
    mclCopyArray(&geoid);
    mclCopyArray(&units);
    /*
     * 
     * %GEOD2ISO  Computes the isometric latitude given the geodetic latitude
     * %
     * %  lat = GEOD2ISO(lat0) computes the isometric latitude given the
     * %  geodetic latitude.  The isometric latitude is a nonlinear function
     * %  of the geodetic latitude.  It is directly proportional to the
     * %  spacing of parallels of geodetic latitude from the Equator on the
     * %  ellipsoidal Mercator projection.  The geodetic latitude is the angle
     * %  which a line perpendicular to the surface of the ellipsoid at the
     * %  given point makes with the equatorial plane.
     * %
     * %  lat = GEOD2ISO(lat0,geoid) uses the ellipsoid definition given in
     * %  the input vector geoid.  Geoid can be determined from the ALMANAC
     * %  function.  If omitted, the default Earth geoid is assumed.
     * %
     * %  lat = GEOD2ISO(lat0,'units') uses the units defined by the input string
     * %  'units'.  If omitted, default units of degrees are assumed.
     * %
     * %  lat = GEOD2ISO(lat0,geoid,'units') uses the geoid and 'units'
     * %  definitions provided by the corresponding inputs.
     * %
     * %  See also:  GEOD2ISO, AUT2GEOD, CEN2GEOD, CNF2GEOD,
     * %             PAR2GEOD, REC2GEOD, ALMANAC
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.11 $    $Date: 2002/03/20 21:25:26 $
     * 
     * %   The formulae employed were taken from:  J. P. Snyder,
     * %   "Map Projections - A Working Manual,"  US Geological
     * %   Survey Professional Paper 1395, US Government Printing
     * %   Office, Washington, DC, 1987, pp. 13-18.
     * 
     * 
     * if nargin == 0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif nargin == 1
     */
    } else if (nargin_ == 1) {
        /*
         * units = [];     geoid = [];
         */
        mlfAssign(&units, _mxarray2_);
        mlfAssign(&geoid, _mxarray2_);
    /*
     * elseif nargin == 2
     */
    } else if (nargin_ == 2) {
        /*
         * if isstr(geoid);    units = geoid;    geoid = [];
         */
        if (mlfTobool(mlfIsstr(mclVa(geoid, "geoid")))) {
            mlfAssign(&units, mclVa(geoid, "geoid"));
            mlfAssign(&geoid, _mxarray2_);
        /*
         * else;          units = 'degrees';
         */
        } else {
            mlfAssign(&units, _mxarray3_);
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * 
     * %  Empty argument tests
     * 
     * 
     * if isempty(units);   units = 'degrees';       end
     */
    if (mlfTobool(mlfIsempty(mclVa(units, "units")))) {
        mlfAssign(&units, _mxarray3_);
    }
    /*
     * if isempty(geoid);   geoid = almanac('earth','geoid');  end
     */
    if (mlfTobool(mlfIsempty(mclVa(geoid, "geoid")))) {
        mlfAssign(&geoid, mlfAlmanac(_mxarray5_, _mxarray7_, NULL, NULL));
    }
    /*
     * 
     * %  Test the geoid input
     * 
     * [geoid,msg] = geoidtst(geoid);
     */
    mlfAssign(&geoid, mlfNGeoidtst(2, &msg, mclVa(geoid, "geoid")));
    /*
     * if ~isempty(msg);   error(msg);   end
     */
    if (mclNotBool(mlfIsempty(mclVv(msg, "msg")))) {
        mlfError(mclVv(msg, "msg"), NULL);
    }
    /*
     * e = geoid(2);
     */
    mlfAssign(&e, mclIntArrayRef1(mclVa(geoid, "geoid"), 2));
    /*
     * 
     * 
     * latin = angledim(latin,units,'radians');   %  Convert to radians
     */
    mlfAssign(
      &latin,
      mlfAngledim(mclVa(latin, "latin"), mclVa(units, "units"), _mxarray9_));
    /*
     * 
     * %  Eliminate any log of zeros.  Points exactly at -90.  Replace
     * %  with +90 and then negate these points
     * 
     * indx = find(abs(latin + pi/2) <= eps );
     */
    mlfAssign(
      &indx,
      mlfFind(
        NULL,
        NULL,
        mclLe(
          mlfAbs(mclPlus(mclVa(latin, "latin"), _mxarray11_)), _mxarray12_)));
    /*
     * if ~isempty(indx);   latin(indx) = pi/2;   end
     */
    if (mclNotBool(mlfIsempty(mclVv(indx, "indx")))) {
        mclArrayAssign1(&latin, _mxarray11_, mclVv(indx, "indx"));
    }
    /*
     * 
     * 
     * latcnf = geod2cnf(latin,geoid,'radians');   %  Compute the conformal lat
     */
    mlfAssign(
      &latcnf,
      mlfGeod2cnf(mclVa(latin, "latin"), mclVa(geoid, "geoid"), _mxarray9_));
    /*
     * latout = log ( tan(pi/4 + latcnf/2) );      %  Transform to isometric
     */
    mlfAssign(
      &latout,
      mlfLog(
        mlfTan(
          mclPlus(
            _mxarray13_, mclMrdivide(mclVv(latcnf, "latcnf"), _mxarray14_)))));
    /*
     * 
     * %  Correct for points at -90;
     * 
     * if ~isempty(indx);    latout(indx) = -latout(indx);    end
     */
    if (mclNotBool(mlfIsempty(mclVv(indx, "indx")))) {
        mclArrayAssign1(
          &latout,
          mclUminus(mclArrayRef1(mclVv(latout, "latout"), mclVv(indx, "indx"))),
          mclVv(indx, "indx"));
    }
    /*
     * 
     * indx = find(isnan(latout));               % operations on NaNs produce
     */
    mlfAssign(&indx, mlfFind(NULL, NULL, mlfIsnan(mclVv(latout, "latout"))));
    /*
     * if ~isempty(indx); latout(indx)=NaN; end  % unwanted complex results
     */
    if (mclNotBool(mlfIsempty(mclVv(indx, "indx")))) {
        mclArrayAssign1(&latout, _mxarray15_, mclVv(indx, "indx"));
    }
    /*
     * 
     * latout = angledim(latout,'radians',units);  %  Convert to output units
     */
    mlfAssign(
      &latout,
      mlfAngledim(mclVv(latout, "latout"), _mxarray9_, mclVa(units, "units")));
    mclValidateOutput(latout, 1, nargout_, "latout", "geod2iso");
    mxDestroyArray(ans);
    mxDestroyArray(msg);
    mxDestroyArray(e);
    mxDestroyArray(indx);
    mxDestroyArray(latcnf);
    mxDestroyArray(units);
    mxDestroyArray(geoid);
    mxDestroyArray(latin);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return latout;
}
