/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:34 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "km2sm.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

static mxChar _array3_[52] = { 'I', 'm', 'a', 'g', 'i', 'n', 'a', 'r', 'y',
                               ' ', 'p', 'a', 'r', 't', 's', ' ', 'o', 'f',
                               ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ' ',
                               'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', ' ',
                               'i', 'g', 'n', 'o', 'r', 'e', 'd' };
static mxArray * _mxarray2_;
static mxArray * _mxarray4_;

void InitializeModule_km2sm(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeString(52, _array3_);
    _mxarray4_ = mclInitializeDouble(1.6093);
}

void TerminateModule_km2sm(void) {
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mkm2sm(int nargout_, mxArray * km);

_mexLocalFunctionTable _local_function_table_km2sm
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfKm2sm" contains the normal interface for the "km2sm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\km2sm.m" (lines 1-22).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfKm2sm(mxArray * km) {
    int nargout = 1;
    mxArray * sm = NULL;
    mlfEnterNewContext(0, 1, km);
    sm = Mkm2sm(nargout, km);
    mlfRestorePreviousContext(0, 1, km);
    return mlfReturnValue(sm);
}

/*
 * The function "mlxKm2sm" contains the feval interface for the "km2sm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\km2sm.m" (lines 1-22).
 * The feval function calls the implementation version of km2sm through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxKm2sm(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: km2sm Line: 1 Column: 1 The function \"km2sm"
            "\" was called with more than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: km2sm Line: 1 Column: 1 The function \"km2sm"
            "\" was called with more than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mkm2sm(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mkm2sm" is the implementation version of the "km2sm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\km2sm.m" (lines 1-22). It
 * contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function sm = km2sm(km)
 */
static mxArray * Mkm2sm(int nargout_, mxArray * km) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_km2sm);
    int nargin_ = mclNargin(1, km, NULL);
    mxArray * sm = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&km);
    /*
     * 
     * %KM2SM Converts distances from kilometers to statute miles
     * %
     * %  sm = KM2SM(km) converts distances from kilometers to statute miles.
     * %
     * %  See also SM2KM, KM2DEG, KM2RAD, KM2NM, DISTDIM
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Brown, E. Byrns
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:25:44 $
     * 
     * if nargin==0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif ~isreal(km)
     */
    } else if (mclNotBool(mlfIsreal(mclVa(km, "km")))) {
        /*
         * warning('Imaginary parts of complex DISTANCE argument ignored')
         */
        mclPrintAns(&ans, mlfNWarning(0, NULL, _mxarray2_, NULL));
        /*
         * km = real(km);
         */
        mlfAssign(&km, mlfReal(mclVa(km, "km")));
    /*
     * end
     */
    }
    /*
     * 
     * 
     * sm=km/1.6093;
     */
    mlfAssign(&sm, mclMrdivide(mclVa(km, "km"), _mxarray4_));
    mclValidateOutput(sm, 1, nargout_, "sm", "km2sm");
    mxDestroyArray(ans);
    mxDestroyArray(km);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return sm;
}
