/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:31 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "meanm.h"
#include "angledim.h"
#include "aut2geod.h"
#include "epsm.h"
#include "geod2aut.h"
#include "geoidtst.h"
#include "libmatlbm.h"
#include "libmmfile.h"
#include "npi2pi.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;

static mxChar _array4_[7] = { 'd', 'e', 'g', 'r', 'e', 'e', 's' };
static mxArray * _mxarray3_;

static double _array6_[2] = { 1.0, 0.0 };
static mxArray * _mxarray5_;
static mxArray * _mxarray7_;

static mxChar _array9_[56] = { 'L', 'a', 't', 'i', 't', 'u', 'd', 'e', ' ', 'a',
                               'n', 'd', ' ', 'l', 'o', 'n', 'g', 'i', 't', 'u',
                               'd', 'e', ' ', 'i', 'n', 'p', 'u', 't', 's', ' ',
                               'l', 'i', 'm', 'i', 't', 'e', 'd', ' ', 't', 'o',
                               ' ', 't', 'w', 'o', ' ', 'd', 'i', 'm', 'e', 'n',
                               's', 'i', 'o', 'n', 's', '.' };
static mxArray * _mxarray8_;

static mxChar _array11_[56] = { 'I', 'n', 'c', 'o', 'n', 's', 'i', 's',
                                't', 'e', 'n', 't', ' ', 'd', 'i', 'm',
                                'e', 'n', 's', 'i', 'o', 'n', 's', ' ',
                                'o', 'n', ' ', 'l', 'a', 't', 'i', 't',
                                'u', 'd', 'e', ' ', 'a', 'n', 'd', ' ',
                                'l', 'o', 'n', 'g', 'i', 't', 'u', 'd',
                                'e', ' ', 'i', 'n', 'p', 'u', 't', 's' };
static mxArray * _mxarray10_;

static mxChar _array13_[7] = { 'r', 'a', 'd', 'i', 'a', 'n', 's' };
static mxArray * _mxarray12_;

static mxChar _array15_[5] = { 'e', 'x', 'a', 'c', 't' };
static mxArray * _mxarray14_;

static mxChar _array17_[65] = { 'D', 'a', 't', 'a', ' ', 'i', 'n', ' ', 'a',
                                't', ' ', 'l', 'e', 'a', 's', 't', ' ', 'o',
                                'n', 'e', ' ', 'c', 'o', 'l', 'u', 'm', 'n',
                                ' ', 'c', 'o', 'n', 's', 'i', 's', 't', 's',
                                ' ', 's', 'o', 'l', 'e', 'l', 'y', ' ', 'o',
                                'f', ' ', 'c', 'a', 'n', 'c', 'e', 'l', 'l',
                                'i', 'n', 'g', ' ', 'p', 'o', 'i', 'n', 't',
                                's', '.' };
static mxArray * _mxarray16_;
static double _ieee_nan_;
static mxArray * _mxarray18_;

void InitializeModule_meanm(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray3_ = mclInitializeString(7, _array4_);
    _mxarray5_ = mclInitializeDoubleVector(1, 2, _array6_);
    _mxarray7_ = mclInitializeDouble(2.0);
    _mxarray8_ = mclInitializeString(56, _array9_);
    _mxarray10_ = mclInitializeString(56, _array11_);
    _mxarray12_ = mclInitializeString(7, _array13_);
    _mxarray14_ = mclInitializeString(5, _array15_);
    _mxarray16_ = mclInitializeString(65, _array17_);
    _ieee_nan_ = mclGetNaN();
    _mxarray18_ = mclInitializeDouble(_ieee_nan_);
}

void TerminateModule_meanm(void) {
    mxDestroyArray(_mxarray18_);
    mxDestroyArray(_mxarray16_);
    mxDestroyArray(_mxarray14_);
    mxDestroyArray(_mxarray12_);
    mxDestroyArray(_mxarray10_);
    mxDestroyArray(_mxarray8_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mmeanm(mxArray * * lonmean,
                        int nargout_,
                        mxArray * lat,
                        mxArray * lon,
                        mxArray * geoid,
                        mxArray * units);

_mexLocalFunctionTable _local_function_table_meanm
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfNMeanm" contains the nargout interface for the "meanm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\meanm.m" (lines 1-109).
 * This interface is only produced if the M-function uses the special variable
 * "nargout". The nargout interface allows the number of requested outputs to
 * be specified via the nargout argument, as opposed to the normal interface
 * which dynamically calculates the number of outputs based on the number of
 * non-NULL inputs it receives. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
mxArray * mlfNMeanm(int nargout,
                    mxArray * * lonmean,
                    mxArray * lat,
                    mxArray * lon,
                    mxArray * geoid,
                    mxArray * units) {
    mxArray * latmean = NULL;
    mxArray * lonmean__ = NULL;
    mlfEnterNewContext(1, 4, lonmean, lat, lon, geoid, units);
    latmean = Mmeanm(&lonmean__, nargout, lat, lon, geoid, units);
    mlfRestorePreviousContext(1, 4, lonmean, lat, lon, geoid, units);
    if (lonmean != NULL) {
        mclCopyOutputArg(lonmean, lonmean__);
    } else {
        mxDestroyArray(lonmean__);
    }
    return mlfReturnValue(latmean);
}

/*
 * The function "mlfMeanm" contains the normal interface for the "meanm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\meanm.m" (lines 1-109).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfMeanm(mxArray * * lonmean,
                   mxArray * lat,
                   mxArray * lon,
                   mxArray * geoid,
                   mxArray * units) {
    int nargout = 1;
    mxArray * latmean = NULL;
    mxArray * lonmean__ = NULL;
    mlfEnterNewContext(1, 4, lonmean, lat, lon, geoid, units);
    if (lonmean != NULL) {
        ++nargout;
    }
    latmean = Mmeanm(&lonmean__, nargout, lat, lon, geoid, units);
    mlfRestorePreviousContext(1, 4, lonmean, lat, lon, geoid, units);
    if (lonmean != NULL) {
        mclCopyOutputArg(lonmean, lonmean__);
    } else {
        mxDestroyArray(lonmean__);
    }
    return mlfReturnValue(latmean);
}

/*
 * The function "mlfVMeanm" contains the void interface for the "meanm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\meanm.m" (lines 1-109).
 * The void interface is only produced if the M-function uses the special
 * variable "nargout", and has at least one output. The void interface function
 * specifies zero output arguments to the implementation version of the
 * function, and in the event that the implementation version still returns an
 * output (which, in MATLAB, would be assigned to the "ans" variable), it
 * deallocates the output. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlfVMeanm(mxArray * lat, mxArray * lon, mxArray * geoid, mxArray * units) {
    mxArray * latmean = NULL;
    mxArray * lonmean = NULL;
    mlfEnterNewContext(0, 4, lat, lon, geoid, units);
    latmean = Mmeanm(&lonmean, 0, lat, lon, geoid, units);
    mlfRestorePreviousContext(0, 4, lat, lon, geoid, units);
    mxDestroyArray(latmean);
    mxDestroyArray(lonmean);
}

/*
 * The function "mlxMeanm" contains the feval interface for the "meanm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\meanm.m" (lines 1-109).
 * The feval function calls the implementation version of meanm through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxMeanm(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[4];
    mxArray * mplhs[2];
    int i;
    if (nlhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: meanm Line: 1 Column: 1 The function \"meanm"
            "\" was called with more than the declared number of outputs (2)."),
          NULL);
    }
    if (nrhs > 4) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: meanm Line: 1 Column: 1 The function \"meanm"
            "\" was called with more than the declared number of inputs (4)."),
          NULL);
    }
    for (i = 0; i < 2; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 4 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 4; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mplhs[0] = Mmeanm(&mplhs[1], nlhs, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mlfRestorePreviousContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 2 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 2; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}

/*
 * The function "Mmeanm" is the implementation version of the "meanm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\meanm.m" (lines 1-109).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function [latmean,lonmean] = meanm(lat,lon,geoid,units)
 */
static mxArray * Mmeanm(mxArray * * lonmean,
                        int nargout_,
                        mxArray * lat,
                        mxArray * lon,
                        mxArray * geoid,
                        mxArray * units) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_meanm);
    int nargin_ = mclNargin(4, lat, lon, geoid, units, NULL);
    mxArray * latmean = NULL;
    mxArray * indx = NULL;
    mxArray * radius = NULL;
    mxArray * latbar = NULL;
    mxArray * lonbar = NULL;
    mxArray * z = NULL;
    mxArray * y = NULL;
    mxArray * x = NULL;
    mxArray * msg = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&lat);
    mclCopyArray(&lon);
    mclCopyArray(&geoid);
    mclCopyArray(&units);
    /*
     * 
     * %MEANM  Mean for geographic data
     * %
     * %  [latbar,lonbar] = MEANM(lat,lon) computes means for geographic
     * %  data.  This corresponds to the geographic centroid of a data set,
     * %  assuming that the data are distributed on a sphere.  In contrast,
     * %  MEAN assumes that the data are distributed on a cartesian plan.
     * %  When lat and lon are vectors, a single mean location is returned.
     * %  When lat and long are matrices, latmean and lonmean are row vectors
     * %  providing the mean locations for each column of lat and lon.
     * %  N-dimensional arrays are not allowed.
     * %
     * %  [latbar,lonbar] = MEANM(lat,lon,geoid) computes the geographic mean
     * %  on the ellipsoid defined by the input geoid. The geoid vector
     * %  is of the form [semimajor axes, eccentricity].  If omitted, the
     * %  unit sphere, geoid = [1 0], is assumed.
     * %
     * %  [latbar,lonbar] = MEANM(lat,lon,'units') use the input 'units'
     * %  to define the angle units of the inputs and outputs.  If
     * %  omitted, 'degrees' are assumed.
     * %
     * %  [latbar,lonbar] = MEANM(lat,lon,geoid,'units') is a valid form.
     * %
     * %  mat = MEANM(...) returns a single output, where mat = [latbar,lonbar].
     * %  This is particularly useful if the lat and lon inputs are vectors.
     * %
     * %  See also MEAN, STDM, STDIST
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown, W. Stumpf
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:25:52 $
     * 
     * 
     * if nargin < 2
     */
    if (nargin_ < 2) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif nargin == 2
     */
    } else if (nargin_ == 2) {
        /*
         * geoid = [];       units = [];
         */
        mlfAssign(&geoid, _mxarray2_);
        mlfAssign(&units, _mxarray2_);
    /*
     * elseif nargin == 3
     */
    } else if (nargin_ == 3) {
        /*
         * if isstr(geoid)
         */
        if (mlfTobool(mlfIsstr(mclVa(geoid, "geoid")))) {
            /*
             * units = geoid;     geoid = [];
             */
            mlfAssign(&units, mclVa(geoid, "geoid"));
            mlfAssign(&geoid, _mxarray2_);
        /*
         * else
         */
        } else {
            /*
             * units = [];
             */
            mlfAssign(&units, _mxarray2_);
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * 
     * %  Empty argument tests
     * 
     * if isempty(units);   units = 'degrees';   end
     */
    if (mlfTobool(mlfIsempty(mclVa(units, "units")))) {
        mlfAssign(&units, _mxarray3_);
    }
    /*
     * if isempty(geoid);   geoid = [1 0];       end
     */
    if (mlfTobool(mlfIsempty(mclVa(geoid, "geoid")))) {
        mlfAssign(&geoid, _mxarray5_);
    }
    /*
     * 
     * %  Input dimension tests
     * 
     * if ndims(lat)>2
     */
    if (mclGtBool(mlfNdims(mclVa(lat, "lat")), _mxarray7_)) {
        /*
         * error('Latitude and longitude inputs limited to two dimensions.')
         */
        mlfError(_mxarray8_, NULL);
    /*
     * end
     */
    }
    /*
     * 
     * if ~isequal(size(lat),size(lon))
     */
    if (mclNotBool(
          mlfIsequal(
            mlfSize(mclValueVarargout(), mclVa(lat, "lat"), NULL),
            mlfSize(mclValueVarargout(), mclVa(lon, "lon"), NULL), NULL))) {
        /*
         * error('Inconsistent dimensions on latitude and longitude inputs')
         */
        mlfError(_mxarray10_, NULL);
    /*
     * end
     */
    }
    /*
     * 
     * %  Test the geoid parameter
     * 
     * [geoid,msg] = geoidtst(geoid);
     */
    mlfAssign(&geoid, mlfNGeoidtst(2, &msg, mclVa(geoid, "geoid")));
    /*
     * if ~isempty(msg);   error(msg);   end
     */
    if (mclNotBool(mlfIsempty(mclVv(msg, "msg")))) {
        mlfError(mclVv(msg, "msg"), NULL);
    }
    /*
     * 
     * %  Convert inputs to radians.  Use an authalic sphere for
     * %  calculations.  Thus, the mean calculation is area-based,
     * %  since the authalic sphere has the same surface area as
     * %  the ellipsoid.
     * 
     * lat = angledim(lat,units,'radians');
     */
    mlfAssign(
      &lat, mlfAngledim(mclVa(lat, "lat"), mclVa(units, "units"), _mxarray12_));
    /*
     * lat = geod2aut(lat,geoid,'radians');
     */
    mlfAssign(
      &lat, mlfGeod2aut(mclVa(lat, "lat"), mclVa(geoid, "geoid"), _mxarray12_));
    /*
     * lon = angledim(lon,units,'radians');
     */
    mlfAssign(
      &lon, mlfAngledim(mclVa(lon, "lon"), mclVa(units, "units"), _mxarray12_));
    /*
     * 
     * %  Convert the input data to cartesian coordinates.
     * %  Compute the centroid point by vector summing all cartesian data.
     * 
     * [x,y,z]=sph2cart(lon,lat,ones(size(lat)));
     */
    mlfAssign(
      &x,
      mlfSph2cart(
        &y,
        &z,
        mclVa(lon, "lon"),
        mclVa(lat, "lat"),
        mlfOnes(mlfSize(mclValueVarargout(), mclVa(lat, "lat"), NULL), NULL)));
    /*
     * [lonbar,latbar,radius]=cart2sph(sum(x),sum(y),sum(z));
     */
    mlfAssign(
      &lonbar,
      mlfCart2sph(
        &latbar,
        &radius,
        mlfSum(mclVv(x, "x"), NULL),
        mlfSum(mclVv(y, "y"), NULL),
        mlfSum(mclVv(z, "z"), NULL)));
    /*
     * 
     * %  Transform outputs to proper units.  Set longitude in -pi to pi range
     * 
     * latbar = aut2geod(latbar,geoid,'radians');
     */
    mlfAssign(
      &latbar,
      mlfAut2geod(mclVv(latbar, "latbar"), mclVa(geoid, "geoid"), _mxarray12_));
    /*
     * latbar = angledim(latbar,'radians',units);
     */
    mlfAssign(
      &latbar,
      mlfAngledim(mclVv(latbar, "latbar"), _mxarray12_, mclVa(units, "units")));
    /*
     * 
     * lonbar = npi2pi(lonbar,'radians','exact');
     */
    mlfAssign(
      &lonbar, mlfNpi2pi(mclVv(lonbar, "lonbar"), _mxarray12_, _mxarray14_));
    /*
     * lonbar = angledim(lonbar,'radians',units);
     */
    mlfAssign(
      &lonbar,
      mlfAngledim(mclVv(lonbar, "lonbar"), _mxarray12_, mclVa(units, "units")));
    /*
     * 
     * %  Eliminate any points whose vector sum produces a point
     * %  which is near the center of the sphere or ellipsoid.  This
     * %  occurs when the data consists of only points and their
     * %  antipodes, and in this case, the centroid does not have any meaning.
     * 
     * indx = find(radius <= epsm('radians'));
     */
    mlfAssign(
      &indx,
      mlfFind(
        NULL, NULL, mclLe(mclVv(radius, "radius"), mlfEpsm(_mxarray12_))));
    /*
     * if ~isempty(indx);
     */
    if (mclNotBool(mlfIsempty(mclVv(indx, "indx")))) {
        /*
         * warning('Data in at least one column consists solely of cancelling points.')
         */
        mclPrintAns(&ans, mlfNWarning(0, NULL, _mxarray16_, NULL));
        /*
         * latbar(indx) = NaN;   lonbar(indx) = NaN;
         */
        mclArrayAssign1(&latbar, _mxarray18_, mclVv(indx, "indx"));
        mclArrayAssign1(&lonbar, _mxarray18_, mclVv(indx, "indx"));
    /*
     * end
     */
    }
    /*
     * 
     * %  Set the output arguments
     * 
     * if nargout < 2
     */
    if (nargout_ < 2) {
        /*
         * latmean = [latbar lonbar];
         */
        mlfAssign(
          &latmean,
          mlfHorzcat(mclVv(latbar, "latbar"), mclVv(lonbar, "lonbar"), NULL));
    /*
     * elseif nargout == 2
     */
    } else if (nargout_ == 2) {
        /*
         * latmean = latbar;   lonmean = lonbar;
         */
        mlfAssign(&latmean, mclVv(latbar, "latbar"));
        mlfAssign(lonmean, mclVv(lonbar, "lonbar"));
    /*
     * end
     */
    }
    mclValidateOutput(latmean, 1, nargout_, "latmean", "meanm");
    mclValidateOutput(*lonmean, 2, nargout_, "lonmean", "meanm");
    mxDestroyArray(ans);
    mxDestroyArray(msg);
    mxDestroyArray(x);
    mxDestroyArray(y);
    mxDestroyArray(z);
    mxDestroyArray(lonbar);
    mxDestroyArray(latbar);
    mxDestroyArray(radius);
    mxDestroyArray(indx);
    mxDestroyArray(units);
    mxDestroyArray(geoid);
    mxDestroyArray(lon);
    mxDestroyArray(lat);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return latmean;
    /*
     * 
     */
}
