/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:35 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "popupstr.h"
#include "libmatlbm.h"
#include "libmmfile.h"

static mxChar _array1_[6] = { 'S', 't', 'r', 'i', 'n', 'g' };
static mxArray * _mxarray0_;

static mxChar _array3_[5] = { 'V', 'a', 'l', 'u', 'e' };
static mxArray * _mxarray2_;

void InitializeModule_popupstr(void) {
    _mxarray0_ = mclInitializeString(6, _array1_);
    _mxarray2_ = mclInitializeString(5, _array3_);
}

void TerminateModule_popupstr(void) {
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mpopupstr(int nargout_, mxArray * handle);

_mexLocalFunctionTable _local_function_table_popupstr
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfPopupstr" contains the normal interface for the "popupstr"
 * M-function from file "c:\matlab6p5\toolbox\matlab\uitools\popupstr.m" (lines
 * 1-18). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfPopupstr(mxArray * handle) {
    int nargout = 1;
    mxArray * str = NULL;
    mlfEnterNewContext(0, 1, handle);
    str = Mpopupstr(nargout, handle);
    mlfRestorePreviousContext(0, 1, handle);
    return mlfReturnValue(str);
}

/*
 * The function "mlxPopupstr" contains the feval interface for the "popupstr"
 * M-function from file "c:\matlab6p5\toolbox\matlab\uitools\popupstr.m" (lines
 * 1-18). The feval function calls the implementation version of popupstr
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxPopupstr(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: popupstr Line: 1 Column:"
            " 1 The function \"popupstr\" was called with m"
            "ore than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: popupstr Line: 1 Column:"
            " 1 The function \"popupstr\" was called with m"
            "ore than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mpopupstr(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mpopupstr" is the implementation version of the "popupstr"
 * M-function from file "c:\matlab6p5\toolbox\matlab\uitools\popupstr.m" (lines
 * 1-18). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function str = popupstr(handle)
 */
static mxArray * Mpopupstr(int nargout_, mxArray * handle) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_popupstr);
    mxArray * str = NULL;
    mxArray * selection = NULL;
    mxArray * pick_list = NULL;
    mclCopyArray(&handle);
    /*
     * %POPUPSTR Get popup menu selection string.
     * %  STR = POPUPSTR(H) returns the currently selected string
     * %  for the popup menu uicontrol whose handle is H.
     * 
     * %  Steven L. Eddins, April 1994
     * %  Copyright 1984-2002 The MathWorks, Inc.
     * %  $Revision: 1.11 $  $Date: 2002/04/09 01:36:09 $
     * 
     * pick_list = get(handle, 'String');
     */
    mlfAssign(
      &pick_list, mlfNGet(1, mclVa(handle, "handle"), _mxarray0_, NULL));
    /*
     * selection = get(handle, 'Value');
     */
    mlfAssign(
      &selection, mlfNGet(1, mclVa(handle, "handle"), _mxarray2_, NULL));
    /*
     * if (iscell(pick_list))
     */
    if (mlfTobool(mlfIscell(mclVv(pick_list, "pick_list")))) {
        /*
         * str = pick_list{selection};
         */
        mlfAssign(
          &str,
          mlfIndexRef(
            mclVv(pick_list, "pick_list"),
            "{?}",
            mclVv(selection, "selection")));
    /*
     * else
     */
    } else {
        /*
         * str = deblank(pick_list(selection,:));
         */
        mlfAssign(
          &str,
          mlfDeblank(
            mclArrayRef2(
              mclVv(pick_list, "pick_list"),
              mclVv(selection, "selection"),
              mlfCreateColonIndex())));
    /*
     * end
     */
    }
    mclValidateOutput(str, 1, nargout_, "str", "popupstr");
    mxDestroyArray(pick_list);
    mxDestroyArray(selection);
    mxDestroyArray(handle);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return str;
    /*
     * 
     */
}
