/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:30 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "rad2dms.h"
#include "deg2dms.h"
#include "libmatlbm.h"
#include "rad2deg.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

void InitializeModule_rad2dms(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
}

void TerminateModule_rad2dms(void) {
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mrad2dms(int nargout_, mxArray * rad);

_mexLocalFunctionTable _local_function_table_rad2dms
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfRad2dms" contains the normal interface for the "rad2dms"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rad2dms.m" (lines 1-20).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfRad2dms(mxArray * rad) {
    int nargout = 1;
    mxArray * dms = NULL;
    mlfEnterNewContext(0, 1, rad);
    dms = Mrad2dms(nargout, rad);
    mlfRestorePreviousContext(0, 1, rad);
    return mlfReturnValue(dms);
}

/*
 * The function "mlxRad2dms" contains the feval interface for the "rad2dms"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rad2dms.m" (lines 1-20).
 * The feval function calls the implementation version of rad2dms through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxRad2dms(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: rad2dms Line: 1 Column: "
            "1 The function \"rad2dms\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: rad2dms Line: 1 Column:"
            " 1 The function \"rad2dms\" was called with m"
            "ore than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mrad2dms(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mrad2dms" is the implementation version of the "rad2dms"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rad2dms.m" (lines 1-20).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function dms=rad2dms(rad)
 */
static mxArray * Mrad2dms(int nargout_, mxArray * rad) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_rad2dms);
    int nargin_ = mclNargin(1, rad, NULL);
    mxArray * dms = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&rad);
    /*
     * 
     * %RAD2DMS Converts angles from radians to deg:min:sec vector format
     * %
     * %  dms = RAD2DMS(rad) converts angles from radians to deg:min:sec vector
     * %  format.
     * %
     * %  See also DMS2RAD, RAD2DEG, MAT2DMS, DMS2MAT, ANGLEDIM, ANGL2STR
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:26:13 $
     * 
     * if nargin==0;  error('Incorrect number of arguments');   end
     */
    if (nargin_ == 0) {
        mlfError(_mxarray0_, NULL);
    }
    /*
     * 
     * %  Compute the angle in dms by first transforming from rad to deg.
     * 
     * dms = deg2dms(rad2deg(rad));
     */
    mlfAssign(&dms, mlfDeg2dms(mlfRad2deg(mclVa(rad, "rad"))));
    mclValidateOutput(dms, 1, nargout_, "dms", "rad2dms");
    mxDestroyArray(ans);
    mxDestroyArray(rad);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return dms;
    /*
     * 
     */
}
