/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:34 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "rad2km.h"
#include "almanac.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

static mxChar _array3_[5] = { 'e', 'a', 'r', 't', 'h' };
static mxArray * _mxarray2_;

static mxChar _array5_[6] = { 'r', 'a', 'd', 'i', 'u', 's' };
static mxArray * _mxarray4_;

static mxChar _array7_[2] = { 'k', 'm' };
static mxArray * _mxarray6_;
static mxArray * _mxarray8_;

static mxChar _array10_[22] = { 'S', 'c', 'a', 'l', 'a', 'r', ' ', 'r',
                                'a', 'd', 'i', 'u', 's', ' ', 'r', 'e',
                                'q', 'u', 'i', 'r', 'e', 'd' };
static mxArray * _mxarray9_;

static mxChar _array12_[67] = { 'I', 'm', 'a', 'g', 'i', 'n', 'a', 'r', 'y',
                                ' ', 'p', 'a', 'r', 't', 's', ' ', 'o', 'f',
                                ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ' ',
                                'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', ' ',
                                'a', 'n', 'd', '/', 'o', 'r', ' ', 'R', 'A',
                                'D', 'I', 'U', 'S', ' ', 'a', 'r', 'g', 'u',
                                'm', 'e', 'n', 't', 's', ' ', 'i', 'g', 'n',
                                'o', 'r', 'e', 'd' };
static mxArray * _mxarray11_;

void InitializeModule_rad2km(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeString(5, _array3_);
    _mxarray4_ = mclInitializeString(6, _array5_);
    _mxarray6_ = mclInitializeString(2, _array7_);
    _mxarray8_ = mclInitializeDouble(1.0);
    _mxarray9_ = mclInitializeString(22, _array10_);
    _mxarray11_ = mclInitializeString(67, _array12_);
}

void TerminateModule_rad2km(void) {
    mxDestroyArray(_mxarray11_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray8_);
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mrad2km(int nargout_, mxArray * rad, mxArray * radius);

_mexLocalFunctionTable _local_function_table_rad2km
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfRad2km" contains the normal interface for the "rad2km"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rad2km.m" (lines 1-36).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfRad2km(mxArray * rad, mxArray * radius) {
    int nargout = 1;
    mxArray * km = NULL;
    mlfEnterNewContext(0, 2, rad, radius);
    km = Mrad2km(nargout, rad, radius);
    mlfRestorePreviousContext(0, 2, rad, radius);
    return mlfReturnValue(km);
}

/*
 * The function "mlxRad2km" contains the feval interface for the "rad2km"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rad2km.m" (lines 1-36).
 * The feval function calls the implementation version of rad2km through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxRad2km(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: rad2km Line: 1 Column: "
            "1 The function \"rad2km\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: rad2km Line: 1 Column: "
            "1 The function \"rad2km\" was called with mor"
            "e than the declared number of inputs (2)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mrad2km(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mrad2km" is the implementation version of the "rad2km"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rad2km.m" (lines 1-36).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function km = rad2km(rad,radius)
 */
static mxArray * Mrad2km(int nargout_, mxArray * rad, mxArray * radius) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_rad2km);
    int nargin_ = mclNargin(2, rad, radius, NULL);
    mxArray * km = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&rad);
    mclCopyArray(&radius);
    /*
     * 
     * %RAD2KM Converts distances from radians to kilometers
     * %
     * %  km = RAD2KM(rad) converts distances from radians to kilometers.
     * %  A radian of distance is measured along a great circle of a sphere.
     * %
     * %  km = RAD2KM(rad,radius) uses the second input to determine the
     * %  radius of the sphere.  If radius is a string, then it is evaluated
     * %  as an ALMANAC body to determine the spherical radius.  If numerical,
     * %  it is the radius of the desired sphere in kilometers.  If omitted,
     * %  the default radius of the Earth is used.
     * %
     * %  See also KM2RAD, RAD2DEG, RAD2NM, RAD2SM, DISTDIM
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Brown, E. Byrns
     * %   $Revision: 1.10 $    $Date: 2002/03/20 21:26:13 $
     * 
     * if nargin==0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif nargin == 1
     */
    } else if (nargin_ == 1) {
        /*
         * radius = almanac('earth','radius','km');
         */
        mlfAssign(
          &radius, mlfAlmanac(_mxarray2_, _mxarray4_, _mxarray6_, NULL));
    /*
     * elseif nargin == 2 & isstr(radius)
     */
    } else {
        mxArray * a_ = mclInitialize(mclBoolToArray(nargin_ == 2));
        if (mlfTobool(a_)
            && mlfTobool(mclAnd(a_, mlfIsstr(mclVa(radius, "radius"))))) {
            mxDestroyArray(a_);
            /*
             * radius = almanac(radius,'radius','km');
             */
            mlfAssign(
              &radius,
              mlfAlmanac(
                mclVa(radius, "radius"), _mxarray4_, _mxarray6_, NULL));
        } else {
            mxDestroyArray(a_);
        }
    /*
     * end
     */
    }
    /*
     * 
     * if max(size(radius)) ~= 1
     */
    if (mclNeBool(
          mlfMax(
            NULL,
            mlfSize(mclValueVarargout(), mclVa(radius, "radius"), NULL),
            NULL,
            NULL),
          _mxarray8_)) {
        /*
         * error('Scalar radius required')
         */
        mlfError(_mxarray9_, NULL);
    /*
     * elseif any([~isreal(rad) ~isreal(radius)])
     */
    } else if (mlfTobool(
                 mlfAny(
                   mlfHorzcat(
                     mclNot(mlfIsreal(mclVa(rad, "rad"))),
                     mclNot(mlfIsreal(mclVa(radius, "radius"))),
                     NULL),
                   NULL))) {
        /*
         * warning('Imaginary parts of complex DISTANCE and/or RADIUS arguments ignored')
         */
        mclPrintAns(&ans, mlfNWarning(0, NULL, _mxarray11_, NULL));
        /*
         * rad = real(rad);   radius = real(radius);
         */
        mlfAssign(&rad, mlfReal(mclVa(rad, "rad")));
        mlfAssign(&radius, mlfReal(mclVa(radius, "radius")));
    /*
     * end
     */
    }
    /*
     * 
     * km = radius*rad;
     */
    mlfAssign(&km, mclMtimes(mclVa(radius, "radius"), mclVa(rad, "rad")));
    mclValidateOutput(km, 1, nargout_, "km", "rad2km");
    mxDestroyArray(ans);
    mxDestroyArray(radius);
    mxDestroyArray(rad);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return km;
}
