/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:36 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "rcurve.h"
#include "angledim.h"
#include "geoidtst.h"
#include "libmatlbm.h"
#include "libmmfile.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;

static mxChar _array4_[8] = { 'p', 'a', 'r', 'a', 'l', 'l', 'e', 'l' };
static mxArray * _mxarray3_;

static mxChar _array6_[8] = { 'm', 'e', 'r', 'i', 'd', 'i', 'a', 'n' };
static mxArray * _mxarray5_;

static mxChar _array8_[10] = { 't', 'r', 'a', 'n', 's',
                               'v', 'e', 'r', 's', 'e' };
static mxArray * _mxarray7_;

static mxChar _array10_[25] = { 'U', 'n', 'r', 'e', 'c', 'o', 'g', 'n', 'i',
                                'z', 'e', 'd', ' ', 'c', 'u', 'r', 'v', 'e',
                                ' ', 's', 't', 'r', 'i', 'n', 'g' };
static mxArray * _mxarray9_;

static mxChar _array12_[7] = { 'd', 'e', 'g', 'r', 'e', 'e', 's' };
static mxArray * _mxarray11_;
static mxArray * _mxarray13_;

static mxChar _array15_[32] = { 'L', 'a', 't', 'i', 't', 'u', 'd', 'e',
                                ' ', 'l', 'i', 'm', 'i', 't', 'e', 'd',
                                ' ', 't', 'o', ' ', '2', ' ', 'd', 'i',
                                'm', 'e', 'n', 's', 'i', 'o', 'n', 's' };
static mxArray * _mxarray14_;

static mxChar _array17_[7] = { 'r', 'a', 'd', 'i', 'a', 'n', 's' };
static mxArray * _mxarray16_;
static mxArray * _mxarray18_;
static mxArray * _mxarray19_;

void InitializeModule_rcurve(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray3_ = mclInitializeString(8, _array4_);
    _mxarray5_ = mclInitializeString(8, _array6_);
    _mxarray7_ = mclInitializeString(10, _array8_);
    _mxarray9_ = mclInitializeString(25, _array10_);
    _mxarray11_ = mclInitializeString(7, _array12_);
    _mxarray13_ = mclInitializeDouble(2.0);
    _mxarray14_ = mclInitializeString(32, _array15_);
    _mxarray16_ = mclInitializeString(7, _array17_);
    _mxarray18_ = mclInitializeDouble(1.0);
    _mxarray19_ = mclInitializeDouble(3.0);
}

void TerminateModule_rcurve(void) {
    mxDestroyArray(_mxarray19_);
    mxDestroyArray(_mxarray18_);
    mxDestroyArray(_mxarray16_);
    mxDestroyArray(_mxarray14_);
    mxDestroyArray(_mxarray13_);
    mxDestroyArray(_mxarray11_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mrcurve(int nargout_,
                         mxArray * str,
                         mxArray * geoid,
                         mxArray * lat,
                         mxArray * units);

_mexLocalFunctionTable _local_function_table_rcurve
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfRcurve" contains the normal interface for the "rcurve"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rcurve.m" (lines 1-110).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfRcurve(mxArray * str,
                    mxArray * geoid,
                    mxArray * lat,
                    mxArray * units) {
    int nargout = 1;
    mxArray * r = NULL;
    mlfEnterNewContext(0, 4, str, geoid, lat, units);
    r = Mrcurve(nargout, str, geoid, lat, units);
    mlfRestorePreviousContext(0, 4, str, geoid, lat, units);
    return mlfReturnValue(r);
}

/*
 * The function "mlxRcurve" contains the feval interface for the "rcurve"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rcurve.m" (lines 1-110).
 * The feval function calls the implementation version of rcurve through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxRcurve(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[4];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: rcurve Line: 1 Column: "
            "1 The function \"rcurve\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 4) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: rcurve Line: 1 Column: "
            "1 The function \"rcurve\" was called with mor"
            "e than the declared number of inputs (4)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 4 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 4; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mplhs[0] = Mrcurve(nlhs, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mlfRestorePreviousContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mrcurve" is the implementation version of the "rcurve"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rcurve.m" (lines 1-110).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function r = rcurve(str,geoid,lat,units)
 */
static mxArray * Mrcurve(int nargout_,
                         mxArray * str,
                         mxArray * geoid,
                         mxArray * lat,
                         mxArray * units) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_rcurve);
    int nargin_ = mclNargin(4, str, geoid, lat, units, NULL);
    mxArray * r = NULL;
    mxArray * rho = NULL;
    mxArray * den = NULL;
    mxArray * num = NULL;
    mxArray * eccent = NULL;
    mxArray * semimajor = NULL;
    mxArray * msg = NULL;
    mxArray * indx = NULL;
    mxArray * strmat = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&str);
    mclCopyArray(&geoid);
    mclCopyArray(&lat);
    mclCopyArray(&units);
    /*
     * 
     * %RCURVE  Computes various radii of curvature for an ellipsoid
     * %
     * %  r = RCURVE(geoid,lat) computes the parallel radius of curvature
     * %  for an ellipsoid.  The parallel radius of curvature is the radius
     * %  of the small circle encompassing the globe at the specified latitude.
     * %  The input geoid is a standard 2 element geoid vector.  The returned
     * %  radius r is in the units of the first element of a standard geoid vector.
     * %
     * %  r = RCURVE(geoid,lat,'units')  defines the 'units' of the input
     * %  latitude data.  If omitted, 'degrees' are assumed.
     * %
     * %  r = RCURVE('parallel',...) also computes the parallel radius of
     * %  curvature for the ellipsoid.
     * %
     * %  r = RCURVE('meridian',...) computes the meridianal radius of
     * %  curvature for the ellipsoid.  The meridianal radius is the
     * %  radius of curvature at the specified latitude for the ellipse
     * %  defined a meridian.
     * %
     * %  r = RCURVE('transverse',...) computes the transverse radius of
     * %  curvature for the ellipsoid.  The transverse radius is the radius
     * %  of the curve formed by a plane intersecting the ellipsoid at the
     * %  latitude which is normal to the surface of the ellipsoid.
     * %
     * %  See also:  RSPHERE
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.13 $    $Date: 2002/03/20 21:26:15 $
     * 
     * %  Reference: D. H. Maling, Coordinate Systems and Map Projections, 2nd Edition
     * %  Pergamon Press, 1992, p. 69.
     * 
     * if nargin < 2 | (nargin == 2 & isstr(str))
     */
    {
        mxArray * a_ = mclInitialize(mclBoolToArray(nargin_ < 2));
        if (mlfTobool(a_)) {
        } else {
            mxArray * b_ = mclInitialize(mclBoolToArray(nargin_ == 2));
            if (mlfTobool(b_)) {
                mlfAssign(&b_, mclAnd(b_, mlfIsstr(mclVa(str, "str"))));
            } else {
                mlfAssign(&b_, mlfScalar(0));
            }
            {
                mxLogical c_0 = mlfTobool(mclOr(a_, b_));
                mxDestroyArray(b_);
                if (c_0) {
                } else {
                    goto l0_;
                }
            }
        }
        mxDestroyArray(a_);
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
        goto done_;
        l0_:
        mxDestroyArray(a_);
        /*
         * 
         * elseif (nargin == 2 & ~isstr(str)) | (nargin == 3 & isstr(str))
         */
        {
            mxArray * a_0 = mclInitialize(mclBoolToArray(nargin_ == 2));
            if (mlfTobool(a_0)) {
                mlfAssign(
                  &a_0, mclAnd(a_0, mclNot(mlfIsstr(mclVa(str, "str")))));
            } else {
                mlfAssign(&a_0, mlfScalar(0));
            }
            if (mlfTobool(a_0)) {
            } else {
                mxArray * b_ = mclInitialize(mclBoolToArray(nargin_ == 3));
                if (mlfTobool(b_)) {
                    mlfAssign(&b_, mclAnd(b_, mlfIsstr(mclVa(str, "str"))));
                } else {
                    mlfAssign(&b_, mlfScalar(0));
                }
                {
                    mxLogical c_0 = mlfTobool(mclOr(a_0, b_));
                    mxDestroyArray(b_);
                    if (c_0) {
                    } else {
                        goto l0_0;
                    }
                }
            }
            mxDestroyArray(a_0);
            /*
             * if ~isstr(str)       %  Shift inputs since str omitted by user
             */
            if (mclNotBool(mlfIsstr(mclVa(str, "str")))) {
                /*
                 * lat = geoid;     geoid = str;     str = [];
                 */
                mlfAssign(&lat, mclVa(geoid, "geoid"));
                mlfAssign(&geoid, mclVa(str, "str"));
                mlfAssign(&str, _mxarray2_);
            /*
             * end
             */
            }
            /*
             * 
             * units = [];
             */
            mlfAssign(&units, _mxarray2_);
            goto done_0;
            l0_0:
            mxDestroyArray(a_0);
            /*
             * 
             * elseif nargin == 3 & ~isstr(str)
             */
            {
                mxArray * a_1 = mclInitialize(mclBoolToArray(nargin_ == 3));
                if (mlfTobool(a_1)
                    && mlfTobool(
                         mclAnd(a_1, mclNot(mlfIsstr(mclVa(str, "str")))))) {
                    mxDestroyArray(a_1);
                    /*
                     * 
                     * %  Shift inputs since str omitted by user
                     * units = lat;   lat = geoid;     geoid = str;     str = [];
                     */
                    mlfAssign(&units, mclVa(lat, "lat"));
                    mlfAssign(&lat, mclVa(geoid, "geoid"));
                    mlfAssign(&geoid, mclVa(str, "str"));
                    mlfAssign(&str, _mxarray2_);
                } else {
                    mxDestroyArray(a_1);
                }
            }
            done_0:;
        }
        /*
         * end
         */
        done_:;
    }
    /*
     * 
     * 
     * %  Empty argument tests
     * 
     * if isempty(str)
     */
    if (mlfTobool(mlfIsempty(mclVa(str, "str")))) {
        /*
         * str   = 'parallel';
         */
        mlfAssign(&str, _mxarray3_);
    /*
     * else
     */
    } else {
        /*
         * strmat = strvcat('parallel','meridian','transverse');
         */
        mlfAssign(
          &strmat, mlfStrvcat(_mxarray3_, _mxarray5_, _mxarray7_, NULL));
        /*
         * indx = strmatch(lower(str),strmat);
         */
        mlfAssign(
          &indx,
          mlfStrmatch(
            mlfLower(mclVa(str, "str")), mclVv(strmat, "strmat"), NULL));
        /*
         * if length(indx) == 1
         */
        if (mclLengthInt(mclVv(indx, "indx")) == 1) {
            /*
             * str = deblank(strmat(indx,:));
             */
            mlfAssign(
              &str,
              mlfDeblank(
                mclArrayRef2(
                  mclVv(strmat, "strmat"),
                  mclVv(indx, "indx"),
                  mlfCreateColonIndex())));
        /*
         * else
         */
        } else {
            /*
             * error('Unrecognized curve string')
             */
            mlfError(_mxarray9_, NULL);
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * 
     * 
     * 
     * %  Input tests
     * 
     * if isempty(units);    units = 'degrees';    end
     */
    if (mlfTobool(mlfIsempty(mclVa(units, "units")))) {
        mlfAssign(&units, _mxarray11_);
    }
    /*
     * [geoid,msg] = geoidtst(geoid);
     */
    mlfAssign(&geoid, mlfNGeoidtst(2, &msg, mclVa(geoid, "geoid")));
    /*
     * if ~isempty(msg);   error(msg);   end
     */
    if (mclNotBool(mlfIsempty(mclVv(msg, "msg")))) {
        mlfError(mclVv(msg, "msg"), NULL);
    }
    /*
     * 
     * if  ndims(lat) > 2
     */
    if (mclGtBool(mlfNdims(mclVa(lat, "lat")), _mxarray13_)) {
        /*
         * error('Latitude limited to 2 dimensions')
         */
        mlfError(_mxarray14_, NULL);
    /*
     * end
     */
    }
    /*
     * 
     * %  Get the semimajor axis and eccentricity
     * 
     * semimajor = geoid(1);
     */
    mlfAssign(&semimajor, mclIntArrayRef1(mclVa(geoid, "geoid"), 1));
    /*
     * eccent    = geoid(2);
     */
    mlfAssign(&eccent, mclIntArrayRef1(mclVa(geoid, "geoid"), 2));
    /*
     * 
     * %  Transform the latitude into radians
     * 
     * lat = angledim(lat,units,'radians');
     */
    mlfAssign(
      &lat, mlfAngledim(mclVa(lat, "lat"), mclVa(units, "units"), _mxarray16_));
    /*
     * 
     * 
     * switch str
     */
    {
        mxArray * v_ = mclInitialize(mclVa(str, "str"));
        if (mclSwitchCompare(v_, _mxarray3_)) {
            /*
             * case 'parallel'                  %  Parallel radius of curvature
             * 
             * num = 1-eccent^2;                        %  Compute the distance from
             */
            mlfAssign(
              &num,
              mclMinus(
                _mxarray18_, mclMpower(mclVv(eccent, "eccent"), _mxarray13_)));
            /*
             * den = 1 - (eccent * cos(lat)).^2;        %  the center of the geoid to
             */
            mlfAssign(
              &den,
              mclMinus(
                _mxarray18_,
                mlfPower(
                  mclMtimes(mclVv(eccent, "eccent"), mlfCos(mclVa(lat, "lat"))),
                  _mxarray13_)));
            /*
             * rho = semimajor * sqrt(num ./ den);      %  the specified point
             */
            mlfAssign(
              &rho,
              mclMtimes(
                mclVv(semimajor, "semimajor"),
                mlfSqrt(mclRdivide(mclVv(num, "num"), mclVv(den, "den")))));
            /*
             * 
             * r = rho .* cos(lat);
             */
            mlfAssign(
              &r, mclTimes(mclVv(rho, "rho"), mlfCos(mclVa(lat, "lat"))));
        /*
         * 
         * case 'meridian'                    %  Meridional radius of curvature
         */
        } else if (mclSwitchCompare(v_, _mxarray5_)) {
            /*
             * 
             * num = semimajor * (1-eccent^2);
             */
            mlfAssign(
              &num,
              mclMtimes(
                mclVv(semimajor, "semimajor"),
                mclMinus(
                  _mxarray18_,
                  mclMpower(mclVv(eccent, "eccent"), _mxarray13_))));
            /*
             * den = 1 - (eccent * sin(lat)).^2;
             */
            mlfAssign(
              &den,
              mclMinus(
                _mxarray18_,
                mlfPower(
                  mclMtimes(mclVv(eccent, "eccent"), mlfSin(mclVa(lat, "lat"))),
                  _mxarray13_)));
            /*
             * r   = num ./ sqrt(den.^3);
             */
            mlfAssign(
              &r,
              mclRdivide(
                mclVv(num, "num"),
                mlfSqrt(mlfPower(mclVv(den, "den"), _mxarray19_))));
        /*
         * 
         * case 'transverse'                  %  Transverse radius of curvature
         */
        } else if (mclSwitchCompare(v_, _mxarray7_)) {
            /*
             * 
             * den = 1 - (eccent * sin(lat)).^2;
             */
            mlfAssign(
              &den,
              mclMinus(
                _mxarray18_,
                mlfPower(
                  mclMtimes(mclVv(eccent, "eccent"), mlfSin(mclVa(lat, "lat"))),
                  _mxarray13_)));
            /*
             * r   = semimajor ./ sqrt(den);
             */
            mlfAssign(
              &r,
              mclRdivide(
                mclVv(semimajor, "semimajor"), mlfSqrt(mclVv(den, "den"))));
        /*
         * 
         * end
         */
        }
        mxDestroyArray(v_);
    }
    mclValidateOutput(r, 1, nargout_, "r", "rcurve");
    mxDestroyArray(ans);
    mxDestroyArray(strmat);
    mxDestroyArray(indx);
    mxDestroyArray(msg);
    mxDestroyArray(semimajor);
    mxDestroyArray(eccent);
    mxDestroyArray(num);
    mxDestroyArray(den);
    mxDestroyArray(rho);
    mxDestroyArray(units);
    mxDestroyArray(lat);
    mxDestroyArray(geoid);
    mxDestroyArray(str);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return r;
}
