/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:31 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "setfaces.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;
static mxArray * _mxarray3_;
static double _ieee_nan_;
static mxArray * _mxarray4_;

void InitializeModule_setfaces(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDouble(1.0);
    _mxarray3_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _ieee_nan_ = mclGetNaN();
    _mxarray4_ = mclInitializeDouble(_ieee_nan_);
}

void TerminateModule_setfaces(void) {
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Msetfaces(int nargout_, mxArray * x, mxArray * y);

_mexLocalFunctionTable _local_function_table_setfaces
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfSetfaces" contains the normal interface for the "setfaces"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\setfaces.m" (lines
 * 1-67). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfSetfaces(mxArray * x, mxArray * y) {
    int nargout = 1;
    mxArray * faces = NULL;
    mlfEnterNewContext(0, 2, x, y);
    faces = Msetfaces(nargout, x, y);
    mlfRestorePreviousContext(0, 2, x, y);
    return mlfReturnValue(faces);
}

/*
 * The function "mlxSetfaces" contains the feval interface for the "setfaces"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\setfaces.m" (lines
 * 1-67). The feval function calls the implementation version of setfaces
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxSetfaces(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: setfaces Line: 1 Column:"
            " 1 The function \"setfaces\" was called with m"
            "ore than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: setfaces Line: 1 Column:"
            " 1 The function \"setfaces\" was called with m"
            "ore than the declared number of inputs (2)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Msetfaces(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Msetfaces" is the implementation version of the "setfaces"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\setfaces.m" (lines
 * 1-67). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function faces = setfaces(x,y)
 */
static mxArray * Msetfaces(int nargout_, mxArray * x, mxArray * y) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_setfaces);
    int nargin_ = mclNargin(2, x, y, NULL);
    mxArray * faces = NULL;
    mxArray * indices = NULL;
    mxArray * endloc = NULL;
    mxArray * startloc = NULL;
    mxArray * i = NULL;
    mxArray * indx = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&x);
    mclCopyArray(&y);
    /*
     * 
     * %SETFACES  Construct the face matrix for a patch, given vertex data
     * %
     * %  faces = SETFACES(x,y) will construct the face matrix for a patch,
     * %  given input vertex data.  The input vertex data are two column
     * %  vectors, with NaNs separating multiple faces of the patch.  If no
     * %  NaNs are found, then the face of the patch is defined by all
     * %  the vertices in the input vector data.  The face matrix and
     * %  vertex vectors are used to set the Face and Vertices properties
     * %  of the patch in PATCHM, PATCHESM and SETM.
     * %
     * %  See also PATCHM, PATCHESM, SETM
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.10 $    $Date: 2002/03/20 21:28:12 $
     * 
     * 
     * %  Argument input tests
     * 
     * if nargin ~= 2;  error('Incorrect number of arguments');   end
     */
    if (nargin_ != 2) {
        mlfError(_mxarray0_, NULL);
    }
    /*
     * 
     * 
     * if all(isnan(x) | isnan(y))     %  If all vertices are NaNs, the
     */
    if (mlfTobool(
          mlfAll(
            mclOr(mlfIsnan(mclVa(x, "x")), mlfIsnan(mclVa(y, "y"))), NULL))) {
        /*
         * faces = 1:length(x);        %  patch has been trimmed and will
         */
        mlfAssign(
          &faces,
          mlfColon(_mxarray2_, mlfScalar(mclLengthInt(mclVa(x, "x"))), NULL));
        /*
         * return                      %  not be displayed
         */
        goto return_;
    /*
     * end
     */
    }
    /*
     * 
     * %  Ensure that the input data is in column format.
     * 
     * x = x(:);   y = y(:);
     */
    mlfAssign(&x, mclArrayRef1(mclVa(x, "x"), mlfCreateColonIndex()));
    mlfAssign(&y, mclArrayRef1(mclVa(y, "y"), mlfCreateColonIndex()));
    /*
     * 
     * %  Find the individual faces to this patch (Separated by NaNs)
     * %  Then construct the face matrix.  The face matrix is pre-allocated
     * %  to the maximum size possible.  In trimmed data sets, some NaNs
     * %  will be neighboring each other (sequential entries in the vector
     * %  data) and these NaNs will not produce faces.  These rows of
     * %  the face matrix will need to be eliminated after construction.
     * %  (This approach was easier than trying to pre-compute the location
     * %  of the neighboring NaNs and then keeping all the subsequent
     * %  bookkeeping straight.  EVB).
     * 
     * indx = find(isnan(x) | isnan(y));
     */
    mlfAssign(
      &indx,
      mlfFind(
        NULL, NULL, mclOr(mlfIsnan(mclVa(x, "x")), mlfIsnan(mclVa(y, "y")))));
    /*
     * 
     * 
     * if isempty(indx)
     */
    if (mlfTobool(mlfIsempty(mclVv(indx, "indx")))) {
        /*
         * faces = 1:length(x);    %  All one face
         */
        mlfAssign(
          &faces,
          mlfColon(_mxarray2_, mlfScalar(mclLengthInt(mclVa(x, "x"))), NULL));
    /*
     * else
     */
    } else {
        /*
         * faces = zeros(length(indx),max([diff(indx,[],1)-1;indx(1)]) ); % Preallocate memory
         */
        mlfAssign(
          &faces,
          mlfZeros(
            mlfScalar(mclLengthInt(mclVv(indx, "indx"))),
            mlfMax(
              NULL,
              mlfVertcat(
                mclMinus(
                  mlfDiff(mclVv(indx, "indx"), _mxarray3_, _mxarray2_),
                  _mxarray2_),
                mclIntArrayRef1(mclVv(indx, "indx"), 1),
                NULL),
              NULL,
              NULL),
            NULL));
        /*
         * faces(:) = NaN;       %  Make the whole matrix NaNs
         */
        mclArrayAssign1(&faces, _mxarray4_, mlfCreateColonIndex());
        /*
         * for i = 1:length(indx)
         */
        {
            int v_ = mclForIntStart(1);
            int e_ = mclLengthInt(mclVv(indx, "indx"));
            if (v_ > e_) {
                mlfAssign(&i, _mxarray3_);
            } else {
                /*
                 * if i == 1;      startloc = 1;
                 * else;      startloc = indx(i-1)+1;
                 * end
                 * endloc   = indx(i)-1;
                 * 
                 * indices = startloc:endloc;   %  Indices will be empty if NaNs are
                 * %  neighboring in the vector data.
                 * 
                 * if ~isempty(indices)         %  Neighboring NaNs happen in trimmed data sets
                 * faces(i,1:length(indices) ) = indices;
                 * end
                 * end
                 */
                for (; ; ) {
                    if (mclEqBool(mlfScalar(v_), _mxarray2_)) {
                        mlfAssign(&startloc, _mxarray2_);
                    } else {
                        mlfAssign(
                          &startloc,
                          mclPlus(
                            mclIntArrayRef1(mclVv(indx, "indx"), v_ - 1),
                            _mxarray2_));
                    }
                    mlfAssign(
                      &endloc,
                      mclMinus(
                        mclIntArrayRef1(mclVv(indx, "indx"), v_), _mxarray2_));
                    mlfAssign(
                      &indices,
                      mlfColon(
                        mclVv(startloc, "startloc"),
                        mclVv(endloc, "endloc"),
                        NULL));
                    if (mclNotBool(mlfIsempty(mclVv(indices, "indices")))) {
                        mclArrayAssign2(
                          &faces,
                          mclVv(indices, "indices"),
                          mlfScalar(v_),
                          mlfColon(
                            _mxarray2_,
                            mlfScalar(mclLengthInt(mclVv(indices, "indices"))),
                            NULL));
                    }
                    if (v_ == e_) {
                        break;
                    }
                    ++v_;
                }
                mlfAssign(&i, mlfScalar(v_));
            }
        }
    /*
     * end
     */
    }
    /*
     * 
     */
    return_:
    mclValidateOutput(faces, 1, nargout_, "faces", "setfaces");
    mxDestroyArray(ans);
    mxDestroyArray(indx);
    mxDestroyArray(i);
    mxDestroyArray(startloc);
    mxDestroyArray(endloc);
    mxDestroyArray(indices);
    mxDestroyArray(y);
    mxDestroyArray(x);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return faces;
}
