/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:30 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "shiftwin.h"
#include "libmatlbm.h"
static mxArray * _mxarray0_;

static mxChar _array2_[5] = { 'u', 'n', 'i', 't', 's' };
static mxArray * _mxarray1_;

static mxChar _array4_[6] = { 'p', 'i', 'x', 'e', 'l', 's' };
static mxArray * _mxarray3_;

static mxChar _array6_[10] = { 's', 'c', 'r', 'e', 'e',
                               'n', 's', 'i', 'z', 'e' };
static mxArray * _mxarray5_;

static mxChar _array8_[8] = { 'p', 'o', 's', 'i', 't', 'i', 'o', 'n' };
static mxArray * _mxarray7_;
static mxArray * _mxarray9_;

void InitializeModule_shiftwin(void) {
    _mxarray0_ = mclInitializeDouble(0.0);
    _mxarray1_ = mclInitializeString(5, _array2_);
    _mxarray3_ = mclInitializeString(6, _array4_);
    _mxarray5_ = mclInitializeString(10, _array6_);
    _mxarray7_ = mclInitializeString(8, _array8_);
    _mxarray9_ = mclInitializeDouble(50.0);
}

void TerminateModule_shiftwin(void) {
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static void Mshiftwin(mxArray * h);

_mexLocalFunctionTable _local_function_table_shiftwin
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfShiftwin" contains the normal interface for the "shiftwin"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\shiftwin.m" (lines
 * 1-59). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlfShiftwin(mxArray * h) {
    mlfEnterNewContext(0, 1, h);
    Mshiftwin(h);
    mlfRestorePreviousContext(0, 1, h);
}

/*
 * The function "mlxShiftwin" contains the feval interface for the "shiftwin"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\shiftwin.m" (lines
 * 1-59). The feval function calls the implementation version of shiftwin
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxShiftwin(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    int i;
    if (nlhs > 0) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: shiftwin Line: 1 Column:"
            " 1 The function \"shiftwin\" was called with m"
            "ore than the declared number of outputs (0)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: shiftwin Line: 1 Column:"
            " 1 The function \"shiftwin\" was called with m"
            "ore than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    Mshiftwin(mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
}

/*
 * The function "Mshiftwin" is the implementation version of the "shiftwin"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\shiftwin.m" (lines
 * 1-59). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function shiftwin(h)
 */
static void Mshiftwin(mxArray * h) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_shiftwin);
    mxArray * urcornery = NULL;
    mxArray * urcornerx = NULL;
    mxArray * shifty = NULL;
    mxArray * shiftx = NULL;
    mxArray * llcornery = NULL;
    mxArray * llcornerx = NULL;
    mxArray * position = NULL;
    mxArray * screendim = NULL;
    mxArray * ans = NULL;
    mxArray * oldunits = NULL;
    mclCopyArray(&h);
    /*
     * 
     * %SHIFTWIN adjusts window position if corners are offscreen
     * %
     * %  SHIFTWIN(h) adjusts position of the window with handle h if any of 
     * %  the corners are offscreen.  The window is translated, but not scaled.
     * 
     * 
     * %  Written by:  W. Stumpf
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %   $Revision: 1.11 $    $Date: 2002/03/20 21:28:14 $
     * 
     * % monitor characteristics
     * 
     * oldunits = get(0,'units');
     */
    mlfAssign(&oldunits, mlfNGet(1, _mxarray0_, _mxarray1_, NULL));
    /*
     * set(0,'units','pixels');
     */
    mclAssignAns(&ans, mlfNSet(0, _mxarray0_, _mxarray1_, _mxarray3_, NULL));
    /*
     * screendim = get(0,'screensize');
     */
    mlfAssign(&screendim, mlfNGet(1, _mxarray0_, _mxarray5_, NULL));
    /*
     * set(0,'units',oldunits);
     */
    mclAssignAns(
      &ans,
      mlfNSet(0, _mxarray0_, _mxarray1_, mclVv(oldunits, "oldunits"), NULL));
    /*
     * 
     * 
     * 
     * % window dimensions
     * 
     * oldunits = get(h,'units');
     */
    mlfAssign(&oldunits, mlfNGet(1, mclVa(h, "h"), _mxarray1_, NULL));
    /*
     * set(h,'units','pixels');
     */
    mclAssignAns(&ans, mlfNSet(0, mclVa(h, "h"), _mxarray1_, _mxarray3_, NULL));
    /*
     * position = get(h,'position');
     */
    mlfAssign(&position, mlfNGet(1, mclVa(h, "h"), _mxarray7_, NULL));
    /*
     * 
     * 
     * % shift window to get lower left corner on screen
     * 
     * llcornerx = position(1);
     */
    mlfAssign(&llcornerx, mclIntArrayRef1(mclVv(position, "position"), 1));
    /*
     * llcornery = position(2);
     */
    mlfAssign(&llcornery, mclIntArrayRef1(mclVv(position, "position"), 2));
    /*
     * 
     * shiftx = llcornerx; if shiftx>0; shiftx=0; end
     */
    mlfAssign(&shiftx, mclVv(llcornerx, "llcornerx"));
    if (mclGtBool(mclVv(shiftx, "shiftx"), _mxarray0_)) {
        mlfAssign(&shiftx, _mxarray0_);
    }
    /*
     * shifty = llcornery; if shifty>0; shifty=0; end
     */
    mlfAssign(&shifty, mclVv(llcornery, "llcornery"));
    if (mclGtBool(mclVv(shifty, "shifty"), _mxarray0_)) {
        mlfAssign(&shifty, _mxarray0_);
    }
    /*
     * 
     * if shiftx<0 | shifty<0
     */
    {
        mxArray * a_
          = mclInitialize(mclLt(mclVv(shiftx, "shiftx"), _mxarray0_));
        if (mlfTobool(a_)
            || mlfTobool(
                 mclOr(a_, mclLt(mclVv(shifty, "shifty"), _mxarray0_)))) {
            mxDestroyArray(a_);
            /*
             * position = position + [-shiftx+50 -shifty+50 0 0];
             */
            mlfAssign(
              &position,
              mclPlus(
                mclVv(position, "position"),
                mlfHorzcat(
                  mclPlus(mclUminus(mclVv(shiftx, "shiftx")), _mxarray9_),
                  mclPlus(mclUminus(mclVv(shifty, "shifty")), _mxarray9_),
                  _mxarray0_,
                  _mxarray0_,
                  NULL)));
            /*
             * set(h,'position',position);
             */
            mclAssignAns(
              &ans,
              mlfNSet(
                0,
                mclVa(h, "h"),
                _mxarray7_,
                mclVv(position, "position"),
                NULL));
        } else {
            mxDestroyArray(a_);
        }
    /*
     * end
     */
    }
    /*
     * 
     * % shift window to get upper right hand corner on screen
     * 
     * urcornerx = position(1)+position(3);
     */
    mlfAssign(
      &urcornerx,
      mclPlus(
        mclIntArrayRef1(mclVv(position, "position"), 1),
        mclIntArrayRef1(mclVv(position, "position"), 3)));
    /*
     * urcornery = position(2)+position(4);
     */
    mlfAssign(
      &urcornery,
      mclPlus(
        mclIntArrayRef1(mclVv(position, "position"), 2),
        mclIntArrayRef1(mclVv(position, "position"), 4)));
    /*
     * 
     * shiftx = urcornerx - screendim(3); if shiftx<0; shiftx=0; end
     */
    mlfAssign(
      &shiftx,
      mclMinus(
        mclVv(urcornerx, "urcornerx"),
        mclIntArrayRef1(mclVv(screendim, "screendim"), 3)));
    if (mclLtBool(mclVv(shiftx, "shiftx"), _mxarray0_)) {
        mlfAssign(&shiftx, _mxarray0_);
    }
    /*
     * shifty = urcornery - screendim(4)+50; if shifty<0; shifty=0; end
     */
    mlfAssign(
      &shifty,
      mclPlus(
        mclMinus(
          mclVv(urcornery, "urcornery"),
          mclIntArrayRef1(mclVv(screendim, "screendim"), 4)),
        _mxarray9_));
    if (mclLtBool(mclVv(shifty, "shifty"), _mxarray0_)) {
        mlfAssign(&shifty, _mxarray0_);
    }
    /*
     * 
     * if shiftx>0 
     */
    if (mclGtBool(mclVv(shiftx, "shiftx"), _mxarray0_)) {
        /*
         * position = position + [-shiftx-50 0 0 0];
         */
        mlfAssign(
          &position,
          mclPlus(
            mclVv(position, "position"),
            mlfHorzcat(
              mclMinus(mclUminus(mclVv(shiftx, "shiftx")), _mxarray9_),
              _mxarray0_,
              _mxarray0_,
              _mxarray0_,
              NULL)));
        /*
         * set(h,'position',position);
         */
        mclAssignAns(
          &ans,
          mlfNSet(
            0, mclVa(h, "h"), _mxarray7_, mclVv(position, "position"), NULL));
    /*
     * end
     */
    }
    /*
     * if shifty>0
     */
    if (mclGtBool(mclVv(shifty, "shifty"), _mxarray0_)) {
        /*
         * position = position + [0 -shifty-50 0 0];
         */
        mlfAssign(
          &position,
          mclPlus(
            mclVv(position, "position"),
            mlfHorzcat(
              _mxarray0_,
              mclMinus(mclUminus(mclVv(shifty, "shifty")), _mxarray9_),
              _mxarray0_,
              _mxarray0_,
              NULL)));
        /*
         * set(h,'position',position);
         */
        mclAssignAns(
          &ans,
          mlfNSet(
            0, mclVa(h, "h"), _mxarray7_, mclVv(position, "position"), NULL));
    /*
     * end
     */
    }
    /*
     * set(h,'units',oldunits);
     */
    mclAssignAns(
      &ans,
      mlfNSet(0, mclVa(h, "h"), _mxarray1_, mclVv(oldunits, "oldunits"), NULL));
    mxDestroyArray(oldunits);
    mxDestroyArray(ans);
    mxDestroyArray(screendim);
    mxDestroyArray(position);
    mxDestroyArray(llcornerx);
    mxDestroyArray(llcornery);
    mxDestroyArray(shiftx);
    mxDestroyArray(shifty);
    mxDestroyArray(urcornerx);
    mxDestroyArray(urcornery);
    mxDestroyArray(h);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
}
