/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:34 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "sm2nm.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

static mxChar _array3_[52] = { 'I', 'm', 'a', 'g', 'i', 'n', 'a', 'r', 'y',
                               ' ', 'p', 'a', 'r', 't', 's', ' ', 'o', 'f',
                               ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ' ',
                               'D', 'I', 'S', 'T', 'A', 'N', 'C', 'E', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', ' ',
                               'i', 'g', 'n', 'o', 'r', 'e', 'd' };
static mxArray * _mxarray2_;
static mxArray * _mxarray4_;

void InitializeModule_sm2nm(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeString(52, _array3_);
    _mxarray4_ = mclInitializeDouble(1.150779);
}

void TerminateModule_sm2nm(void) {
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Msm2nm(int nargout_, mxArray * sm);

_mexLocalFunctionTable _local_function_table_sm2nm
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfSm2nm" contains the normal interface for the "sm2nm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\sm2nm.m" (lines 1-22).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfSm2nm(mxArray * sm) {
    int nargout = 1;
    mxArray * nm = NULL;
    mlfEnterNewContext(0, 1, sm);
    nm = Msm2nm(nargout, sm);
    mlfRestorePreviousContext(0, 1, sm);
    return mlfReturnValue(nm);
}

/*
 * The function "mlxSm2nm" contains the feval interface for the "sm2nm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\sm2nm.m" (lines 1-22).
 * The feval function calls the implementation version of sm2nm through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxSm2nm(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: sm2nm Line: 1 Column: 1 The function \"sm2nm"
            "\" was called with more than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: sm2nm Line: 1 Column: 1 The function \"sm2nm"
            "\" was called with more than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Msm2nm(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Msm2nm" is the implementation version of the "sm2nm"
 * M-function from file "c:\matlab6p5\toolbox\map\map\sm2nm.m" (lines 1-22). It
 * contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function nm = sm2nm(sm)
 */
static mxArray * Msm2nm(int nargout_, mxArray * sm) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_sm2nm);
    int nargin_ = mclNargin(1, sm, NULL);
    mxArray * nm = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&sm);
    /*
     * 
     * %SM2NM Converts distances from statute miles to nautical miles
     * %
     * %  nm = SM2NM(sm) converts distances from statute miles to nautical miles.
     * %
     * %  See also NM2SM, SM2DEG, SM2RAD, SM2KM, DISTDIM
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Brown, E. Byrns
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:26:26 $
     * 
     * if nargin==0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif ~isreal(sm)
     */
    } else if (mclNotBool(mlfIsreal(mclVa(sm, "sm")))) {
        /*
         * warning('Imaginary parts of complex DISTANCE argument ignored')
         */
        mclPrintAns(&ans, mlfNWarning(0, NULL, _mxarray2_, NULL));
        /*
         * sm = real(sm);
         */
        mlfAssign(&sm, mlfReal(mclVa(sm, "sm")));
    /*
     * end
     */
    }
    /*
     * 
     * 
     * nm=sm/1.150779;
     */
    mlfAssign(&nm, mclMrdivide(mclVa(sm, "sm"), _mxarray4_));
    mclValidateOutput(nm, 1, nargout_, "nm", "sm2nm");
    mxDestroyArray(ans);
    mxDestroyArray(sm);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return nm;
}
