/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:37 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */

#ifndef MLF_V2
#define MLF_V2 1
#endif

#include "libmatlb.h"
#include "libsgl.h"
#include "traj.h"
#include "axesm.h"
#include "cla.h"
#include "fillm.h"
#include "framem.h"
#include "guidata.h"
#include "guihandles.h"
#include "hidem.h"
#include "mfwdtran.h"
#include "openfig.h"
#include "waitbar.h"
#include "angledim.h"
#include "axesmui.h"
#include "defaultm.h"
#include "geoidtst.h"
#include "gridm.h"
#include "ismap.h"
#include "maplist.h"
#include "maps.h"
#include "mlabel.h"
#include "plabel.h"
#include "showaxes.h"
#include "unitstr.h"
#include "utmzone.h"
#include "nextmap.h"
#include "patchm.h"
#include "epsm.h"
#include "gcm.h"
#include "handlem.h"
#include "rad2deg.h"
#include "restack.h"
#include "scircle1.h"
#include "showm.h"
#include "isvarname.h"
#include "globe.h"
#include "movegui.h"
#include "title.h"
#include "deg2dm.h"
#include "deg2dms.h"
#include "deg2rad.h"
#include "dms2deg.h"
#include "dms2dm.h"
#include "dms2rad.h"
#include "rad2dm.h"
#include "rad2dms.h"
#include "almanac.h"
#include "guifactm.h"
#include "setm.h"
#include "shiftwin.h"
#include "utmgeoid.h"
#include "utmzoneui.h"
#include "linem.h"
#include "angl2str.h"
#include "npi2pi.h"
#include "rotatetext.h"
#include "textm.h"
#include "meanm.h"
#include "clmo.h"
#include "clma.h"
#include "setfaces.h"
#include "listdlg.h"
#include "namem.h"
#include "reckon.h"
#include "iskeyword.h"
#include "dms2mat.h"
#include "mat2dms.h"
#include "distdim.h"
#include "elpcalc.h"
#include "flat2ecc.h"
#include "sphcalc.h"
#include "cart2grn.h"
#include "getm.h"
#include "ismapped.h"
#include "mdistort.h"
#include "meshgrat.h"
#include "minvtran.h"
#include "parallelui.h"
#include "scaleruler.h"
#include "scircleg.h"
#include "sectorg.h"
#include "trackg.h"
#include "displaym.h"
#include "gcpmap.h"
#include "degchar.h"
#include "leadblnk.h"
#include "vfwdtran.h"
#include "aut2geod.h"
#include "geod2aut.h"
#include "geod2iso.h"
#include "geod2rec.h"
#include "rec2geod.h"
#include "rsphere.h"
#include "roundn.h"
#include "deg2km.h"
#include "deg2nm.h"
#include "deg2sm.h"
#include "km2deg.h"
#include "km2nm.h"
#include "km2rad.h"
#include "km2sm.h"
#include "nm2deg.h"
#include "nm2km.h"
#include "nm2rad.h"
#include "nm2sm.h"
#include "rad2km.h"
#include "rad2nm.h"
#include "rad2sm.h"
#include "sm2deg.h"
#include "sm2km.h"
#include "sm2nm.h"
#include "sm2rad.h"
#include "minaxis.h"
#include "clabel.h"
#include "contour.h"
#include "distortcalc.h"
#include "tagm.h"
#include "zdatam.h"
#include "limitm.h"
#include "zlim.h"
#include "azimuth.h"
#include "distance.h"
#include "inputm.h"
#include "plotm.h"
#include "popupstr.h"
#include "scircle2.h"
#include "uimaptbx.h"
#include "track2.h"
#include "zero22pi.h"
#include "extractm.h"
#include "lightm.h"
#include "meshm.h"
#include "patchesm.h"
#include "surfacem.h"
#include "rotatem.h"
#include "geod2cnf.h"
#include "ecc2n.h"
#include "ecc2flat.h"
#include "rcurve.h"
#include "contour3.h"
#include "geod2par.h"
#include "merccalc.h"
#include "track1.h"
#include "contours.h"
#include "mercator.h"
#include "clipdata.h"
#include "cnf2geod.h"
#include "trimdata.h"
#include "undoclip.h"
#include "undotrim.h"
#include "interpm.h"
#include "polyjoin.h"
#include "track.h"
#include "libmmfile.h"
#include "libmwsglm.h"

extern _mex_information _main_info;

static mexFunctionTableEntry function_table[152]
  = { { "traj", mlxTraj, -1, -1, &_local_function_table_traj },
      { "axesm", mlxAxesm, -1, 2, &_local_function_table_axesm },
      { "cla", mlxCla, -1, 1, &_local_function_table_cla },
      { "fillm", mlxFillm, -1, 1, &_local_function_table_fillm },
      { "framem", mlxFramem, -1, 1, &_local_function_table_framem },
      { "guidata", mlxGuidata, 2, 1, &_local_function_table_guidata },
      { "guihandles", mlxGuihandles, 1, 1, &_local_function_table_guihandles },
      { "hidem", mlxHidem, 1, 0, &_local_function_table_hidem },
      { "mfwdtran", mlxMfwdtran, -1, 4, &_local_function_table_mfwdtran },
      { "openfig", mlxOpenfig, 3, 1, &_local_function_table_openfig },
      { "waitbar", mlxWaitbar, -3, 1, &_local_function_table_waitbar },
      { "angledim", mlxAngledim, 3, 1, &_local_function_table_angledim },
      { "axesmui", mlxAxesmui, 2, 1, &_local_function_table_axesmui },
      { "defaultm", mlxDefaultm, 1, 2, &_local_function_table_defaultm },
      { "geoidtst", mlxGeoidtst, 1, 2, &_local_function_table_geoidtst },
      { "gridm", mlxGridm, -1, 1, &_local_function_table_gridm },
      { "ismap", mlxIsmap, 1, 2, &_local_function_table_ismap },
      { "maplist", mlxMaplist, 0, 2, &_local_function_table_maplist },
      { "maps", mlxMaps, 1, 2, &_local_function_table_maps },
      { "mlabel", mlxMlabel, -1, 1, &_local_function_table_mlabel },
      { "plabel", mlxPlabel, -1, 1, &_local_function_table_plabel },
      { "showaxes", mlxShowaxes, 1, 0, &_local_function_table_showaxes },
      { "unitstr", mlxUnitstr, 2, 2, &_local_function_table_unitstr },
      { "utmzone", mlxUtmzone, -1, -1, &_local_function_table_utmzone },
      { "nextmap", mlxNextmap, 0, 0, &_local_function_table_nextmap },
      { "patchm", mlxPatchm, -1, 2, &_local_function_table_patchm },
      { "epsm", mlxEpsm, 1, 1, &_local_function_table_epsm },
      { "gcm", mlxGcm, 1, 2, &_local_function_table_gcm },
      { "handlem", mlxHandlem, 3, 2, &_local_function_table_handlem },
      { "rad2deg", mlxRad2deg, 1, 1, &_local_function_table_rad2deg },
      { "restack", mlxRestack, 2, 0, &_local_function_table_restack },
      { "scircle1", mlxScircle1, 8, 2, &_local_function_table_scircle1 },
      { "showm", mlxShowm, 1, 0, &_local_function_table_showm },
      { "isvarname", mlxIsvarname, 1, 1, &_local_function_table_isvarname },
      { "globe", mlxGlobe, 6, 3, &_local_function_table_globe },
      { "movegui", mlxMovegui, -1, 0, &_local_function_table_movegui },
      { "title", mlxTitle, -2, 1, &_local_function_table_title },
      { "deg2dm", mlxDeg2dm, 1, 1, &_local_function_table_deg2dm },
      { "deg2dms", mlxDeg2dms, 1, 1, &_local_function_table_deg2dms },
      { "deg2rad", mlxDeg2rad, 1, 1, &_local_function_table_deg2rad },
      { "dms2deg", mlxDms2deg, 3, 1, &_local_function_table_dms2deg },
      { "dms2dm", mlxDms2dm, 1, 1, &_local_function_table_dms2dm },
      { "dms2rad", mlxDms2rad, 3, 1, &_local_function_table_dms2rad },
      { "rad2dm", mlxRad2dm, 1, 1, &_local_function_table_rad2dm },
      { "rad2dms", mlxRad2dms, 1, 1, &_local_function_table_rad2dms },
      { "almanac", mlxAlmanac, 4, 1, &_local_function_table_almanac },
      { "guifactm", mlxGuifactm, 1, 1, &_local_function_table_guifactm },
      { "setm", mlxSetm, -1, 0, &_local_function_table_setm },
      { "shiftwin", mlxShiftwin, 1, 0, &_local_function_table_shiftwin },
      { "utmgeoid", mlxUtmgeoid, 1, 2, &_local_function_table_utmgeoid },
      { "utmzoneui", mlxUtmzoneui, 1, 2, &_local_function_table_utmzoneui },
      { "linem", mlxLinem, -1, 2, &_local_function_table_linem },
      { "angl2str", mlxAngl2str, 4, 1, &_local_function_table_angl2str },
      { "npi2pi", mlxNpi2pi, 3, 1, &_local_function_table_npi2pi },
      { "rotatetext", mlxRotatetext, 2, 0, &_local_function_table_rotatetext },
      { "textm", mlxTextm, -1, 2, &_local_function_table_textm },
      { "meanm", mlxMeanm, 4, 2, &_local_function_table_meanm },
      { "clmo", mlxClmo, 1, 0, &_local_function_table_clmo },
      { "clma", mlxClma, 1, 0, &_local_function_table_clma },
      { "setfaces", mlxSetfaces, 2, 1, &_local_function_table_setfaces },
      { "listdlg", mlxListdlg, -1, 2, &_local_function_table_listdlg },
      { "namem", mlxNamem, 1, 2, &_local_function_table_namem },
      { "reckon", mlxReckon, -1, 2, &_local_function_table_reckon },
      { "iskeyword", mlxIskeyword, 1, 1, &_local_function_table_iskeyword },
      { "dms2mat", mlxDms2mat, 2, 3, &_local_function_table_dms2mat },
      { "mat2dms", mlxMat2dms, 4, 1, &_local_function_table_mat2dms },
      { "distdim", mlxDistdim, 4, 1, &_local_function_table_distdim },
      { "elpcalc", mlxElpcalc, 2, 1, &_local_function_table_elpcalc },
      { "flat2ecc", mlxFlat2ecc, 1, 1, &_local_function_table_flat2ecc },
      { "sphcalc", mlxSphcalc, 2, 1, &_local_function_table_sphcalc },
      { "cart2grn", mlxCart2grn, 2, 3, &_local_function_table_cart2grn },
      { "getm", mlxGetm, 2, 1, &_local_function_table_getm },
      { "ismapped", mlxIsmapped, 1, 2, &_local_function_table_ismapped },
      { "mdistort", mlxMdistort, 3, 2, &_local_function_table_mdistort },
      { "meshgrat", mlxMeshgrat, 4, 2, &_local_function_table_meshgrat },
      { "minvtran", mlxMinvtran, -1, 3, &_local_function_table_minvtran },
      { "parallelui", mlxParallelui, 1, 0, &_local_function_table_parallelui },
      { "scaleruler", mlxScaleruler, -1, -1,
        &_local_function_table_scaleruler },
      { "scircleg", mlxScircleg, -1, 2, &_local_function_table_scircleg },
      { "sectorg", mlxSectorg, 1, 0, &_local_function_table_sectorg },
      { "trackg", mlxTrackg, -1, 2, &_local_function_table_trackg },
      { "displaym", mlxDisplaym, -1, 2, &_local_function_table_displaym },
      { "gcpmap", mlxGcpmap, 1, 1, &_local_function_table_gcpmap },
      { "degchar", mlxDegchar, 0, 1, &_local_function_table_degchar },
      { "leadblnk", mlxLeadblnk, 2, 1, &_local_function_table_leadblnk },
      { "vfwdtran", mlxVfwdtran, -1, 2, &_local_function_table_vfwdtran },
      { "aut2geod", mlxAut2geod, 3, 1, &_local_function_table_aut2geod },
      { "geod2aut", mlxGeod2aut, 3, 1, &_local_function_table_geod2aut },
      { "geod2iso", mlxGeod2iso, 3, 1, &_local_function_table_geod2iso },
      { "geod2rec", mlxGeod2rec, 3, 1, &_local_function_table_geod2rec },
      { "rec2geod", mlxRec2geod, 3, 1, &_local_function_table_rec2geod },
      { "rsphere", mlxRsphere, -1, 1, &_local_function_table_rsphere },
      { "roundn", mlxRoundn, 2, 2, &_local_function_table_roundn },
      { "deg2km", mlxDeg2km, 2, 1, &_local_function_table_deg2km },
      { "deg2nm", mlxDeg2nm, 2, 1, &_local_function_table_deg2nm },
      { "deg2sm", mlxDeg2sm, 2, 1, &_local_function_table_deg2sm },
      { "km2deg", mlxKm2deg, 2, 1, &_local_function_table_km2deg },
      { "km2nm", mlxKm2nm, 1, 1, &_local_function_table_km2nm },
      { "km2rad", mlxKm2rad, 2, 1, &_local_function_table_km2rad },
      { "km2sm", mlxKm2sm, 1, 1, &_local_function_table_km2sm },
      { "nm2deg", mlxNm2deg, 2, 1, &_local_function_table_nm2deg },
      { "nm2km", mlxNm2km, 1, 1, &_local_function_table_nm2km },
      { "nm2rad", mlxNm2rad, 2, 1, &_local_function_table_nm2rad },
      { "nm2sm", mlxNm2sm, 1, 1, &_local_function_table_nm2sm },
      { "rad2km", mlxRad2km, 2, 1, &_local_function_table_rad2km },
      { "rad2nm", mlxRad2nm, 2, 1, &_local_function_table_rad2nm },
      { "rad2sm", mlxRad2sm, 2, 1, &_local_function_table_rad2sm },
      { "sm2deg", mlxSm2deg, 2, 1, &_local_function_table_sm2deg },
      { "sm2km", mlxSm2km, 1, 1, &_local_function_table_sm2km },
      { "sm2nm", mlxSm2nm, 1, 1, &_local_function_table_sm2nm },
      { "sm2rad", mlxSm2rad, 2, 1, &_local_function_table_sm2rad },
      { "minaxis", mlxMinaxis, 2, 1, &_local_function_table_minaxis },
      { "clabel", mlxClabel, -2, 1, &_local_function_table_clabel },
      { "contour", mlxContour, -1, 2, &_local_function_table_contour },
      { "distortcalc", mlxDistortcalc, -1, 6,
        &_local_function_table_distortcalc },
      { "tagm", mlxTagm, 2, 1, &_local_function_table_tagm },
      { "zdatam", mlxZdatam, 2, 0, &_local_function_table_zdatam },
      { "limitm", mlxLimitm, 2, 2, &_local_function_table_limitm },
      { "zlim", mlxZlim, 2, 1, &_local_function_table_zlim },
      { "azimuth", mlxAzimuth, -1, 1, &_local_function_table_azimuth },
      { "distance", mlxDistance, -1, 1, &_local_function_table_distance },
      { "inputm", mlxInputm, 2, 2, &_local_function_table_inputm },
      { "plotm", mlxPlotm, -1, 1, &_local_function_table_plotm },
      { "popupstr", mlxPopupstr, 1, 1, &_local_function_table_popupstr },
      { "scircle2", mlxScircle2, 8, 2, &_local_function_table_scircle2 },
      { "uimaptbx", mlxUimaptbx, 3, 0, &_local_function_table_uimaptbx },
      { "track2", mlxTrack2, 8, 2, &_local_function_table_track2 },
      { "zero22pi", mlxZero22pi, 3, 1, &_local_function_table_zero22pi },
      { "extractm", mlxExtractm, 3, 3, &_local_function_table_extractm },
      { "lightm", mlxLightm, -1, 2, &_local_function_table_lightm },
      { "meshm", mlxMeshm, -1, 2, &_local_function_table_meshm },
      { "patchesm", mlxPatchesm, -1, 2, &_local_function_table_patchesm },
      { "surfacem", mlxSurfacem, -1, 2, &_local_function_table_surfacem },
      { "rotatem", mlxRotatem, 5, 2, &_local_function_table_rotatem },
      { "geod2cnf", mlxGeod2cnf, 3, 1, &_local_function_table_geod2cnf },
      { "ecc2n", mlxEcc2n, 1, 1, &_local_function_table_ecc2n },
      { "ecc2flat", mlxEcc2flat, 1, 1, &_local_function_table_ecc2flat },
      { "rcurve", mlxRcurve, 4, 1, &_local_function_table_rcurve },
      { "contour3", mlxContour3, -1, 3, &_local_function_table_contour3 },
      { "geod2par", mlxGeod2par, 3, 1, &_local_function_table_geod2par },
      { "merccalc", mlxMerccalc, 5, 2, &_local_function_table_merccalc },
      { "track1", mlxTrack1, 8, 2, &_local_function_table_track1 },
      { "contours", mlxContours, -1, 2, &_local_function_table_contours },
      { "mercator", mlxMercator, 6, 3, &_local_function_table_mercator },
      { "clipdata", mlxClipdata, 3, 3, &_local_function_table_clipdata },
      { "cnf2geod", mlxCnf2geod, 3, 1, &_local_function_table_cnf2geod },
      { "trimdata", mlxTrimdata, 5, 3, &_local_function_table_trimdata },
      { "undoclip", mlxUndoclip, 4, 2, &_local_function_table_undoclip },
      { "undotrim", mlxUndotrim, 4, 2, &_local_function_table_undotrim },
      { "interpm", mlxInterpm, 5, 2, &_local_function_table_interpm },
      { "polyjoin", mlxPolyjoin, 2, 2, &_local_function_table_polyjoin },
      { "track", mlxTrack, 6, 2, &_local_function_table_track } };

static _mexInitTermTableEntry init_term_table[154]
  = { { libmmfileInitialize, libmmfileTerminate },
      { libmwsglmInitialize, libmwsglmTerminate },
      { InitializeModule_traj, TerminateModule_traj },
      { InitializeModule_axesm, TerminateModule_axesm },
      { InitializeModule_cla, TerminateModule_cla },
      { InitializeModule_fillm, TerminateModule_fillm },
      { InitializeModule_framem, TerminateModule_framem },
      { InitializeModule_guidata, TerminateModule_guidata },
      { InitializeModule_guihandles, TerminateModule_guihandles },
      { InitializeModule_hidem, TerminateModule_hidem },
      { InitializeModule_mfwdtran, TerminateModule_mfwdtran },
      { InitializeModule_openfig, TerminateModule_openfig },
      { InitializeModule_waitbar, TerminateModule_waitbar },
      { InitializeModule_angledim, TerminateModule_angledim },
      { InitializeModule_axesmui, TerminateModule_axesmui },
      { InitializeModule_defaultm, TerminateModule_defaultm },
      { InitializeModule_geoidtst, TerminateModule_geoidtst },
      { InitializeModule_gridm, TerminateModule_gridm },
      { InitializeModule_ismap, TerminateModule_ismap },
      { InitializeModule_maplist, TerminateModule_maplist },
      { InitializeModule_maps, TerminateModule_maps },
      { InitializeModule_mlabel, TerminateModule_mlabel },
      { InitializeModule_plabel, TerminateModule_plabel },
      { InitializeModule_showaxes, TerminateModule_showaxes },
      { InitializeModule_unitstr, TerminateModule_unitstr },
      { InitializeModule_utmzone, TerminateModule_utmzone },
      { InitializeModule_nextmap, TerminateModule_nextmap },
      { InitializeModule_patchm, TerminateModule_patchm },
      { InitializeModule_epsm, TerminateModule_epsm },
      { InitializeModule_gcm, TerminateModule_gcm },
      { InitializeModule_handlem, TerminateModule_handlem },
      { InitializeModule_rad2deg, TerminateModule_rad2deg },
      { InitializeModule_restack, TerminateModule_restack },
      { InitializeModule_scircle1, TerminateModule_scircle1 },
      { InitializeModule_showm, TerminateModule_showm },
      { InitializeModule_isvarname, TerminateModule_isvarname },
      { InitializeModule_globe, TerminateModule_globe },
      { InitializeModule_movegui, TerminateModule_movegui },
      { InitializeModule_title, TerminateModule_title },
      { InitializeModule_deg2dm, TerminateModule_deg2dm },
      { InitializeModule_deg2dms, TerminateModule_deg2dms },
      { InitializeModule_deg2rad, TerminateModule_deg2rad },
      { InitializeModule_dms2deg, TerminateModule_dms2deg },
      { InitializeModule_dms2dm, TerminateModule_dms2dm },
      { InitializeModule_dms2rad, TerminateModule_dms2rad },
      { InitializeModule_rad2dm, TerminateModule_rad2dm },
      { InitializeModule_rad2dms, TerminateModule_rad2dms },
      { InitializeModule_almanac, TerminateModule_almanac },
      { InitializeModule_guifactm, TerminateModule_guifactm },
      { InitializeModule_setm, TerminateModule_setm },
      { InitializeModule_shiftwin, TerminateModule_shiftwin },
      { InitializeModule_utmgeoid, TerminateModule_utmgeoid },
      { InitializeModule_utmzoneui, TerminateModule_utmzoneui },
      { InitializeModule_linem, TerminateModule_linem },
      { InitializeModule_angl2str, TerminateModule_angl2str },
      { InitializeModule_npi2pi, TerminateModule_npi2pi },
      { InitializeModule_rotatetext, TerminateModule_rotatetext },
      { InitializeModule_textm, TerminateModule_textm },
      { InitializeModule_meanm, TerminateModule_meanm },
      { InitializeModule_clmo, TerminateModule_clmo },
      { InitializeModule_clma, TerminateModule_clma },
      { InitializeModule_setfaces, TerminateModule_setfaces },
      { InitializeModule_listdlg, TerminateModule_listdlg },
      { InitializeModule_namem, TerminateModule_namem },
      { InitializeModule_reckon, TerminateModule_reckon },
      { InitializeModule_iskeyword, TerminateModule_iskeyword },
      { InitializeModule_dms2mat, TerminateModule_dms2mat },
      { InitializeModule_mat2dms, TerminateModule_mat2dms },
      { InitializeModule_distdim, TerminateModule_distdim },
      { InitializeModule_elpcalc, TerminateModule_elpcalc },
      { InitializeModule_flat2ecc, TerminateModule_flat2ecc },
      { InitializeModule_sphcalc, TerminateModule_sphcalc },
      { InitializeModule_cart2grn, TerminateModule_cart2grn },
      { InitializeModule_getm, TerminateModule_getm },
      { InitializeModule_ismapped, TerminateModule_ismapped },
      { InitializeModule_mdistort, TerminateModule_mdistort },
      { InitializeModule_meshgrat, TerminateModule_meshgrat },
      { InitializeModule_minvtran, TerminateModule_minvtran },
      { InitializeModule_parallelui, TerminateModule_parallelui },
      { InitializeModule_scaleruler, TerminateModule_scaleruler },
      { InitializeModule_scircleg, TerminateModule_scircleg },
      { InitializeModule_sectorg, TerminateModule_sectorg },
      { InitializeModule_trackg, TerminateModule_trackg },
      { InitializeModule_displaym, TerminateModule_displaym },
      { InitializeModule_gcpmap, TerminateModule_gcpmap },
      { InitializeModule_degchar, TerminateModule_degchar },
      { InitializeModule_leadblnk, TerminateModule_leadblnk },
      { InitializeModule_vfwdtran, TerminateModule_vfwdtran },
      { InitializeModule_aut2geod, TerminateModule_aut2geod },
      { InitializeModule_geod2aut, TerminateModule_geod2aut },
      { InitializeModule_geod2iso, TerminateModule_geod2iso },
      { InitializeModule_geod2rec, TerminateModule_geod2rec },
      { InitializeModule_rec2geod, TerminateModule_rec2geod },
      { InitializeModule_rsphere, TerminateModule_rsphere },
      { InitializeModule_roundn, TerminateModule_roundn },
      { InitializeModule_deg2km, TerminateModule_deg2km },
      { InitializeModule_deg2nm, TerminateModule_deg2nm },
      { InitializeModule_deg2sm, TerminateModule_deg2sm },
      { InitializeModule_km2deg, TerminateModule_km2deg },
      { InitializeModule_km2nm, TerminateModule_km2nm },
      { InitializeModule_km2rad, TerminateModule_km2rad },
      { InitializeModule_km2sm, TerminateModule_km2sm },
      { InitializeModule_nm2deg, TerminateModule_nm2deg },
      { InitializeModule_nm2km, TerminateModule_nm2km },
      { InitializeModule_nm2rad, TerminateModule_nm2rad },
      { InitializeModule_nm2sm, TerminateModule_nm2sm },
      { InitializeModule_rad2km, TerminateModule_rad2km },
      { InitializeModule_rad2nm, TerminateModule_rad2nm },
      { InitializeModule_rad2sm, TerminateModule_rad2sm },
      { InitializeModule_sm2deg, TerminateModule_sm2deg },
      { InitializeModule_sm2km, TerminateModule_sm2km },
      { InitializeModule_sm2nm, TerminateModule_sm2nm },
      { InitializeModule_sm2rad, TerminateModule_sm2rad },
      { InitializeModule_minaxis, TerminateModule_minaxis },
      { InitializeModule_clabel, TerminateModule_clabel },
      { InitializeModule_contour, TerminateModule_contour },
      { InitializeModule_distortcalc, TerminateModule_distortcalc },
      { InitializeModule_tagm, TerminateModule_tagm },
      { InitializeModule_zdatam, TerminateModule_zdatam },
      { InitializeModule_limitm, TerminateModule_limitm },
      { InitializeModule_zlim, TerminateModule_zlim },
      { InitializeModule_azimuth, TerminateModule_azimuth },
      { InitializeModule_distance, TerminateModule_distance },
      { InitializeModule_inputm, TerminateModule_inputm },
      { InitializeModule_plotm, TerminateModule_plotm },
      { InitializeModule_popupstr, TerminateModule_popupstr },
      { InitializeModule_scircle2, TerminateModule_scircle2 },
      { InitializeModule_uimaptbx, TerminateModule_uimaptbx },
      { InitializeModule_track2, TerminateModule_track2 },
      { InitializeModule_zero22pi, TerminateModule_zero22pi },
      { InitializeModule_extractm, TerminateModule_extractm },
      { InitializeModule_lightm, TerminateModule_lightm },
      { InitializeModule_meshm, TerminateModule_meshm },
      { InitializeModule_patchesm, TerminateModule_patchesm },
      { InitializeModule_surfacem, TerminateModule_surfacem },
      { InitializeModule_rotatem, TerminateModule_rotatem },
      { InitializeModule_geod2cnf, TerminateModule_geod2cnf },
      { InitializeModule_ecc2n, TerminateModule_ecc2n },
      { InitializeModule_ecc2flat, TerminateModule_ecc2flat },
      { InitializeModule_rcurve, TerminateModule_rcurve },
      { InitializeModule_contour3, TerminateModule_contour3 },
      { InitializeModule_geod2par, TerminateModule_geod2par },
      { InitializeModule_merccalc, TerminateModule_merccalc },
      { InitializeModule_track1, TerminateModule_track1 },
      { InitializeModule_contours, TerminateModule_contours },
      { InitializeModule_mercator, TerminateModule_mercator },
      { InitializeModule_clipdata, TerminateModule_clipdata },
      { InitializeModule_cnf2geod, TerminateModule_cnf2geod },
      { InitializeModule_trimdata, TerminateModule_trimdata },
      { InitializeModule_undoclip, TerminateModule_undoclip },
      { InitializeModule_undotrim, TerminateModule_undotrim },
      { InitializeModule_interpm, TerminateModule_interpm },
      { InitializeModule_polyjoin, TerminateModule_polyjoin },
      { InitializeModule_track, TerminateModule_track } };

_mex_information _main_info
  = { 1, 152, function_table, 0, NULL, 0, NULL, 154, init_term_table };

/*
 * The function "main" is a Compiler-generated main wrapper, suitable for
 * building a stand-alone application.  It calls a library function to perform
 * initialization, call the main function, and perform library termination.
 */
int main(int argc, const char * * argv) {
    return mclMainhg(argc, argv, mlxTraj, 1, &_main_info);
}
