/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:36 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "undotrim.h"
#include "libmatlbm.h"
#include "libmmfile.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

static mxChar _array3_[7] = { 's', 'u', 'r', 'f', 'a', 'c', 'e' };
static mxArray * _mxarray2_;
static mxArray * _mxarray4_;
static mxArray * _mxarray5_;
static mxArray * _mxarray6_;

static mxChar _array8_[5] = { 'l', 'i', 'g', 'h', 't' };
static mxArray * _mxarray7_;

static mxChar _array10_[4] = { 'l', 'i', 'n', 'e' };
static mxArray * _mxarray9_;
static mxArray * _mxarray11_;

static mxChar _array13_[5] = { 'p', 'a', 't', 'c', 'h' };
static mxArray * _mxarray12_;

static mxChar _array15_[4] = { 't', 'e', 'x', 't' };
static mxArray * _mxarray14_;

static mxChar _array17_[22] = { 'U', 'n', 'r', 'e', 'c', 'o', 'g', 'n',
                                'i', 'z', 'e', 'd', ' ', 'o', 'b', 'j',
                                'e', 'c', 't', ':', ' ', ' ' };
static mxArray * _mxarray16_;

void InitializeModule_undotrim(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeString(7, _array3_);
    _mxarray4_ = mclInitializeDouble(2.0);
    _mxarray5_ = mclInitializeDouble(1.0);
    _mxarray6_ = mclInitializeDouble(3.0);
    _mxarray7_ = mclInitializeString(5, _array8_);
    _mxarray9_ = mclInitializeString(4, _array10_);
    _mxarray11_ = mclInitializeDouble(4.0);
    _mxarray12_ = mclInitializeString(5, _array13_);
    _mxarray14_ = mclInitializeString(4, _array15_);
    _mxarray16_ = mclInitializeString(22, _array17_);
}

void TerminateModule_undotrim(void) {
    mxDestroyArray(_mxarray16_);
    mxDestroyArray(_mxarray14_);
    mxDestroyArray(_mxarray12_);
    mxDestroyArray(_mxarray11_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mundotrim(mxArray * * xmat,
                           int nargout_,
                           mxArray * ymat_in,
                           mxArray * xmat_in,
                           mxArray * trimpts,
                           mxArray * object);

_mexLocalFunctionTable _local_function_table_undotrim
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfUndotrim" contains the normal interface for the "undotrim"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\undotrim.m" (lines
 * 1-63). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfUndotrim(mxArray * * xmat,
                      mxArray * ymat_in,
                      mxArray * xmat_in,
                      mxArray * trimpts,
                      mxArray * object) {
    int nargout = 1;
    mxArray * ymat = NULL;
    mxArray * xmat__ = NULL;
    mlfEnterNewContext(1, 4, xmat, ymat_in, xmat_in, trimpts, object);
    if (xmat != NULL) {
        ++nargout;
    }
    ymat = Mundotrim(&xmat__, nargout, ymat_in, xmat_in, trimpts, object);
    mlfRestorePreviousContext(1, 4, xmat, ymat_in, xmat_in, trimpts, object);
    if (xmat != NULL) {
        mclCopyOutputArg(xmat, xmat__);
    } else {
        mxDestroyArray(xmat__);
    }
    return mlfReturnValue(ymat);
}

/*
 * The function "mlxUndotrim" contains the feval interface for the "undotrim"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\undotrim.m" (lines
 * 1-63). The feval function calls the implementation version of undotrim
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxUndotrim(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[4];
    mxArray * mplhs[2];
    int i;
    if (nlhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: undotrim Line: 1 Column:"
            " 1 The function \"undotrim\" was called with m"
            "ore than the declared number of outputs (2)."),
          NULL);
    }
    if (nrhs > 4) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: undotrim Line: 1 Column:"
            " 1 The function \"undotrim\" was called with m"
            "ore than the declared number of inputs (4)."),
          NULL);
    }
    for (i = 0; i < 2; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 4 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 4; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mplhs[0]
      = Mundotrim(&mplhs[1], nlhs, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mlfRestorePreviousContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 2 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 2; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}

/*
 * The function "Mundotrim" is the implementation version of the "undotrim"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\undotrim.m" (lines
 * 1-63). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function [ymat,xmat] = undotrim(ymat,xmat,trimpts,object)
 */
static mxArray * Mundotrim(mxArray * * xmat,
                           int nargout_,
                           mxArray * ymat_in,
                           mxArray * xmat_in,
                           mxArray * trimpts,
                           mxArray * object) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_undotrim);
    int nargin_ = mclNargin(4, ymat_in, xmat_in, trimpts, object, NULL);
    mxArray * ymat = NULL;
    mxArray * ans = NULL;
    mclCopyInputArg(&ymat, ymat_in);
    mclCopyInputArg(xmat, xmat_in);
    mclCopyArray(&trimpts);
    mclCopyArray(&object);
    /*
     * 
     * %UNDOTRIM  Removes object trims introduced by TRIMDATA
     * %
     * %  [ymat,xmat] = undotrim(ymat,xmat,trimpts,'object') will remove the
     * %  object trims introduced by TRIMDATA.  This function is necessary to
     * %  properly invert projected data from the cartesian space to the
     * %  original lat, long data points.  The input variable, trimpts, must
     * %  be constructed by the function TRIMDATA.
     * %
     * %  Allowable object string are:  'surface' for undoing trimmed graticules;
     * %  'light' for undoing trimmed lights; 'line' for undoing trimmed lines;
     * %  'patch' for undoing trimmed patches; and 'text' for undoing trimmed
     * %  text object location points.
     * %
     * %  See also CLIPDATA, TRIMDATA, UNDOCLIP
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.8 $    $Date: 2002/03/20 21:28:30 $
     * 
     * 
     * %  Argument tests
     * 
     * if nargin ~= 4;  error('Incorrect number of arguments');  end
     */
    if (nargin_ != 4) {
        mlfError(_mxarray0_, NULL);
    }
    /*
     * 
     * %  Return if nothing to undo
     * 
     * if isempty(trimpts);    return;   end
     */
    if (mlfTobool(mlfIsempty(mclVa(trimpts, "trimpts")))) {
        goto return_;
    }
    /*
     * 
     * %  Switch according to the correct object
     * 
     * switch object
     */
    {
        mxArray * v_ = mclInitialize(mclVa(object, "object"));
        if (mclSwitchCompare(v_, _mxarray2_)) {
            /*
             * case 'surface'
             * ymat(trimpts(:,1)) = trimpts(:,2);
             */
            mclArrayAssign1(
              &ymat,
              mclArrayRef2(
                mclVa(trimpts, "trimpts"), mlfCreateColonIndex(), _mxarray4_),
              mclArrayRef2(
                mclVa(trimpts, "trimpts"), mlfCreateColonIndex(), _mxarray5_));
            /*
             * xmat(trimpts(:,1)) = trimpts(:,3);
             */
            mclArrayAssign1(
              xmat,
              mclArrayRef2(
                mclVa(trimpts, "trimpts"), mlfCreateColonIndex(), _mxarray6_),
              mclArrayRef2(
                mclVa(trimpts, "trimpts"), mlfCreateColonIndex(), _mxarray5_));
        /*
         * case 'light'
         */
        } else if (mclSwitchCompare(v_, _mxarray7_)) {
            /*
             * xmat = xmat;   ymat = ymat;
             */
            mlfAssign(xmat, mclVa(*xmat, "xmat"));
            mlfAssign(&ymat, mclVa(ymat, "ymat"));
        /*
         * 
         * case 'line'
         */
        } else if (mclSwitchCompare(v_, _mxarray9_)) {
            /*
             * if size(trimpts,2) == 3
             */
            if (mclEqBool(
                  mlfSize(
                    mclValueVarargout(), mclVa(trimpts, "trimpts"), _mxarray4_),
                  _mxarray6_)) {
                /*
                 * ymat(trimpts(:,1)) = trimpts(:,2);
                 */
                mclArrayAssign1(
                  &ymat,
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray4_),
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray5_));
                /*
                 * xmat(trimpts(:,1)) = trimpts(:,3);
                 */
                mclArrayAssign1(
                  xmat,
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray6_),
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray5_));
            /*
             * elseif size(trimpts,2) == 4
             */
            } else if (mclEqBool(
                         mlfSize(
                           mclValueVarargout(),
                           mclVa(trimpts, "trimpts"),
                           _mxarray4_),
                         _mxarray11_)) {
                /*
                 * ymat(trimpts(:,1)) = trimpts(:,3);
                 */
                mclArrayAssign1(
                  &ymat,
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray6_),
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray5_));
                /*
                 * xmat(trimpts(:,1)) = trimpts(:,4);
                 */
                mclArrayAssign1(
                  xmat,
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray11_),
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray5_));
            /*
             * end
             */
            }
        /*
         * case 'patch'
         */
        } else if (mclSwitchCompare(v_, _mxarray12_)) {
            /*
             * trimpts = flipud(trimpts);          % undo them in reverse order, important when off both bottom and side
             */
            mlfAssign(&trimpts, mlfFlipud(mclVa(trimpts, "trimpts")));
            /*
             * ymat(trimpts(:,1)) = trimpts(:,3);
             */
            mclArrayAssign1(
              &ymat,
              mclArrayRef2(
                mclVa(trimpts, "trimpts"), mlfCreateColonIndex(), _mxarray6_),
              mclArrayRef2(
                mclVa(trimpts, "trimpts"), mlfCreateColonIndex(), _mxarray5_));
            /*
             * xmat(trimpts(:,1)) = trimpts(:,4);
             */
            mclArrayAssign1(
              xmat,
              mclArrayRef2(
                mclVa(trimpts, "trimpts"), mlfCreateColonIndex(), _mxarray11_),
              mclArrayRef2(
                mclVa(trimpts, "trimpts"), mlfCreateColonIndex(), _mxarray5_));
        /*
         * case 'text'
         */
        } else if (mclSwitchCompare(v_, _mxarray14_)) {
            /*
             * if size(trimpts,2) == 3
             */
            if (mclEqBool(
                  mlfSize(
                    mclValueVarargout(), mclVa(trimpts, "trimpts"), _mxarray4_),
                  _mxarray6_)) {
                /*
                 * ymat(trimpts(:,1)) = trimpts(:,2);
                 */
                mclArrayAssign1(
                  &ymat,
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray4_),
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray5_));
                /*
                 * xmat(trimpts(:,1)) = trimpts(:,3);
                 */
                mclArrayAssign1(
                  xmat,
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray6_),
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray5_));
            /*
             * elseif size(trimpts,2) == 4
             */
            } else if (mclEqBool(
                         mlfSize(
                           mclValueVarargout(),
                           mclVa(trimpts, "trimpts"),
                           _mxarray4_),
                         _mxarray11_)) {
                /*
                 * ymat(trimpts(:,1)) = trimpts(:,3);
                 */
                mclArrayAssign1(
                  &ymat,
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray6_),
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray5_));
                /*
                 * xmat(trimpts(:,1)) = trimpts(:,4);
                 */
                mclArrayAssign1(
                  xmat,
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray11_),
                  mclArrayRef2(
                    mclVa(trimpts, "trimpts"),
                    mlfCreateColonIndex(),
                    _mxarray5_));
            /*
             * end
             */
            }
        /*
         * otherwise
         */
        } else {
            /*
             * error(['Unrecognized object:  ',object])
             */
            mlfError(
              mlfHorzcat(_mxarray16_, mclVa(object, "object"), NULL), NULL);
        /*
         * end
         */
        }
        mxDestroyArray(v_);
    }
    return_:
    mclValidateOutput(ymat, 1, nargout_, "ymat", "undotrim");
    mclValidateOutput(*xmat, 2, nargout_, "xmat", "undotrim");
    mxDestroyArray(ans);
    mxDestroyArray(object);
    mxDestroyArray(trimpts);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return ymat;
}
