/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:31 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "clmo.h"
#include "libsgl.h"
#include "handlem.h"
#include "libmatlbm.h"
#include "libmmfile.h"
#include "libmwsglm.h"
#include "scaleruler.h"

static mxChar _array1_[7] = { 't', 'a', 'g', 'l', 'i', 's', 't' };
static mxArray * _mxarray0_;

static mxChar _array5_[3] = { 'a', 'l', 'l' };
static mxArray * _mxarray4_;

static mxChar _array7_[3] = { 'm', 'a', 'p' };
static mxArray * _mxarray6_;

static mxArray * _array3_[2] = { NULL /*_mxarray4_*/, NULL /*_mxarray6_*/ };
static mxArray * _mxarray2_;

static mxChar _array9_[3] = { 'o', 'f', 'f' };
static mxArray * _mxarray8_;

static mxChar _array11_[10] = { 's', 'c', 'a', 'l', 'e',
                                'r', 'u', 'l', 'e', 'r' };
static mxArray * _mxarray10_;

static mxChar _array13_[3] = { 't', 'a', 'g' };
static mxArray * _mxarray12_;

void InitializeModule_clmo(void) {
    _mxarray0_ = mclInitializeString(7, _array1_);
    _mxarray4_ = mclInitializeString(3, _array5_);
    _array3_[0] = _mxarray4_;
    _mxarray6_ = mclInitializeString(3, _array7_);
    _array3_[1] = _mxarray6_;
    _mxarray2_ = mclInitializeCellVector(1, 2, _array3_);
    _mxarray8_ = mclInitializeString(3, _array9_);
    _mxarray10_ = mclInitializeString(10, _array11_);
    _mxarray12_ = mclInitializeString(3, _array13_);
}

void TerminateModule_clmo(void) {
    mxDestroyArray(_mxarray12_);
    mxDestroyArray(_mxarray10_);
    mxDestroyArray(_mxarray8_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray0_);
}

static void Mclmo(mxArray * object);

_mexLocalFunctionTable _local_function_table_clmo
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfClmo" contains the normal interface for the "clmo"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\clmo.m" (lines 1-56).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlfClmo(mxArray * object) {
    mlfEnterNewContext(0, 1, object);
    Mclmo(object);
    mlfRestorePreviousContext(0, 1, object);
}

/*
 * The function "mlxClmo" contains the feval interface for the "clmo"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\clmo.m" (lines 1-56).
 * The feval function calls the implementation version of clmo through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxClmo(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    int i;
    if (nlhs > 0) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: clmo Line: 1 Column: 1 The function \"clmo\""
            " was called with more than the declared number of outputs (0)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: clmo Line: 1 Column: 1 The function \"clmo"
            "\" was called with more than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    Mclmo(mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
}

/*
 * The function "Mclmo" is the implementation version of the "clmo" M-function
 * from file "c:\matlab6p5\toolbox\map\mapdisp\clmo.m" (lines 1-56). It
 * contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function clmo(object)
 */
static void Mclmo(mxArray * object) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_clmo);
    int nargin_ = mclNargin(1, object, NULL);
    mxArray * msg = NULL;
    mxArray * hndl = NULL;
    mxArray * hndls = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&object);
    /*
     * 
     * %CLMO  Deletes identified graphic objects
     * %
     * %  CLMO('str') deletes the object on the current axes specified
     * %  by the string 'str', where 'str' is any string recognized by HANDLEM.
     * %
     * %  CLMO displays a Graphical User Interface prompting for the
     * %  objects to be deleted from the current axes.
     * %
     * %  CLMO(h) deletes the objects specified by the input handles h.  This
     * %  is equivalent to DELETE(h)
     * %
     * %  See also HIDE, SHOWM, HANDLEM, NAMEM, TAGM
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * % $Revision: 1.8 $
     * %  Written by:  E. Byrns, E. Brown
     * 
     * 
     * if nargin == 0;   object = 'taglist';   end
     */
    if (nargin_ == 0) {
        mlfAssign(&object, _mxarray0_);
    }
    /*
     * 
     * %  Handle scaleruler separately, because hidden elements aren't 
     * %  returned by HANDLEM
     * 
     * if all(ishandle(object));
     */
    if (mlfTobool(mlfAll(mlfIshandle(mclVa(object, "object")), NULL))) {
        /*
         * delete(object)
         */
        mlfDelete(mclVa(object, "object"), NULL);
        /*
         * return
         */
        goto return_;
    /*
     * end
     */
    }
    /*
     * 
     * switch object
     */
    {
        mxArray * v_ = mclInitialize(mclVa(object, "object"));
        if (mclSwitchCompare(v_, _mxarray2_)) {
            /*
             * case{'all','map'}
             * scaleruler off
             */
            mclPrintAns(
              &ans, mlfNScaleruler(0, mclAnsVarargout(), _mxarray8_, NULL));
        /*
         * case 'scaleruler'
         */
        } else if (mclSwitchCompare(v_, _mxarray10_)) {
            /*
             * scaleruler off
             */
            mclPrintAns(
              &ans, mlfNScaleruler(0, mclAnsVarargout(), _mxarray8_, NULL));
            /*
             * return	
             */
            mxDestroyArray(v_);
            goto return_;
        /*
         * otherwise
         */
        } else {
            /*
             * 
             * % special treatment for scalerulers, because of hidden elements
             * if strmatch('scaleruler',object) % strip trailing numbers
             */
            if (mlfTobool(
                  mlfStrmatch(_mxarray10_, mclVa(object, "object"), NULL))) {
                /*
                 * hndls = findall(gca,'tag',object);
                 */
                mlfAssign(
                  &hndls,
                  mlfFindall(
                    mlfGca(NULL), _mxarray12_, mclVa(object, "object"), NULL));
                /*
                 * delete(hndls);
                 */
                mlfDelete(mclVv(hndls, "hndls"), NULL);
                /*
                 * return
                 */
                mxDestroyArray(v_);
                goto return_;
            /*
             * end
             */
            }
        /*
         * end
         */
        }
        mxDestroyArray(v_);
    }
    /*
     * 
     * %  Get the appropriate object handles
     * 
     * [hndl,msg] = handlem(object);
     */
    mlfAssign(&hndl, mlfNHandlem(2, &msg, mclVa(object, "object"), NULL, NULL));
    /*
     * if ~isempty(msg);  error(msg);  end
     */
    if (mclNotBool(mlfIsempty(mclVv(msg, "msg")))) {
        mlfError(mclVv(msg, "msg"), NULL);
    }
    /*
     * 
     * %  Delete the identified graphics objects
     * 
     * delete(hndl)
     */
    mlfDelete(mclVv(hndl, "hndl"), NULL);
    /*
     * 
     */
    return_:
    mxDestroyArray(ans);
    mxDestroyArray(hndls);
    mxDestroyArray(hndl);
    mxDestroyArray(msg);
    mxDestroyArray(object);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
}
