/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:36 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "contours.h"
#include "libmatlbm.h"
#include "libmmfile.h"
static mxArray * _mxarray0_;
static mxArray * _mxarray1_;
static mxArray * _mxarray2_;

static mxChar _array4_[6] = { 'd', 'o', 'u', 'b', 'l', 'e' };
static mxArray * _mxarray3_;
static mxArray * _mxarray5_;
static mxArray * _mxarray6_;
static mxArray * _mxarray7_;
static mxArray * _mxarray8_;

void InitializeModule_contours(void) {
    _mxarray0_ = mclInitializeDouble(1.0);
    _mxarray1_ = mclInitializeDouble(4.0);
    _mxarray2_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray3_ = mclInitializeString(6, _array4_);
    _mxarray5_ = mclInitializeDouble(3.0);
    _mxarray6_ = mclInitializeDouble(2.0);
    _mxarray7_ = mclInitializeDouble(0.0);
    _mxarray8_ = mclInitializeDouble(2.220446049250313e-16);
}

void TerminateModule_contours(void) {
    mxDestroyArray(_mxarray8_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * mlfContours_veryclose(mxArray * a, mxArray * b);
static void mlxContours_veryclose(int nlhs,
                                  mxArray * plhs[],
                                  int nrhs,
                                  mxArray * prhs[]);
static mxArray * Mcontours(mxArray * * msg, int nargout_, mxArray * varargin);
static mxArray * Mcontours_veryclose(int nargout_, mxArray * a, mxArray * b);

static mexFunctionTableEntry local_function_table_[1]
  = { { "veryclose", mlxContours_veryclose, 2, 1, NULL } };

_mexLocalFunctionTable _local_function_table_contours
  = { 1, local_function_table_ };

/*
 * The function "mlfContours" contains the normal interface for the "contours"
 * M-function from file "c:\matlab6p5\toolbox\matlab\specgraph\contours.m"
 * (lines 1-176). This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
mxArray * mlfContours(mxArray * * msg, ...) {
    mxArray * varargin = NULL;
    int nargout = 1;
    mxArray * CS = NULL;
    mxArray * msg__ = NULL;
    mlfVarargin(&varargin, msg, 0);
    mlfEnterNewContext(1, -1, msg, varargin);
    if (msg != NULL) {
        ++nargout;
    }
    CS = Mcontours(&msg__, nargout, varargin);
    mlfRestorePreviousContext(1, 0, msg);
    mxDestroyArray(varargin);
    if (msg != NULL) {
        mclCopyOutputArg(msg, msg__);
    } else {
        mxDestroyArray(msg__);
    }
    return mlfReturnValue(CS);
}

/*
 * The function "mlxContours" contains the feval interface for the "contours"
 * M-function from file "c:\matlab6p5\toolbox\matlab\specgraph\contours.m"
 * (lines 1-176). The feval function calls the implementation version of
 * contours through this function. This function processes any input arguments
 * and passes them to the implementation version of the function, appearing
 * above.
 */
void mlxContours(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[2];
    int i;
    if (nlhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: contours Line: 1 Column:"
            " 1 The function \"contours\" was called with m"
            "ore than the declared number of outputs (2)."),
          NULL);
    }
    for (i = 0; i < 2; ++i) {
        mplhs[i] = NULL;
    }
    mlfEnterNewContext(0, 0);
    mprhs[0] = NULL;
    mlfAssign(&mprhs[0], mclCreateVararginCell(nrhs, prhs));
    mplhs[0] = Mcontours(&mplhs[1], nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 0);
    plhs[0] = mplhs[0];
    for (i = 1; i < 2 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 2; ++i) {
        mxDestroyArray(mplhs[i]);
    }
    mxDestroyArray(mprhs[0]);
}

/*
 * The function "mlfContours_veryclose" contains the normal interface for the
 * "contours/veryclose" M-function from file
 * "c:\matlab6p5\toolbox\matlab\specgraph\contours.m" (lines 176-180). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
static mxArray * mlfContours_veryclose(mxArray * a, mxArray * b) {
    int nargout = 1;
    mxArray * tf = NULL;
    mlfEnterNewContext(0, 2, a, b);
    tf = Mcontours_veryclose(nargout, a, b);
    mlfRestorePreviousContext(0, 2, a, b);
    return mlfReturnValue(tf);
}

/*
 * The function "mlxContours_veryclose" contains the feval interface for the
 * "contours/veryclose" M-function from file
 * "c:\matlab6p5\toolbox\matlab\specgraph\contours.m" (lines 176-180). The
 * feval function calls the implementation version of contours/veryclose
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
static void mlxContours_veryclose(int nlhs,
                                  mxArray * plhs[],
                                  int nrhs,
                                  mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: contours/veryclose Line: 176 Col"
            "umn: 1 The function \"contours/veryclose\" was called "
            "with more than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: contours/veryclose Line: 176 Co"
            "lumn: 1 The function \"contours/veryclose\" was calle"
            "d with more than the declared number of inputs (2)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mcontours_veryclose(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mcontours" is the implementation version of the "contours"
 * M-function from file "c:\matlab6p5\toolbox\matlab\specgraph\contours.m"
 * (lines 1-176). It contains the actual compiled code for that M-function. It
 * is a static function and must only be called from one of the interface
 * functions, appearing below.
 */
/*
 * function [CS,msg]=contours(varargin)
 */
static mxArray * Mcontours(mxArray * * msg, int nargout_, mxArray * varargin) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_contours);
    int nargin_ = mclNargin(-1, varargin, NULL);
    mxArray * CS = NULL;
    mxArray * dx = NULL;
    mxArray * dy = NULL;
    mxArray * Ibr = NULL;
    mxArray * Itr = NULL;
    mxArray * Itl = NULL;
    mxArray * Ibl = NULL;
    mxArray * fY = NULL;
    mxArray * cY = NULL;
    mxArray * fX = NULL;
    mxArray * cX = NULL;
    mxArray * Y = NULL;
    mxArray * X = NULL;
    mxArray * y = NULL;
    mxArray * x = NULL;
    mxArray * vy2 = NULL;
    mxArray * vx2 = NULL;
    mxArray * cpy = NULL;
    mxArray * cpx = NULL;
    mxArray * vy1 = NULL;
    mxArray * vx1 = NULL;
    mxArray * y2 = NULL;
    mxArray * x2 = NULL;
    mxArray * y1 = NULL;
    mxArray * x1 = NULL;
    mxArray * t = NULL;
    mxArray * md = NULL;
    mxArray * skewd = NULL;
    mxArray * lev = NULL;
    mxArray * nl = NULL;
    mxArray * k = NULL;
    mxArray * ii = NULL;
    mxArray * Nx = NULL;
    mxArray * Ny = NULL;
    mxArray * zz = NULL;
    mxArray * numarg_for_call = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&varargin);
    /*
     * %CONTOURS Contouring over non-rectangular surface.
     * %   CONTOURS calculates the contour matrix C for use by CONTOUR,
     * %       CONTOUR3, or CONTOURF to draw the actual contour plot.
     * %   CONTOURS(...) is the same as CONTOURC except CONTOURS(X,Y,Z,...)
     * %       allows the specification of parametric surfaces (as for SURF).
     * %   C = CONTOURS(Z) computes the contour matrix for a contour plot
     * %      of matrix Z treating the values in Z as heights above a plane.
     * %   C = CONTOURS(X,Y,Z), where X and Y are vectors, specifies the X- 
     * %      and Y-axes limits for Z. X and Y can also be matrices of the
     * %      same size as Z, in which case they specify a surface as for SURF. 
     * %   CONTOURS(Z,N) and CONTOURS(X,Y,Z,N) compute N contour lines, 
     * %      overriding the default automatic value.
     * %   CONTOURS(Z,V) and CONTOURS(X,Y,Z,V) compute LENGTH(V) contour 
     * %      lines at the values specified in vector V.
     * %   
     * %   The contour matrix C is a two row matrix of contour lines. Each
     * %   contiguous drawing segment contains the value of the contour, 
     * %   the number of (x,y) drawing pairs, and the pairs themselves.  
     * %   The segments are appended end-to-end as
     * % 
     * %       C = [level1 x1 x2 x3 ... level2 x2 x2 x3 ...;
     * %            pairs1 y1 y2 y3 ... pairs2 y2 y2 y3 ...]
     * % 
     * %   See also CONTOUR, CONTOUR3 and CONTOURF.
     * 
     * %   Copyright 1984-2002 The MathWorks, Inc. 
     * %   $Revision: 1.18 $  $Date: 2002/06/05 17:52:52 $
     * 
     * % Author: R. Pawlowicz (IOS) rich@ios.bc.ca
     * %         12/12/94
     * 
     * error(nargchk(1,4,nargin));
     */
    mlfError(mlfNargchk(_mxarray0_, _mxarray1_, mlfScalar(nargin_)), NULL);
    /*
     * msg = [];
     */
    mlfAssign(msg, _mxarray2_);
    /*
     * if (nargin <=2),
     */
    if (nargin_ <= 2) {
        /*
         * numarg_for_call = 1:nargin;
         */
        mlfAssign(
          &numarg_for_call, mlfColon(_mxarray0_, mlfScalar(nargin_), NULL));
        /*
         * if ~isa(varargin{1}, 'double')
         */
        if (mclNotBool(
              mclFeval(
                mclValueVarargout(),
                mlxIsa,
                mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray0_),
                _mxarray3_,
                NULL))) {
            /*
             * varargin{1} = double(varargin{1});
             */
            mlfIndexAssign(
              &varargin,
              "{?}",
              _mxarray0_,
              mclFeval(
                mclValueVarargout(),
                mlxDouble,
                mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray0_),
                NULL));
        /*
         * end
         */
        }
        /*
         * zz=varargin{1};
         */
        mlfAssign(
          &zz, mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray0_));
    /*
     * else
     */
    } else {
        /*
         * numarg_for_call= 3:nargin;
         */
        mlfAssign(
          &numarg_for_call, mlfColon(_mxarray5_, mlfScalar(nargin_), NULL));
        /*
         * if ~isa(varargin{1}, 'double')
         */
        if (mclNotBool(
              mclFeval(
                mclValueVarargout(),
                mlxIsa,
                mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray0_),
                _mxarray3_,
                NULL))) {
            /*
             * varargin{1} = double(varargin{1});
             */
            mlfIndexAssign(
              &varargin,
              "{?}",
              _mxarray0_,
              mclFeval(
                mclValueVarargout(),
                mlxDouble,
                mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray0_),
                NULL));
        /*
         * end
         */
        }
        /*
         * if ~isa(varargin{2}, 'double')
         */
        if (mclNotBool(
              mclFeval(
                mclValueVarargout(),
                mlxIsa,
                mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray6_),
                _mxarray3_,
                NULL))) {
            /*
             * varargin{2} = double(varargin{2});
             */
            mlfIndexAssign(
              &varargin,
              "{?}",
              _mxarray6_,
              mclFeval(
                mclValueVarargout(),
                mlxDouble,
                mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray6_),
                NULL));
        /*
         * end
         */
        }
        /*
         * if ~isa(varargin{3}, 'double')
         */
        if (mclNotBool(
              mclFeval(
                mclValueVarargout(),
                mlxIsa,
                mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray5_),
                _mxarray3_,
                NULL))) {
            /*
             * varargin{3} = double(varargin{3});
             */
            mlfIndexAssign(
              &varargin,
              "{?}",
              _mxarray5_,
              mclFeval(
                mclValueVarargout(),
                mlxDouble,
                mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray5_),
                NULL));
        /*
         * end
         */
        }
        /*
         * zz=varargin{3};
         */
        mlfAssign(
          &zz, mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray5_));
        /*
         * msg = xyzchk(varargin{1:3});
         */
        mlfAssign(
          msg,
          mclFeval(
            mclValueVarargout(),
            mlxXyzchk,
            mlfIndexRef(
              mclVa(varargin, "varargin"),
              "{?}",
              mlfColon(_mxarray0_, _mxarray5_, NULL)),
            NULL));
        /*
         * if ~isempty(msg), CS = []; return, end
         */
        if (mclNotBool(mlfIsempty(mclVv(*msg, "msg")))) {
            mlfAssign(&CS, _mxarray2_);
            goto return_;
        }
    /*
     * end; 
     */
    }
    /*
     * 
     * CS=contourc(varargin{numarg_for_call});
     */
    mlfAssign(
      &CS,
      mlfNContourc(
        1,
        mlfIndexRef(
          mclVa(varargin, "varargin"),
          "{?}",
          mclVv(numarg_for_call, "numarg_for_call")),
        NULL));
    /*
     * [Ny,Nx]=size(zz);
     */
    mlfSize(mlfVarargout(&Ny, &Nx, NULL), mclVv(zz, "zz"), NULL);
    /*
     * 
     * % Find data values and check curve orientation.
     * 
     * ii= ones(1,size(CS,2))~=0;
     */
    mlfAssign(
      &ii,
      mclNe(
        mlfOnes(
          _mxarray0_,
          mlfSize(mclValueVarargout(), mclVv(CS, "CS"), _mxarray6_),
          NULL),
        _mxarray7_));
    /*
     * k=1;
     */
    mlfAssign(&k, _mxarray0_);
    /*
     * while (k < size(CS,2)),
     */
    while (mclLtBool(
             mclVv(k, "k"),
             mlfSize(mclValueVarargout(), mclVv(CS, "CS"), _mxarray6_))) {
        /*
         * nl=CS(2,k);
         */
        mlfAssign(
          &nl, mclArrayRef2(mclVv(CS, "CS"), _mxarray6_, mclVv(k, "k")));
        /*
         * 
         * % Now this is a little bit of magic needed to make the filled contours
         * % work. Essentially I draw the *closed* contours so that the "high" side is
         * % always on the right. To test this, I take the cross product of the
         * % first vector with a vector to a corner point and test the sign
         * % against the elevation change. There are several special cases:
         * % (1) If the contour line goes through a point (which happen when -Infs
         * % are around), and (2) when the contour level equals the level on the high
         * % side (this always seems to happen in 'simple test' cases!). We take
         * % care of (1) by choosing other points, and we take care of (2) by adding
         * % eps to the data before comparing with the contour data.
         * 
         * if ( CS(:,k+1)==CS(:,k+nl) & nl>1 ),
         */
        {
            mxArray * a_
              = mclInitialize(
                  mclEq(
                    mclArrayRef2(
                      mclVv(CS, "CS"),
                      mlfCreateColonIndex(),
                      mclPlus(mclVv(k, "k"), _mxarray0_)),
                    mclArrayRef2(
                      mclVv(CS, "CS"),
                      mlfCreateColonIndex(),
                      mclPlus(mclVv(k, "k"), mclVv(nl, "nl")))));
            if (mlfTobool(a_)
                && mlfTobool(mclAnd(a_, mclGt(mclVv(nl, "nl"), _mxarray0_)))) {
                mxDestroyArray(a_);
                /*
                 * lev=CS(1,k);
                 */
                mlfAssign(
                  &lev,
                  mclArrayRef2(mclVv(CS, "CS"), _mxarray0_, mclVv(k, "k")));
                /*
                 * 
                 * % Use manhattan distance to find a line segment that is the
                 * % farthest away from being on the grid (skewd is an integer
                 * % when a line segment is aligned with the grid so we look
                 * % for the "least integer-like" distance).
                 * skewd=abs(diff(CS(1,k+1:k+nl)))+abs(diff(CS(2,k+1:k+nl)));
                 */
                mlfAssign(
                  &skewd,
                  mclPlus(
                    mlfAbs(
                      mlfDiff(
                        mclArrayRef2(
                          mclVv(CS, "CS"),
                          _mxarray0_,
                          mlfColon(
                            mclPlus(mclVv(k, "k"), _mxarray0_),
                            mclPlus(mclVv(k, "k"), mclVv(nl, "nl")),
                            NULL)),
                        NULL,
                        NULL)),
                    mlfAbs(
                      mlfDiff(
                        mclArrayRef2(
                          mclVv(CS, "CS"),
                          _mxarray6_,
                          mlfColon(
                            mclPlus(mclVv(k, "k"), _mxarray0_),
                            mclPlus(mclVv(k, "k"), mclVv(nl, "nl")),
                            NULL)),
                        NULL,
                        NULL))));
                /*
                 * skewd=abs(skewd-round(skewd));
                 */
                mlfAssign(
                  &skewd,
                  mlfAbs(
                    mclMinus(
                      mclVv(skewd, "skewd"), mlfRound(mclVv(skewd, "skewd")))));
                /*
                 * [md,t]=max(skewd);
                 */
                mlfAssign(&md, mlfMax(&t, mclVv(skewd, "skewd"), NULL, NULL));
                /*
                 * if isempty(t), t = 1; end
                 */
                if (mlfTobool(mlfIsempty(mclVv(t, "t")))) {
                    mlfAssign(&t, _mxarray0_);
                }
                /*
                 * 
                 * x1=CS(1,k+t); y1=CS(2,k+t);
                 */
                mlfAssign(
                  &x1,
                  mclArrayRef2(
                    mclVv(CS, "CS"),
                    _mxarray0_,
                    mclPlus(mclVv(k, "k"), mclVv(t, "t"))));
                mlfAssign(
                  &y1,
                  mclArrayRef2(
                    mclVv(CS, "CS"),
                    _mxarray6_,
                    mclPlus(mclVv(k, "k"), mclVv(t, "t"))));
                /*
                 * x2=CS(1,k+t+1); y2=CS(2,k+t+1);
                 */
                mlfAssign(
                  &x2,
                  mclArrayRef2(
                    mclVv(CS, "CS"),
                    _mxarray0_,
                    mclPlus(
                      mclPlus(mclVv(k, "k"), mclVv(t, "t")), _mxarray0_)));
                mlfAssign(
                  &y2,
                  mclArrayRef2(
                    mclVv(CS, "CS"),
                    _mxarray6_,
                    mclPlus(
                      mclPlus(mclVv(k, "k"), mclVv(t, "t")), _mxarray0_)));
                /*
                 * vx1=x2-x1; vy1=y2-y1;
                 */
                mlfAssign(&vx1, mclMinus(mclVv(x2, "x2"), mclVv(x1, "x1")));
                mlfAssign(&vy1, mclMinus(mclVv(y2, "y2"), mclVv(y1, "y1")));
                /*
                 * cpx=round(x1); cpy=round(y1);
                 */
                mlfAssign(&cpx, mlfRound(mclVv(x1, "x1")));
                mlfAssign(&cpy, mlfRound(mclVv(y1, "y1")));
                /*
                 * if veryclose([cpx cpy],[x1 y1])
                 */
                if (mlfTobool(
                      mlfContours_veryclose(
                        mlfHorzcat(mclVv(cpx, "cpx"), mclVv(cpy, "cpy"), NULL),
                        mlfHorzcat(mclVv(x1, "x1"), mclVv(y1, "y1"), NULL)))) {
                    /*
                     * cpx=round(x2); cpy=round(y2);
                     */
                    mlfAssign(&cpx, mlfRound(mclVv(x2, "x2")));
                    mlfAssign(&cpy, mlfRound(mclVv(y2, "y2")));
                    /*
                     * if veryclose([cpx cpy],[x2 y2]),
                     */
                    if (mlfTobool(
                          mlfContours_veryclose(
                            mlfHorzcat(
                              mclVv(cpx, "cpx"), mclVv(cpy, "cpy"), NULL),
                            mlfHorzcat(
                              mclVv(x2, "x2"), mclVv(y2, "y2"), NULL)))) {
                        /*
                         * % If we've made it to here, the contour line is along a
                         * % grid line.  It is also possible we're on a ridge or valley.  
                         * % If so, filled ridge or valley contours will be drawn 
                         * % with the same color on both sides.
                         * if [cpx cpy]~=round([x1 y1]), % Diagonal contour
                         */
                        if (mclNeBool(
                              mlfHorzcat(
                                mclVv(cpx, "cpx"), mclVv(cpy, "cpy"), NULL),
                              mlfRound(
                                mlfHorzcat(
                                  mclVv(x1, "x1"), mclVv(y1, "y1"), NULL)))) {
                            /*
                             * cpx=round(x1);
                             */
                            mlfAssign(&cpx, mlfRound(mclVv(x1, "x1")));
                        /*
                         * else % edge contour
                         */
                        } else {
                            /*
                             * cpx=round(x1)+round(y2-y1);
                             */
                            mlfAssign(
                              &cpx,
                              mclPlus(
                                mlfRound(mclVv(x1, "x1")),
                                mlfRound(
                                  mclMinus(mclVv(y2, "y2"), mclVv(y1, "y1")))));
                            /*
                             * cpy=round(y1)-round(x2-x1);
                             */
                            mlfAssign(
                              &cpy,
                              mclMinus(
                                mlfRound(mclVv(y1, "y1")),
                                mlfRound(
                                  mclMinus(mclVv(x2, "x2"), mclVv(x1, "x1")))));
                            /*
                             * % Make sure the values stay in bounds (stay at least one pixel
                             * % away from the edge since filled contours put NaNs there).
                             * if (cpx < 2) | (cpx > size(zz,2)-1)
                             */
                            {
                                mxArray * a_0
                                  = mclInitialize(
                                      mclLt(mclVv(cpx, "cpx"), _mxarray6_));
                                if (mlfTobool(a_0)
                                    || mlfTobool(
                                         mclOr(
                                           a_0,
                                           mclGt(
                                             mclVv(cpx, "cpx"),
                                             mclMinus(
                                               mlfSize(
                                                 mclValueVarargout(),
                                                 mclVv(zz, "zz"),
                                                 _mxarray6_),
                                               _mxarray0_))))) {
                                    mxDestroyArray(a_0);
                                    /*
                                     * cpx=round(x1)-round(y2-y1);
                                     */
                                    mlfAssign(
                                      &cpx,
                                      mclMinus(
                                        mlfRound(mclVv(x1, "x1")),
                                        mlfRound(
                                          mclMinus(
                                            mclVv(y2, "y2"),
                                            mclVv(y1, "y1")))));
                                } else {
                                    mxDestroyArray(a_0);
                                }
                            /*
                             * end
                             */
                            }
                            /*
                             * if (cpy < 2) | (cpy > size(zz,1)-1)
                             */
                            {
                                mxArray * a_1
                                  = mclInitialize(
                                      mclLt(mclVv(cpy, "cpy"), _mxarray6_));
                                if (mlfTobool(a_1)
                                    || mlfTobool(
                                         mclOr(
                                           a_1,
                                           mclGt(
                                             mclVv(cpy, "cpy"),
                                             mclMinus(
                                               mlfSize(
                                                 mclValueVarargout(),
                                                 mclVv(zz, "zz"),
                                                 _mxarray0_),
                                               _mxarray0_))))) {
                                    mxDestroyArray(a_1);
                                    /*
                                     * cpy=round(y1)+round(x2-x1);
                                     */
                                    mlfAssign(
                                      &cpy,
                                      mclPlus(
                                        mlfRound(mclVv(y1, "y1")),
                                        mlfRound(
                                          mclMinus(
                                            mclVv(x2, "x2"),
                                            mclVv(x1, "x1")))));
                                } else {
                                    mxDestroyArray(a_1);
                                }
                            /*
                             * end
                             */
                            }
                        /*
                         * end;
                         */
                        }
                    /*
                     * end;
                     */
                    }
                /*
                 * end;
                 */
                }
                /*
                 * vx2=cpx-x1; vy2=cpy-y1;
                 */
                mlfAssign(&vx2, mclMinus(mclVv(cpx, "cpx"), mclVv(x1, "x1")));
                mlfAssign(&vy2, mclMinus(mclVv(cpy, "cpy"), mclVv(y1, "y1")));
                /*
                 * if ( sign(zz(cpy,cpx)-lev+eps) == sign(vx1*vy2-vx2*vy1)  ),
                 */
                if (mclEqBool(
                      mlfSign(
                        mclPlus(
                          mclMinus(
                            mclArrayRef2(
                              mclVv(zz, "zz"),
                              mclVv(cpy, "cpy"),
                              mclVv(cpx, "cpx")),
                            mclVv(lev, "lev")),
                          _mxarray8_)),
                      mlfSign(
                        mclMinus(
                          mclMtimes(mclVv(vx1, "vx1"), mclVv(vy2, "vy2")),
                          mclMtimes(mclVv(vx2, "vx2"), mclVv(vy1, "vy1")))))) {
                    /*
                     * CS(:,k+(1:nl))=fliplr(CS(:,k+(1:nl)));
                     */
                    mclArrayAssign2(
                      &CS,
                      mlfFliplr(
                        mclArrayRef2(
                          mclVv(CS, "CS"),
                          mlfCreateColonIndex(),
                          mclPlus(
                            mclVv(k, "k"),
                            mlfColon(_mxarray0_, mclVv(nl, "nl"), NULL)))),
                      mlfCreateColonIndex(),
                      mclPlus(
                        mclVv(k, "k"),
                        mlfColon(_mxarray0_, mclVv(nl, "nl"), NULL)));
                /*
                 * end; 
                 */
                }
            } else {
                mxDestroyArray(a_);
            }
        /*
         * end;
         */
        }
        /*
         * ii(k)=0;
         */
        mclArrayAssign1(&ii, _mxarray7_, mclVv(k, "k"));
        /*
         * k=k+1+nl;
         */
        mlfAssign(
          &k, mclPlus(mclPlus(mclVv(k, "k"), _mxarray0_), mclVv(nl, "nl")));
    /*
     * end;
     */
    }
    /*
     * 
     * % Data from integer coords to data coords. There are 3 cases
     * % (1) Matrix X/Y
     * % (2) Vector X/Y
     * % (3) no X/Y. (do nothing);
     * 
     * if nargin>2,
     */
    if (nargin_ > 2) {
        /*
         * x = varargin{1};  
         */
        mlfAssign(
          &x, mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray0_));
        /*
         * y = varargin{2};
         */
        mlfAssign(
          &y, mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray6_));
    /*
     * end
     */
    }
    /*
     * 
     * if isempty(CS)
     */
    if (mlfTobool(mlfIsempty(mclVv(CS, "CS")))) {
    /*
     * % Nothing to do
     * elseif (nargin > 2) & (min(size(varargin{1})) > 1),
     */
    } else {
        mxArray * a_ = mclInitialize(mclBoolToArray(nargin_ > 2));
        if (mlfTobool(a_)
            && mlfTobool(
                 mclAnd(
                   a_,
                   mclGt(
                     mlfMin(
                       NULL,
                       mclFeval(
                         mclValueVarargout(),
                         mlxSize,
                         mlfIndexRef(
                           mclVa(varargin, "varargin"), "{?}", _mxarray0_),
                         NULL),
                       NULL,
                       NULL),
                     _mxarray0_)))) {
            mxDestroyArray(a_);
            /*
             * 
             * X=CS(1,ii)';   Y=CS(2,ii)';
             */
            mlfAssign(
              &X,
              mlfCtranspose(
                mclArrayRef2(mclVv(CS, "CS"), _mxarray0_, mclVv(ii, "ii"))));
            mlfAssign(
              &Y,
              mlfCtranspose(
                mclArrayRef2(mclVv(CS, "CS"), _mxarray6_, mclVv(ii, "ii"))));
            /*
             * cX=ceil(X);    fX=floor(X);
             */
            mlfAssign(&cX, mlfCeil(mclVv(X, "X")));
            mlfAssign(&fX, mlfFloor(mclVv(X, "X")));
            /*
             * cY=ceil(Y);    fY=floor(Y);
             */
            mlfAssign(&cY, mlfCeil(mclVv(Y, "Y")));
            mlfAssign(&fY, mlfFloor(mclVv(Y, "Y")));
            /*
             * 
             * 
             * Ibl=cY+(fX-1)*Ny;    Itl=fY+(fX-1)*Ny;
             */
            mlfAssign(
              &Ibl,
              mclPlus(
                mclVv(cY, "cY"),
                mclMtimes(
                  mclMinus(mclVv(fX, "fX"), _mxarray0_), mclVv(Ny, "Ny"))));
            mlfAssign(
              &Itl,
              mclPlus(
                mclVv(fY, "fY"),
                mclMtimes(
                  mclMinus(mclVv(fX, "fX"), _mxarray0_), mclVv(Ny, "Ny"))));
            /*
             * Itr=fY+(cX-1)*Ny;    Ibr=cY+(cX-1)*Ny;
             */
            mlfAssign(
              &Itr,
              mclPlus(
                mclVv(fY, "fY"),
                mclMtimes(
                  mclMinus(mclVv(cX, "cX"), _mxarray0_), mclVv(Ny, "Ny"))));
            mlfAssign(
              &Ibr,
              mclPlus(
                mclVv(cY, "cY"),
                mclMtimes(
                  mclMinus(mclVv(cX, "cX"), _mxarray0_), mclVv(Ny, "Ny"))));
            /*
             * 
             * dy=cY-Y; dx=X-fX;
             */
            mlfAssign(&dy, mclMinus(mclVv(cY, "cY"), mclVv(Y, "Y")));
            mlfAssign(&dx, mclMinus(mclVv(X, "X"), mclVv(fX, "fX")));
            /*
             * 
             * CS(1,ii) = [ x(Ibl).*(1-dx).*(1-dy) + x(Itl).* (1-dx).*dy + ...
             */
            mclArrayAssign2(
              &CS,
              mlfCtranspose(
                mclPlus(
                  mclPlus(
                    mclPlus(
                      mclTimes(
                        mclTimes(
                          mclArrayRef1(mclVv(x, "x"), mclVv(Ibl, "Ibl")),
                          mclMinus(_mxarray0_, mclVv(dx, "dx"))),
                        mclMinus(_mxarray0_, mclVv(dy, "dy"))),
                      mclTimes(
                        mclTimes(
                          mclArrayRef1(mclVv(x, "x"), mclVv(Itl, "Itl")),
                          mclMinus(_mxarray0_, mclVv(dx, "dx"))),
                        mclVv(dy, "dy"))),
                    mclTimes(
                      mclTimes(
                        mclArrayRef1(mclVv(x, "x"), mclVv(Itr, "Itr")),
                        mclVv(dx, "dx")),
                      mclVv(dy, "dy"))),
                  mclTimes(
                    mclTimes(
                      mclArrayRef1(mclVv(x, "x"), mclVv(Ibr, "Ibr")),
                      mclVv(dx, "dx")),
                    mclMinus(_mxarray0_, mclVv(dy, "dy"))))),
              _mxarray0_,
              mclVv(ii, "ii"));
            /*
             * x(Itr).*dx.*dy + x(Ibr).*dx.*(1-dy) ]';
             * CS(2,ii) = [ y(Ibl).*(1-dx).*(1-dy) + y(Itl).*(1-dx).*dy + ...
             */
            mclArrayAssign2(
              &CS,
              mlfCtranspose(
                mclPlus(
                  mclPlus(
                    mclPlus(
                      mclTimes(
                        mclTimes(
                          mclArrayRef1(mclVv(y, "y"), mclVv(Ibl, "Ibl")),
                          mclMinus(_mxarray0_, mclVv(dx, "dx"))),
                        mclMinus(_mxarray0_, mclVv(dy, "dy"))),
                      mclTimes(
                        mclTimes(
                          mclArrayRef1(mclVv(y, "y"), mclVv(Itl, "Itl")),
                          mclMinus(_mxarray0_, mclVv(dx, "dx"))),
                        mclVv(dy, "dy"))),
                    mclTimes(
                      mclTimes(
                        mclArrayRef1(mclVv(y, "y"), mclVv(Itr, "Itr")),
                        mclVv(dx, "dx")),
                      mclVv(dy, "dy"))),
                  mclTimes(
                    mclTimes(
                      mclArrayRef1(mclVv(y, "y"), mclVv(Ibr, "Ibr")),
                      mclVv(dx, "dx")),
                    mclMinus(_mxarray0_, mclVv(dy, "dy"))))),
              _mxarray6_,
              mclVv(ii, "ii"));
        /*
         * y(Itr).*dx.*dy + y(Ibr).*dx.*(1-dy) ]';
         * 
         * elseif (nargin>2 & min(size(x))==1 ),
         */
        } else {
            mxDestroyArray(a_);
            {
                mxArray * a_2 = mclInitialize(mclBoolToArray(nargin_ > 2));
                if (mlfTobool(a_2)
                    && mlfTobool(
                         mclAnd(
                           a_2,
                           mclEq(
                             mlfMin(
                               NULL,
                               mlfSize(
                                 mclValueVarargout(), mclVv(x, "x"), NULL),
                               NULL,
                               NULL),
                             _mxarray0_)))) {
                    mxDestroyArray(a_2);
                    /*
                     * X=CS(1,ii);  Y=CS(2,ii);
                     */
                    mlfAssign(
                      &X,
                      mclArrayRef2(
                        mclVv(CS, "CS"), _mxarray0_, mclVv(ii, "ii")));
                    mlfAssign(
                      &Y,
                      mclArrayRef2(
                        mclVv(CS, "CS"), _mxarray6_, mclVv(ii, "ii")));
                    /*
                     * cX=ceil(X); fX=floor(X);
                     */
                    mlfAssign(&cX, mlfCeil(mclVv(X, "X")));
                    mlfAssign(&fX, mlfFloor(mclVv(X, "X")));
                    /*
                     * cY=ceil(Y); fY=floor(Y);
                     */
                    mlfAssign(&cY, mlfCeil(mclVv(Y, "Y")));
                    mlfAssign(&fY, mlfFloor(mclVv(Y, "Y")));
                    /*
                     * 
                     * dy=cY-Y;    dx=X-fX;
                     */
                    mlfAssign(&dy, mclMinus(mclVv(cY, "cY"), mclVv(Y, "Y")));
                    mlfAssign(&dx, mclMinus(mclVv(X, "X"), mclVv(fX, "fX")));
                    /*
                     * 
                     * if (size(x,2)==1), 
                     */
                    if (mclEqBool(
                          mlfSize(
                            mclValueVarargout(), mclVv(x, "x"), _mxarray6_),
                          _mxarray0_)) {
                        /*
                         * CS(1,ii)=[x(fX)'.*(1-dx)+x(cX)'.*dx];
                         */
                        mclArrayAssign2(
                          &CS,
                          mclPlus(
                            mclTimes(
                              mlfCtranspose(
                                mclArrayRef1(mclVv(x, "x"), mclVv(fX, "fX"))),
                              mclMinus(_mxarray0_, mclVv(dx, "dx"))),
                            mclTimes(
                              mlfCtranspose(
                                mclArrayRef1(mclVv(x, "x"), mclVv(cX, "cX"))),
                              mclVv(dx, "dx"))),
                          _mxarray0_,
                          mclVv(ii, "ii"));
                    /*
                     * else
                     */
                    } else {
                        /*
                         * CS(1,ii)=[x(fX).*(1-dx)+x(cX).*dx];
                         */
                        mclArrayAssign2(
                          &CS,
                          mclPlus(
                            mclTimes(
                              mclArrayRef1(mclVv(x, "x"), mclVv(fX, "fX")),
                              mclMinus(_mxarray0_, mclVv(dx, "dx"))),
                            mclTimes(
                              mclArrayRef1(mclVv(x, "x"), mclVv(cX, "cX")),
                              mclVv(dx, "dx"))),
                          _mxarray0_,
                          mclVv(ii, "ii"));
                    /*
                     * end;
                     */
                    }
                    /*
                     * 
                     * if (size(y,2)==1), 
                     */
                    if (mclEqBool(
                          mlfSize(
                            mclValueVarargout(), mclVv(y, "y"), _mxarray6_),
                          _mxarray0_)) {
                        /*
                         * CS(2,ii)=[y(fY)'.*dy+y(cY)'.*(1-dy)]; 
                         */
                        mclArrayAssign2(
                          &CS,
                          mclPlus(
                            mclTimes(
                              mlfCtranspose(
                                mclArrayRef1(mclVv(y, "y"), mclVv(fY, "fY"))),
                              mclVv(dy, "dy")),
                            mclTimes(
                              mlfCtranspose(
                                mclArrayRef1(mclVv(y, "y"), mclVv(cY, "cY"))),
                              mclMinus(_mxarray0_, mclVv(dy, "dy")))),
                          _mxarray6_,
                          mclVv(ii, "ii"));
                    /*
                     * else
                     */
                    } else {
                        /*
                         * CS(2,ii)=[y(fY).*dy+y(cY).*(1-dy)]; 
                         */
                        mclArrayAssign2(
                          &CS,
                          mclPlus(
                            mclTimes(
                              mclArrayRef1(mclVv(y, "y"), mclVv(fY, "fY")),
                              mclVv(dy, "dy")),
                            mclTimes(
                              mclArrayRef1(mclVv(y, "y"), mclVv(cY, "cY")),
                              mclMinus(_mxarray0_, mclVv(dy, "dy")))),
                          _mxarray6_,
                          mclVv(ii, "ii"));
                    /*
                     * end;
                     */
                    }
                } else {
                    mxDestroyArray(a_2);
                }
            }
        }
    /*
     * 
     * end;
     */
    }
    /*
     * 
     */
    return_:
    mclValidateOutput(CS, 1, nargout_, "CS", "contours");
    mclValidateOutput(*msg, 2, nargout_, "msg", "contours");
    mxDestroyArray(ans);
    mxDestroyArray(numarg_for_call);
    mxDestroyArray(zz);
    mxDestroyArray(Ny);
    mxDestroyArray(Nx);
    mxDestroyArray(ii);
    mxDestroyArray(k);
    mxDestroyArray(nl);
    mxDestroyArray(lev);
    mxDestroyArray(skewd);
    mxDestroyArray(md);
    mxDestroyArray(t);
    mxDestroyArray(x1);
    mxDestroyArray(y1);
    mxDestroyArray(x2);
    mxDestroyArray(y2);
    mxDestroyArray(vx1);
    mxDestroyArray(vy1);
    mxDestroyArray(cpx);
    mxDestroyArray(cpy);
    mxDestroyArray(vx2);
    mxDestroyArray(vy2);
    mxDestroyArray(x);
    mxDestroyArray(y);
    mxDestroyArray(X);
    mxDestroyArray(Y);
    mxDestroyArray(cX);
    mxDestroyArray(fX);
    mxDestroyArray(cY);
    mxDestroyArray(fY);
    mxDestroyArray(Ibl);
    mxDestroyArray(Itl);
    mxDestroyArray(Itr);
    mxDestroyArray(Ibr);
    mxDestroyArray(dy);
    mxDestroyArray(dx);
    mxDestroyArray(varargin);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return CS;
}

/*
 * The function "Mcontours_veryclose" is the implementation version of the
 * "contours/veryclose" M-function from file
 * "c:\matlab6p5\toolbox\matlab\specgraph\contours.m" (lines 176-180). It
 * contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function tf = veryclose(a,b)
 */
static mxArray * Mcontours_veryclose(int nargout_, mxArray * a, mxArray * b) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_contours);
    mxArray * tf = NULL;
    mclCopyArray(&a);
    mclCopyArray(&b);
    /*
     * % Return true if the two inputs are very close to each other
     * tf = all(abs(a-b) <= sqrt(eps)*max(abs(a),abs(b)));
     */
    mlfAssign(
      &tf,
      mlfAll(
        mclLe(
          mlfAbs(mclMinus(mclVa(a, "a"), mclVa(b, "b"))),
          mclMtimes(
            mlfSqrt(_mxarray8_),
            mlfMax(NULL, mlfAbs(mclVa(a, "a")), mlfAbs(mclVa(b, "b")), NULL))),
        NULL));
    mclValidateOutput(tf, 1, nargout_, "tf", "contours/veryclose");
    mxDestroyArray(b);
    mxDestroyArray(a);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return tf;
    /*
     * 
     */
}
