/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:30 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "deg2rad.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

static mxChar _array3_[49] = { 'I', 'm', 'a', 'g', 'i', 'n', 'a', 'r', 'y', ' ',
                               'p', 'a', 'r', 't', 's', ' ', 'o', 'f', ' ', 'c',
                               'o', 'm', 'p', 'l', 'e', 'x', ' ', 'A', 'N', 'G',
                               'L', 'E', ' ', 'a', 'r', 'g', 'u', 'm', 'e', 'n',
                               't', ' ', 'i', 'g', 'n', 'o', 'r', 'e', 'd' };
static mxArray * _mxarray2_;
static mxArray * _mxarray4_;
static mxArray * _mxarray5_;

void InitializeModule_deg2rad(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeString(49, _array3_);
    _mxarray4_ = mclInitializeDouble(3.141592653589793);
    _mxarray5_ = mclInitializeDouble(180.0);
}

void TerminateModule_deg2rad(void) {
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mdeg2rad(int nargout_, mxArray * D);

_mexLocalFunctionTable _local_function_table_deg2rad
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfDeg2rad" contains the normal interface for the "deg2rad"
 * M-function from file "c:\matlab6p5\toolbox\map\map\deg2rad.m" (lines 1-22).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfDeg2rad(mxArray * D) {
    int nargout = 1;
    mxArray * R = NULL;
    mlfEnterNewContext(0, 1, D);
    R = Mdeg2rad(nargout, D);
    mlfRestorePreviousContext(0, 1, D);
    return mlfReturnValue(R);
}

/*
 * The function "mlxDeg2rad" contains the feval interface for the "deg2rad"
 * M-function from file "c:\matlab6p5\toolbox\map\map\deg2rad.m" (lines 1-22).
 * The feval function calls the implementation version of deg2rad through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxDeg2rad(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: deg2rad Line: 1 Column: "
            "1 The function \"deg2rad\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: deg2rad Line: 1 Column:"
            " 1 The function \"deg2rad\" was called with m"
            "ore than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mdeg2rad(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mdeg2rad" is the implementation version of the "deg2rad"
 * M-function from file "c:\matlab6p5\toolbox\map\map\deg2rad.m" (lines 1-22).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function R=deg2rad(D)
 */
static mxArray * Mdeg2rad(int nargout_, mxArray * D) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_deg2rad);
    int nargin_ = mclNargin(1, D, NULL);
    mxArray * R = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&D);
    /*
     * 
     * %DEG2RAD Converts angles from degrees to radians
     * %
     * %  rad = DEG2RAD(deg) converts angles from degrees to radians.
     * %
     * %  See also RAD2DEG, DEG2DMS, ANGLEDIM, ANGL2STR
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:25:00 $
     * 
     * 
     * if nargin==0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif ~isreal(D)
     */
    } else if (mclNotBool(mlfIsreal(mclVa(D, "D")))) {
        /*
         * warning('Imaginary parts of complex ANGLE argument ignored')
         */
        mclPrintAns(&ans, mlfNWarning(0, NULL, _mxarray2_, NULL));
        /*
         * D = real(D);
         */
        mlfAssign(&D, mlfReal(mclVa(D, "D")));
    /*
     * end
     */
    }
    /*
     * 
     * R = D*pi/180;
     */
    mlfAssign(
      &R, mclMrdivide(mclMtimes(mclVa(D, "D"), _mxarray4_), _mxarray5_));
    mclValidateOutput(R, 1, nargout_, "R", "deg2rad");
    mxDestroyArray(ans);
    mxDestroyArray(D);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return R;
}
