/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:35 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "distortcalc.h"
#include "angledim.h"
#include "gcm.h"
#include "libmatlbm.h"
#include "libmmfile.h"
#include "vfwdtran.h"
static mxArray * _mxarray0_;
static mxArray * _mxarray1_;
static mxArray * _mxarray2_;
static mxArray * _mxarray3_;

static mxChar _array5_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray4_;
static mxArray * _mxarray6_;

static mxChar _array8_[7] = { 'r', 'a', 'd', 'i', 'a', 'n', 's' };
static mxArray * _mxarray7_;
static mxArray * _mxarray9_;

static mxChar _array11_[7] = { 'd', 'e', 'g', 'r', 'e', 'e', 's' };
static mxArray * _mxarray10_;

static mxChar _array13_[3] = { 'o', 'f', 'f' };
static mxArray * _mxarray12_;

void InitializeModule_distortcalc(void) {
    _mxarray0_ = mclInitializeDouble(1.0);
    _mxarray1_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray2_ = mclInitializeDouble(2.0);
    _mxarray3_ = mclInitializeDouble(3.0);
    _mxarray4_ = mclInitializeString(29, _array5_);
    _mxarray6_ = mclInitializeDouble(0.0);
    _mxarray7_ = mclInitializeString(7, _array8_);
    _mxarray9_ = mclInitializeDouble(90.0);
    _mxarray10_ = mclInitializeString(7, _array11_);
    _mxarray12_ = mclInitializeString(3, _array13_);
}

void TerminateModule_distortcalc(void) {
    mxDestroyArray(_mxarray12_);
    mxDestroyArray(_mxarray10_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mdistortcalc(mxArray * * angdef,
                              mxArray * * maxscale,
                              mxArray * * minscale,
                              mxArray * * merscale,
                              mxArray * * parscale,
                              int nargout_,
                              mxArray * varargin);

_mexLocalFunctionTable _local_function_table_distortcalc
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfNDistortcalc" contains the nargout interface for the
 * "distortcalc" M-function from file
 * "c:\matlab6p5\toolbox\map\map\distortcalc.m" (lines 1-132). This interface
 * is only produced if the M-function uses the special variable "nargout". The
 * nargout interface allows the number of requested outputs to be specified via
 * the nargout argument, as opposed to the normal interface which dynamically
 * calculates the number of outputs based on the number of non-NULL inputs it
 * receives. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfNDistortcalc(int nargout,
                          mxArray * * angdef,
                          mxArray * * maxscale,
                          mxArray * * minscale,
                          mxArray * * merscale,
                          mxArray * * parscale,
                          ...) {
    mxArray * varargin = NULL;
    mxArray * areascale = NULL;
    mxArray * angdef__ = NULL;
    mxArray * maxscale__ = NULL;
    mxArray * minscale__ = NULL;
    mxArray * merscale__ = NULL;
    mxArray * parscale__ = NULL;
    mlfVarargin(&varargin, parscale, 0);
    mlfEnterNewContext(
      5, -1, angdef, maxscale, minscale, merscale, parscale, varargin);
    areascale
      = Mdistortcalc(
          &angdef__,
          &maxscale__,
          &minscale__,
          &merscale__,
          &parscale__,
          nargout,
          varargin);
    mlfRestorePreviousContext(
      5, 0, angdef, maxscale, minscale, merscale, parscale);
    mxDestroyArray(varargin);
    if (angdef != NULL) {
        mclCopyOutputArg(angdef, angdef__);
    } else {
        mxDestroyArray(angdef__);
    }
    if (maxscale != NULL) {
        mclCopyOutputArg(maxscale, maxscale__);
    } else {
        mxDestroyArray(maxscale__);
    }
    if (minscale != NULL) {
        mclCopyOutputArg(minscale, minscale__);
    } else {
        mxDestroyArray(minscale__);
    }
    if (merscale != NULL) {
        mclCopyOutputArg(merscale, merscale__);
    } else {
        mxDestroyArray(merscale__);
    }
    if (parscale != NULL) {
        mclCopyOutputArg(parscale, parscale__);
    } else {
        mxDestroyArray(parscale__);
    }
    return mlfReturnValue(areascale);
}

/*
 * The function "mlfDistortcalc" contains the normal interface for the
 * "distortcalc" M-function from file
 * "c:\matlab6p5\toolbox\map\map\distortcalc.m" (lines 1-132). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
mxArray * mlfDistortcalc(mxArray * * angdef,
                         mxArray * * maxscale,
                         mxArray * * minscale,
                         mxArray * * merscale,
                         mxArray * * parscale,
                         ...) {
    mxArray * varargin = NULL;
    int nargout = 1;
    mxArray * areascale = NULL;
    mxArray * angdef__ = NULL;
    mxArray * maxscale__ = NULL;
    mxArray * minscale__ = NULL;
    mxArray * merscale__ = NULL;
    mxArray * parscale__ = NULL;
    mlfVarargin(&varargin, parscale, 0);
    mlfEnterNewContext(
      5, -1, angdef, maxscale, minscale, merscale, parscale, varargin);
    if (angdef != NULL) {
        ++nargout;
    }
    if (maxscale != NULL) {
        ++nargout;
    }
    if (minscale != NULL) {
        ++nargout;
    }
    if (merscale != NULL) {
        ++nargout;
    }
    if (parscale != NULL) {
        ++nargout;
    }
    areascale
      = Mdistortcalc(
          &angdef__,
          &maxscale__,
          &minscale__,
          &merscale__,
          &parscale__,
          nargout,
          varargin);
    mlfRestorePreviousContext(
      5, 0, angdef, maxscale, minscale, merscale, parscale);
    mxDestroyArray(varargin);
    if (angdef != NULL) {
        mclCopyOutputArg(angdef, angdef__);
    } else {
        mxDestroyArray(angdef__);
    }
    if (maxscale != NULL) {
        mclCopyOutputArg(maxscale, maxscale__);
    } else {
        mxDestroyArray(maxscale__);
    }
    if (minscale != NULL) {
        mclCopyOutputArg(minscale, minscale__);
    } else {
        mxDestroyArray(minscale__);
    }
    if (merscale != NULL) {
        mclCopyOutputArg(merscale, merscale__);
    } else {
        mxDestroyArray(merscale__);
    }
    if (parscale != NULL) {
        mclCopyOutputArg(parscale, parscale__);
    } else {
        mxDestroyArray(parscale__);
    }
    return mlfReturnValue(areascale);
}

/*
 * The function "mlfVDistortcalc" contains the void interface for the
 * "distortcalc" M-function from file
 * "c:\matlab6p5\toolbox\map\map\distortcalc.m" (lines 1-132). The void
 * interface is only produced if the M-function uses the special variable
 * "nargout", and has at least one output. The void interface function
 * specifies zero output arguments to the implementation version of the
 * function, and in the event that the implementation version still returns an
 * output (which, in MATLAB, would be assigned to the "ans" variable), it
 * deallocates the output. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlfVDistortcalc(mxArray * synthetic_varargin_argument, ...) {
    mxArray * varargin = NULL;
    mxArray * areascale = NULL;
    mxArray * angdef = NULL;
    mxArray * maxscale = NULL;
    mxArray * minscale = NULL;
    mxArray * merscale = NULL;
    mxArray * parscale = NULL;
    mlfVarargin(&varargin, synthetic_varargin_argument, 1);
    mlfEnterNewContext(0, -1, varargin);
    areascale
      = Mdistortcalc(
          &angdef,
          &maxscale,
          &minscale,
          &merscale,
          &parscale,
          0,
          synthetic_varargin_argument);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
    mxDestroyArray(areascale);
    mxDestroyArray(angdef);
    mxDestroyArray(maxscale);
    mxDestroyArray(minscale);
    mxDestroyArray(merscale);
}

/*
 * The function "mlxDistortcalc" contains the feval interface for the
 * "distortcalc" M-function from file
 * "c:\matlab6p5\toolbox\map\map\distortcalc.m" (lines 1-132). The feval
 * function calls the implementation version of distortcalc through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxDistortcalc(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[6];
    int i;
    if (nlhs > 6) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: distortcalc Line: 1 Column"
            ": 1 The function \"distortcalc\" was called with"
            " more than the declared number of outputs (6)."),
          NULL);
    }
    for (i = 0; i < 6; ++i) {
        mplhs[i] = NULL;
    }
    mlfEnterNewContext(0, 0);
    mprhs[0] = NULL;
    mlfAssign(&mprhs[0], mclCreateVararginCell(nrhs, prhs));
    mplhs[0]
      = Mdistortcalc(
          &mplhs[1],
          &mplhs[2],
          &mplhs[3],
          &mplhs[4],
          &mplhs[5],
          nlhs,
          mprhs[0]);
    mlfRestorePreviousContext(0, 0);
    plhs[0] = mplhs[0];
    for (i = 1; i < 6 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 6; ++i) {
        mxDestroyArray(mplhs[i]);
    }
    mxDestroyArray(mprhs[0]);
}

/*
 * The function "Mdistortcalc" is the implementation version of the
 * "distortcalc" M-function from file
 * "c:\matlab6p5\toolbox\map\map\distortcalc.m" (lines 1-132). It contains the
 * actual compiled code for that M-function. It is a static function and must
 * only be called from one of the interface functions, appearing below.
 */
/*
 * function [areascale,angdef,maxscale,minscale,merscale,parscale] = distortcalc(varargin)
 */
static mxArray * Mdistortcalc(mxArray * * angdef,
                              mxArray * * maxscale,
                              mxArray * * minscale,
                              mxArray * * merscale,
                              mxArray * * parscale,
                              int nargout_,
                              mxArray * varargin) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_distortcalc);
    int nargin_ = mclNargin(-1, varargin, NULL);
    mxArray * areascale = NULL;
    mxArray * omega = NULL;
    mxArray * sinomegaby2 = NULL;
    mxArray * p = NULL;
    mxArray * b = NULL;
    mxArray * a = NULL;
    mxArray * aminusb = NULL;
    mxArray * aplusb = NULL;
    mxArray * sinThetaPrime = NULL;
    mxArray * cosThetaPrime = NULL;
    mxArray * k = NULL;
    mxArray * warnState = NULL;
    mxArray * h = NULL;
    mxArray * G = NULL;
    mxArray * F = NULL;
    mxArray * E = NULL;
    mxArray * dxdlambda = NULL;
    mxArray * dydlambda = NULL;
    mxArray * ang = NULL;
    mxArray * dydphi = NULL;
    mxArray * dxdphi = NULL;
    mxArray * len = NULL;
    mxArray * th = NULL;
    mxArray * units = NULL;
    mxArray * msg = NULL;
    mxArray * ans = NULL;
    mxArray * lon = NULL;
    mxArray * lat = NULL;
    mxArray * mstruct = NULL;
    mclCopyArray(&varargin);
    /*
     * 
     * % DISTORTCALC calculates distortion parameters for a map projection
     * %
     * %  areascale = DISTORTCALC(lat,long) computes the area distortion for the 
     * %  current map projection at the specified geographic location. An area 
     * %  scale of 1 indicates no scale distortion. Latitude and longitude may 
     * %  be scalars, vectors or matrices in the angle units of the defined map 
     * %  projection.  
     * %
     * %  areascale = DISTORTCALC(mstruct,lat,long) uses the projection defined in 
     * %  the map structure mstruct.
     * %
     * %  [areascale,angdef,maxscale,minscale,merscale,parscale] = DISTORTCALC(...)
     * %  computes the area scale, maximum angular deformation (in the angle units of
     * %  the defined projection), the particular maximum and minimum scale 
     * %  distortions in any direction, and the particular scale along the 
     * %  meridian and parallel. DISTORTCALC may also be called with fewer output 
     * %  arguments, in the order shown.
     * %
     * %  See also MDISTORT, TISSOT
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by: W. Stumpf
     * %   $Revision: 1.5 $    $Date: 2002/03/20 21:25:04 $
     * %
     * %  Ref. Maling, Coordinate Systems and Map Projections, 2nd Edition, 
     * 
     * 
     * if nargin == 2 & ~isstruct(varargin{1})
     */
    {
        mxArray * a_ = mclInitialize(mclBoolToArray(nargin_ == 2));
        if (mlfTobool(a_)
            && mlfTobool(
                 mclAnd(
                   a_,
                   mclNot(
                     mclFeval(
                       mclValueVarargout(),
                       mlxIsstruct,
                       mlfIndexRef(
                         mclVa(varargin, "varargin"), "{?}", _mxarray0_),
                       NULL))))) {
            mxDestroyArray(a_);
            /*
             * mstruct = [];
             */
            mlfAssign(&mstruct, _mxarray1_);
            /*
             * lat   = varargin{1};
             */
            mlfAssign(
              &lat,
              mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray0_));
            /*
             * lon   = varargin{2};
             */
            mlfAssign(
              &lon,
              mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray2_));
        /*
         * elseif nargin == 3 & isstruct(varargin{1})
         */
        } else {
            mxDestroyArray(a_);
            {
                mxArray * a_0 = mclInitialize(mclBoolToArray(nargin_ == 3));
                if (mlfTobool(a_0)
                    && mlfTobool(
                         mclAnd(
                           a_0,
                           mclFeval(
                             mclValueVarargout(),
                             mlxIsstruct,
                             mlfIndexRef(
                               mclVa(varargin, "varargin"), "{?}", _mxarray0_),
                             NULL)))) {
                    mxDestroyArray(a_0);
                    /*
                     * mstruct = varargin{1};
                     */
                    mlfAssign(
                      &mstruct,
                      mlfIndexRef(
                        mclVa(varargin, "varargin"), "{?}", _mxarray0_));
                    /*
                     * lat   = varargin{2};
                     */
                    mlfAssign(
                      &lat,
                      mlfIndexRef(
                        mclVa(varargin, "varargin"), "{?}", _mxarray2_));
                    /*
                     * lon   = varargin{3};
                     */
                    mlfAssign(
                      &lon,
                      mlfIndexRef(
                        mclVa(varargin, "varargin"), "{?}", _mxarray3_));
                /*
                 * else
                 */
                } else {
                    mxDestroyArray(a_0);
                    /*
                     * error('Incorrect number of arguments')	  
                     */
                    mlfError(_mxarray4_, NULL);
                }
            }
        }
    /*
     * end
     */
    }
    /*
     * 
     * %  Retrieve map structure
     * 
     * if isempty(mstruct)
     */
    if (mlfTobool(mlfIsempty(mclVv(mstruct, "mstruct")))) {
        /*
         * [mstruct,msg] = gcm;
         */
        mlfAssign(&mstruct, mlfNGcm(2, &msg, NULL));
        /*
         * if ~isempty(msg);   error(msg);   end
         */
        if (mclNotBool(mlfIsempty(mclVv(msg, "msg")))) {
            mlfError(mclVv(msg, "msg"), NULL);
        }
    /*
     * end
     */
    }
    /*
     * 
     * units = mstruct.angleunits;
     */
    mlfAssign(&units, mlfIndexRef(mclVv(mstruct, "mstruct"), ".angleunits"));
    /*
     * 
     * %  Direction and scale along the meridian by finite difference
     * 
     * [th,len] = vfwdtran(mstruct,lat,lon,0*ones(size(lat)));
     */
    mlfAssign(
      &th,
      mlfVfwdtran(
        &len,
        mclVv(mstruct, "mstruct"),
        mclVv(lat, "lat"),
        mclVv(lon, "lon"),
        mclMtimes(
          _mxarray6_,
          mlfOnes(mlfSize(mclValueVarargout(), mclVv(lat, "lat"), NULL), NULL)),
        NULL));
    /*
     * 
     * %  Components in x and y directions
     * 
     * th = angledim(th,units,'radians');
     */
    mlfAssign(
      &th, mlfAngledim(mclVv(th, "th"), mclVv(units, "units"), _mxarray7_));
    /*
     * dxdphi =  cos(th).*len; % phi = lat
     */
    mlfAssign(&dxdphi, mclTimes(mlfCos(mclVv(th, "th")), mclVv(len, "len")));
    /*
     * dydphi =  sin(th).*len; % phi = lat
     */
    mlfAssign(&dydphi, mclTimes(mlfSin(mclVv(th, "th")), mclVv(len, "len")));
    /*
     * 
     * %  Direction and scale along the parallel by finite difference
     * 
     * ang = angledim(90,'degrees',units);
     */
    mlfAssign(
      &ang, mlfAngledim(_mxarray9_, _mxarray10_, mclVv(units, "units")));
    /*
     * [th,len] = vfwdtran(mstruct,lat,lon,ang*ones(size(lat)));
     */
    mlfAssign(
      &th,
      mlfVfwdtran(
        &len,
        mclVv(mstruct, "mstruct"),
        mclVv(lat, "lat"),
        mclVv(lon, "lon"),
        mclMtimes(
          mclVv(ang, "ang"),
          mlfOnes(mlfSize(mclValueVarargout(), mclVv(lat, "lat"), NULL), NULL)),
        NULL));
    /*
     * th = angledim(th,units,'radians');
     */
    mlfAssign(
      &th, mlfAngledim(mclVv(th, "th"), mclVv(units, "units"), _mxarray7_));
    /*
     * 
     * %  Convert lat and long to radians for trig functions
     * 
     * lat = angledim(lat,units,'radians');
     */
    mlfAssign(
      &lat, mlfAngledim(mclVv(lat, "lat"), mclVv(units, "units"), _mxarray7_));
    /*
     * lon = angledim(lon,units,'radians');
     */
    mlfAssign(
      &lon, mlfAngledim(mclVv(lon, "lon"), mclVv(units, "units"), _mxarray7_));
    /*
     * 
     * %  Components in x and y directions
     * 
     * dydlambda =  sin(th).*len.*cos(lat); % lambda = lon
     */
    mlfAssign(
      &dydlambda,
      mclTimes(
        mclTimes(mlfSin(mclVv(th, "th")), mclVv(len, "len")),
        mlfCos(mclVv(lat, "lat"))));
    /*
     * dxdlambda =  cos(th).*len.*cos(lat); % lambda = lon
     */
    mlfAssign(
      &dxdlambda,
      mclTimes(
        mclTimes(mlfCos(mclVv(th, "th")), mclVv(len, "len")),
        mlfCos(mclVv(lat, "lat"))));
    /*
     * 
     * %  Gauss parameters
     * 
     * E = dxdphi.^2 + dydphi.^2;
     */
    mlfAssign(
      &E,
      mclPlus(
        mlfPower(mclVv(dxdphi, "dxdphi"), _mxarray2_),
        mlfPower(mclVv(dydphi, "dydphi"), _mxarray2_)));
    /*
     * F = dxdphi.*dxdlambda + dydphi.*dydlambda ;
     */
    mlfAssign(
      &F,
      mclPlus(
        mclTimes(mclVv(dxdphi, "dxdphi"), mclVv(dxdlambda, "dxdlambda")),
        mclTimes(mclVv(dydphi, "dydphi"), mclVv(dydlambda, "dydlambda"))));
    /*
     * G = dxdlambda.^2 + dydlambda.^2;
     */
    mlfAssign(
      &G,
      mclPlus(
        mlfPower(mclVv(dxdlambda, "dxdlambda"), _mxarray2_),
        mlfPower(mclVv(dydlambda, "dydlambda"), _mxarray2_)));
    /*
     * 
     * %  Particular scale along the meridian
     * 
     * h = sqrt(E);
     */
    mlfAssign(&h, mlfSqrt(mclVv(E, "E")));
    /*
     * 
     * %  Particular scale along the parallel.
     * %  Expect divide by zeros at the poles. Turn off warnings temporarily and
     * %  let the IEEE math do the right thing.
     * 
     * warnState = warning; warning off
     */
    mlfAssign(&warnState, mlfNWarning(1, NULL, NULL));
    mclPrintAns(&ans, mlfNWarning(0, NULL, _mxarray12_, NULL));
    /*
     * 
     * k = sqrt(G)./cos(lat) ;
     */
    mlfAssign(
      &k, mclRdivide(mlfSqrt(mclVv(G, "G")), mlfCos(mclVv(lat, "lat"))));
    /*
     * 
     * %  Parameters used in computing scales
     * 
     * cosThetaPrime = F./(h.*k.*cos(lat));
     */
    mlfAssign(
      &cosThetaPrime,
      mclRdivide(
        mclVv(F, "F"),
        mclTimes(
          mclTimes(mclVv(h, "h"), mclVv(k, "k")), mlfCos(mclVv(lat, "lat")))));
    /*
     * sinThetaPrime = sin(acos(cosThetaPrime));
     */
    mlfAssign(
      &sinThetaPrime, mlfSin(mlfAcos(mclVv(cosThetaPrime, "cosThetaPrime"))));
    /*
     * 
     * warning(warnState);
     */
    mclAssignAns(
      &ans, mlfNWarning(0, NULL, mclVv(warnState, "warnState"), NULL));
    /*
     * 
     * aplusb  = sqrt(h.^2 + k.^2 + 2.*h.*k.*sinThetaPrime);
     */
    mlfAssign(
      &aplusb,
      mlfSqrt(
        mclPlus(
          mclPlus(
            mlfPower(mclVv(h, "h"), _mxarray2_),
            mlfPower(mclVv(k, "k"), _mxarray2_)),
          mclTimes(
            mclTimes(mclTimes(_mxarray2_, mclVv(h, "h")), mclVv(k, "k")),
            mclVv(sinThetaPrime, "sinThetaPrime")))));
    /*
     * aminusb = sqrt(h.^2 + k.^2 - 2.*h.*k.*sinThetaPrime);
     */
    mlfAssign(
      &aminusb,
      mlfSqrt(
        mclMinus(
          mclPlus(
            mlfPower(mclVv(h, "h"), _mxarray2_),
            mlfPower(mclVv(k, "k"), _mxarray2_)),
          mclTimes(
            mclTimes(mclTimes(_mxarray2_, mclVv(h, "h")), mclVv(k, "k")),
            mclVv(sinThetaPrime, "sinThetaPrime")))));
    /*
     * 
     * %  Maximum particular scale at a point
     * 
     * a = (aplusb + aminusb)./2;
     */
    mlfAssign(
      &a,
      mclRdivide(
        mclPlus(mclVv(aplusb, "aplusb"), mclVv(aminusb, "aminusb")),
        _mxarray2_));
    /*
     * 
     * %  Minimum particular scale at a point
     * 
     * b = aplusb-a;
     */
    mlfAssign(&b, mclMinus(mclVv(aplusb, "aplusb"), mclVv(a, "a")));
    /*
     * 
     * %  Area scale
     * 
     * p = a.*b;
     */
    mlfAssign(&p, mclTimes(mclVv(a, "a"), mclVv(b, "b")));
    /*
     * 
     * %  Angular deformation
     * 
     * sinomegaby2 = aminusb./aplusb;
     */
    mlfAssign(
      &sinomegaby2,
      mclRdivide(mclVv(aminusb, "aminusb"), mclVv(aplusb, "aplusb")));
    /*
     * omega = 2*asin(sinomegaby2);
     */
    mlfAssign(
      &omega,
      mclMtimes(_mxarray2_, mlfAsin(mclVv(sinomegaby2, "sinomegaby2"))));
    /*
     * 
     * %  Output arguments
     * 
     * if nargout >=1; areascale = p; end
     */
    if (nargout_ >= 1) {
        mlfAssign(&areascale, mclVv(p, "p"));
    }
    /*
     * if nargout >=2; angdef = angledim(omega,'radians',units); end
     */
    if (nargout_ >= 2) {
        mlfAssign(
          angdef,
          mlfAngledim(
            mclVv(omega, "omega"), _mxarray7_, mclVv(units, "units")));
    }
    /*
     * if nargout >=3; maxscale = a; end
     */
    if (nargout_ >= 3) {
        mlfAssign(maxscale, mclVv(a, "a"));
    }
    /*
     * if nargout >=4; minscale = b; end
     */
    if (nargout_ >= 4) {
        mlfAssign(minscale, mclVv(b, "b"));
    }
    /*
     * if nargout >=5; merscale = h; end
     */
    if (nargout_ >= 5) {
        mlfAssign(merscale, mclVv(h, "h"));
    }
    /*
     * if nargout ==6; parscale = k; end
     */
    if (nargout_ == 6) {
        mlfAssign(parscale, mclVv(k, "k"));
    }
    mclValidateOutput(areascale, 1, nargout_, "areascale", "distortcalc");
    mclValidateOutput(*angdef, 2, nargout_, "angdef", "distortcalc");
    mclValidateOutput(*maxscale, 3, nargout_, "maxscale", "distortcalc");
    mclValidateOutput(*minscale, 4, nargout_, "minscale", "distortcalc");
    mclValidateOutput(*merscale, 5, nargout_, "merscale", "distortcalc");
    mclValidateOutput(*parscale, 6, nargout_, "parscale", "distortcalc");
    mxDestroyArray(mstruct);
    mxDestroyArray(lat);
    mxDestroyArray(lon);
    mxDestroyArray(ans);
    mxDestroyArray(msg);
    mxDestroyArray(units);
    mxDestroyArray(th);
    mxDestroyArray(len);
    mxDestroyArray(dxdphi);
    mxDestroyArray(dydphi);
    mxDestroyArray(ang);
    mxDestroyArray(dydlambda);
    mxDestroyArray(dxdlambda);
    mxDestroyArray(E);
    mxDestroyArray(F);
    mxDestroyArray(G);
    mxDestroyArray(h);
    mxDestroyArray(warnState);
    mxDestroyArray(k);
    mxDestroyArray(cosThetaPrime);
    mxDestroyArray(sinThetaPrime);
    mxDestroyArray(aplusb);
    mxDestroyArray(aminusb);
    mxDestroyArray(a);
    mxDestroyArray(b);
    mxDestroyArray(p);
    mxDestroyArray(sinomegaby2);
    mxDestroyArray(omega);
    mxDestroyArray(varargin);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return areascale;
    /*
     * 
     * 
     */
}
