/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:36 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "ecc2flat.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;
static mxArray * _mxarray3_;

static mxChar _array5_[43] = { 'I', 'm', 'a', 'g', 'i', 'n', 'a', 'r', 'y',
                               ' ', 'p', 'a', 'r', 't', 's', ' ', 'o', 'f',
                               ' ', 'c', 'o', 'm', 'p', 'l', 'e', 'x', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', ' ',
                               'i', 'g', 'n', 'o', 'r', 'e', 'd' };
static mxArray * _mxarray4_;

void InitializeModule_ecc2flat(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDouble(2.0);
    _mxarray3_ = mclInitializeDouble(1.0);
    _mxarray4_ = mclInitializeString(43, _array5_);
}

void TerminateModule_ecc2flat(void) {
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mecc2flat(int nargout_, mxArray * parm);

_mexLocalFunctionTable _local_function_table_ecc2flat
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfEcc2flat" contains the normal interface for the "ecc2flat"
 * M-function from file "c:\matlab6p5\toolbox\map\map\ecc2flat.m" (lines 1-45).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfEcc2flat(mxArray * parm) {
    int nargout = 1;
    mxArray * flat = NULL;
    mlfEnterNewContext(0, 1, parm);
    flat = Mecc2flat(nargout, parm);
    mlfRestorePreviousContext(0, 1, parm);
    return mlfReturnValue(flat);
}

/*
 * The function "mlxEcc2flat" contains the feval interface for the "ecc2flat"
 * M-function from file "c:\matlab6p5\toolbox\map\map\ecc2flat.m" (lines 1-45).
 * The feval function calls the implementation version of ecc2flat through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxEcc2flat(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: ecc2flat Line: 1 Column:"
            " 1 The function \"ecc2flat\" was called with m"
            "ore than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: ecc2flat Line: 1 Column:"
            " 1 The function \"ecc2flat\" was called with m"
            "ore than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mecc2flat(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mecc2flat" is the implementation version of the "ecc2flat"
 * M-function from file "c:\matlab6p5\toolbox\map\map\ecc2flat.m" (lines 1-45).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function flat = ecc2flat(parm)
 */
static mxArray * Mecc2flat(int nargout_, mxArray * parm) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_ecc2flat);
    int nargin_ = mclNargin(1, parm, NULL);
    mxArray * flat = NULL;
    mxArray * eccent = NULL;
    mxArray * col = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&parm);
    /*
     * 
     * %ECC2FLAT  Computes the flattening of an ellipse given an eccentricity
     * %
     * %  f = ECC2FLAT(mat) computes the flattening of an ellipse (or
     * %  ellipsoid of revolution) given the eccentricity.  If the
     * %  input is a column vector, then each input is assumed to be an
     * %  eccentricity.  If the input has two columns, then the second
     * %  column is assumed to be the eccentricity.  This allows geoid
     * %  vectors from ALMANAC to be used as inputs.  If the input
     * %  is an n x m matrix, where m,n > 1, then each element is assumed
     * %  to be an eccentricity.
     * %
     * %  See also:  FLAT2ECC, ECC2N, MAJAXIS, MINAXIS
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:25:10 $
     * 
     * if nargin == 0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * end
     */
    }
    /*
     * 
     * %  Dimension tests
     * 
     * if min(size(parm)) == 1 & ndims(parm) <= 2
     */
    {
        mxArray * a_
          = mclInitialize(
              mclEq(
                mlfMin(
                  NULL,
                  mlfSize(mclValueVarargout(), mclVa(parm, "parm"), NULL),
                  NULL,
                  NULL),
                _mxarray3_));
        if (mlfTobool(a_)
            && mlfTobool(
                 mclAnd(
                   a_, mclLe(mlfNdims(mclVa(parm, "parm")), _mxarray2_)))) {
            mxDestroyArray(a_);
            /*
             * 
             * col = min(size(parm,2), 2);   % Select first or second column
             */
            mlfAssign(
              &col,
              mlfMin(
                NULL,
                mlfSize(mclValueVarargout(), mclVa(parm, "parm"), _mxarray2_),
                _mxarray2_,
                NULL));
            /*
             * eccent = parm(:,col);         % First col if single vector input
             */
            mlfAssign(
              &eccent,
              mclArrayRef2(
                mclVa(parm, "parm"), mlfCreateColonIndex(), mclVv(col, "col")));
        /*
         * % Second col if two column inputs (eg. geoid vecs)
         * else
         */
        } else {
            mxDestroyArray(a_);
            /*
             * eccent = parm;        %  General matrix input
             */
            mlfAssign(&eccent, mclVa(parm, "parm"));
        }
    /*
     * end
     */
    }
    /*
     * 
     * %  Ensure real inputs
     * 
     * if ~isreal(eccent)
     */
    if (mclNotBool(mlfIsreal(mclVv(eccent, "eccent")))) {
        /*
         * warning('Imaginary parts of complex argument ignored')
         */
        mclPrintAns(&ans, mlfNWarning(0, NULL, _mxarray4_, NULL));
        /*
         * eccent = real(eccent);
         */
        mlfAssign(&eccent, mlfReal(mclVv(eccent, "eccent")));
    /*
     * end
     */
    }
    /*
     * 
     * %  Compute the flattening
     * 
     * flat = 1 - sqrt(1 - eccent.^2);
     */
    mlfAssign(
      &flat,
      mclMinus(
        _mxarray3_,
        mlfSqrt(
          mclMinus(
            _mxarray3_, mlfPower(mclVv(eccent, "eccent"), _mxarray2_)))));
    mclValidateOutput(flat, 1, nargout_, "flat", "ecc2flat");
    mxDestroyArray(ans);
    mxDestroyArray(col);
    mxDestroyArray(eccent);
    mxDestroyArray(parm);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return flat;
}
