/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:31 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "elpcalc.h"
#include "geoidtst.h"
#include "libmatlbm.h"
#include "minaxis.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

static mxChar _array3_[6] = { 'v', 'o', 'l', 'u', 'm', 'e' };
static mxArray * _mxarray2_;
static mxArray * _mxarray4_;
static mxArray * _mxarray5_;

static mxChar _array7_[8] = { 's', 'u', 'r', 'f', 'a', 'r', 'e', 'a' };
static mxArray * _mxarray6_;
static mxArray * _mxarray8_;
static mxArray * _mxarray9_;
static mxArray * _mxarray10_;
static mxArray * _mxarray11_;

static mxChar _array13_[31] = { 'U', 'n', 'r', 'e', 'c', 'o', 'g', 'n',
                                'i', 'z', 'e', 'd', ' ', 'c', 'a', 'l',
                                'c', 'u', 'l', 'a', 't', 'i', 'o', 'n',
                                ' ', 's', 't', 'r', 'i', 'n', 'g' };
static mxArray * _mxarray12_;

void InitializeModule_elpcalc(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeString(6, _array3_);
    _mxarray4_ = mclInitializeDouble(4.1887902047863905);
    _mxarray5_ = mclInitializeDouble(2.0);
    _mxarray6_ = mclInitializeString(8, _array7_);
    _mxarray8_ = mclInitializeDouble(1e-10);
    _mxarray9_ = mclInitializeDouble(1.0);
    _mxarray10_ = mclInitializeDouble(6.283185307179586);
    _mxarray11_ = mclInitializeDouble(3.141592653589793);
    _mxarray12_ = mclInitializeString(31, _array13_);
}

void TerminateModule_elpcalc(void) {
    mxDestroyArray(_mxarray12_);
    mxDestroyArray(_mxarray11_);
    mxDestroyArray(_mxarray10_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray8_);
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Melpcalc(int nargout_, mxArray * geoid, mxArray * calculation);

_mexLocalFunctionTable _local_function_table_elpcalc
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfElpcalc" contains the normal interface for the "elpcalc"
 * M-function from file "c:\matlab6p5\toolbox\map\map\elpcalc.m" (lines 1-45).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfElpcalc(mxArray * geoid, mxArray * calculation) {
    int nargout = 1;
    mxArray * val = NULL;
    mlfEnterNewContext(0, 2, geoid, calculation);
    val = Melpcalc(nargout, geoid, calculation);
    mlfRestorePreviousContext(0, 2, geoid, calculation);
    return mlfReturnValue(val);
}

/*
 * The function "mlxElpcalc" contains the feval interface for the "elpcalc"
 * M-function from file "c:\matlab6p5\toolbox\map\map\elpcalc.m" (lines 1-45).
 * The feval function calls the implementation version of elpcalc through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxElpcalc(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: elpcalc Line: 1 Column: "
            "1 The function \"elpcalc\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: elpcalc Line: 1 Column:"
            " 1 The function \"elpcalc\" was called with m"
            "ore than the declared number of inputs (2)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Melpcalc(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Melpcalc" is the implementation version of the "elpcalc"
 * M-function from file "c:\matlab6p5\toolbox\map\map\elpcalc.m" (lines 1-45).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function val = elpcalc(geoid,calculation)
 */
static mxArray * Melpcalc(int nargout_,
                          mxArray * geoid,
                          mxArray * calculation) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_elpcalc);
    int nargin_ = mclNargin(2, geoid, calculation, NULL);
    mxArray * val = NULL;
    mxArray * fact = NULL;
    mxArray * eccent = NULL;
    mxArray * semimajor = NULL;
    mxArray * semiminor = NULL;
    mxArray * msg = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&geoid);
    mclCopyArray(&calculation);
    /*
     * 
     * %ELPCALC  Computes volume and surface area for an oblate spheroid
     * %
     * %  ELPCALC(geoid,'volume') computes the volume of an oblate
     * %  spheriod defined by geoid = [SemimajorAxis  Eccentricity].
     * %  The units are defined by the input semimajor axis.
     * %
     * %  ELPCALC(geoid,'surfarea') computes the surface area of an oblate
     * %  spheriod defined by geoid = [SemimajorAxis  Eccentricity].
     * %
     * %  See also SPHCALC
     * 
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:25:12 $
     * 
     * if nargin ~= 2;    error('Incorrect number of arguments');   end
     */
    if (nargin_ != 2) {
        mlfError(_mxarray0_, NULL);
    }
    /*
     * 
     * %  Test the geoid input
     * 
     * [geoid,msg] = geoidtst(geoid);
     */
    mlfAssign(&geoid, mlfNGeoidtst(2, &msg, mclVa(geoid, "geoid")));
    /*
     * if ~isempty(msg);   error(msg);   end
     */
    if (mclNotBool(mlfIsempty(mclVv(msg, "msg")))) {
        mlfError(mclVv(msg, "msg"), NULL);
    }
    /*
     * 
     * semiminor =  minaxis(geoid);
     */
    mlfAssign(&semiminor, mlfMinaxis(mclVa(geoid, "geoid"), NULL));
    /*
     * semimajor = geoid(1);
     */
    mlfAssign(&semimajor, mclIntArrayRef1(mclVa(geoid, "geoid"), 1));
    /*
     * eccent    = geoid(2);
     */
    mlfAssign(&eccent, mclIntArrayRef1(mclVa(geoid, "geoid"), 2));
    /*
     * 
     * if strcmp(calculation,'volume')
     */
    if (mlfTobool(mlfStrcmp(mclVa(calculation, "calculation"), _mxarray2_))) {
        /*
         * val = (4*pi/3) * semiminor * semimajor^2;
         */
        mlfAssign(
          &val,
          mclMtimes(
            mclMtimes(_mxarray4_, mclVv(semiminor, "semiminor")),
            mclMpower(mclVv(semimajor, "semimajor"), _mxarray5_)));
    /*
     * 
     * elseif strcmp(calculation,'surfarea')
     */
    } else if (mlfTobool(
                 mlfStrcmp(mclVa(calculation, "calculation"), _mxarray6_))) {
        /*
         * if eccent > 1E-10
         */
        if (mclGtBool(mclVv(eccent, "eccent"), _mxarray8_)) {
            /*
             * fact = log((1+eccent)/(1-eccent))/eccent;
             */
            mlfAssign(
              &fact,
              mclMrdivide(
                mlfLog(
                  mclMrdivide(
                    mclPlus(_mxarray9_, mclVv(eccent, "eccent")),
                    mclMinus(_mxarray9_, mclVv(eccent, "eccent")))),
                mclVv(eccent, "eccent")));
        /*
         * else
         */
        } else {
            /*
             * fact = 2;
             */
            mlfAssign(&fact, _mxarray5_);
        /*
         * end
         */
        }
        /*
         * 
         * val = 2*pi*semimajor^2 + fact*pi*semiminor^2;
         */
        mlfAssign(
          &val,
          mclPlus(
            mclMtimes(
              _mxarray10_,
              mclMpower(mclVv(semimajor, "semimajor"), _mxarray5_)),
            mclMtimes(
              mclMtimes(mclVv(fact, "fact"), _mxarray11_),
              mclMpower(mclVv(semiminor, "semiminor"), _mxarray5_))));
    /*
     * 
     * else
     */
    } else {
        /*
         * error('Unrecognized calculation string')
         */
        mlfError(_mxarray12_, NULL);
    /*
     * end
     */
    }
    mclValidateOutput(val, 1, nargout_, "val", "elpcalc");
    mxDestroyArray(ans);
    mxDestroyArray(msg);
    mxDestroyArray(semiminor);
    mxDestroyArray(semimajor);
    mxDestroyArray(eccent);
    mxDestroyArray(fact);
    mxDestroyArray(calculation);
    mxDestroyArray(geoid);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return val;
}
