/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:28 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "fillm.h"
#include "libmatlbm.h"
#include "nextmap.h"
#include "patchm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;
static mxArray * _mxarray3_;

void InitializeModule_fillm(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDouble(1.0);
    _mxarray3_ = mclInitializeDouble(2.0);
}

void TerminateModule_fillm(void) {
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mfillm(int nargout_, mxArray * varargin);

_mexLocalFunctionTable _local_function_table_fillm
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfNFillm" contains the nargout interface for the "fillm"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\fillm.m" (lines
 * 1-46). This interface is only produced if the M-function uses the special
 * variable "nargout". The nargout interface allows the number of requested
 * outputs to be specified via the nargout argument, as opposed to the normal
 * interface which dynamically calculates the number of outputs based on the
 * number of non-NULL inputs it receives. This function processes any input
 * arguments and passes them to the implementation version of the function,
 * appearing above.
 */
mxArray * mlfNFillm(int nargout, ...) {
    mxArray * varargin = NULL;
    mxArray * hndl = NULL;
    mlfVarargin(&varargin, nargout, 0);
    mlfEnterNewContext(0, -1, varargin);
    hndl = Mfillm(nargout, varargin);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
    return mlfReturnValue(hndl);
}

/*
 * The function "mlfFillm" contains the normal interface for the "fillm"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\fillm.m" (lines
 * 1-46). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfFillm(mxArray * synthetic_varargin_argument, ...) {
    mxArray * varargin = NULL;
    int nargout = 1;
    mxArray * hndl = NULL;
    mlfVarargin(&varargin, synthetic_varargin_argument, 1);
    mlfEnterNewContext(0, -1, varargin);
    hndl = Mfillm(nargout, varargin);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
    return mlfReturnValue(hndl);
}

/*
 * The function "mlfVFillm" contains the void interface for the "fillm"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\fillm.m" (lines
 * 1-46). The void interface is only produced if the M-function uses the
 * special variable "nargout", and has at least one output. The void interface
 * function specifies zero output arguments to the implementation version of
 * the function, and in the event that the implementation version still returns
 * an output (which, in MATLAB, would be assigned to the "ans" variable), it
 * deallocates the output. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlfVFillm(mxArray * synthetic_varargin_argument, ...) {
    mxArray * varargin = NULL;
    mxArray * hndl = NULL;
    mlfVarargin(&varargin, synthetic_varargin_argument, 1);
    mlfEnterNewContext(0, -1, varargin);
    hndl = Mfillm(0, synthetic_varargin_argument);
    mlfRestorePreviousContext(0, 0);
    mxDestroyArray(varargin);
}

/*
 * The function "mlxFillm" contains the feval interface for the "fillm"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\fillm.m" (lines
 * 1-46). The feval function calls the implementation version of fillm through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
void mlxFillm(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: fillm Line: 1 Column: 1 The function \"fillm"
            "\" was called with more than the declared number of outputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    mlfEnterNewContext(0, 0);
    mprhs[0] = NULL;
    mlfAssign(&mprhs[0], mclCreateVararginCell(nrhs, prhs));
    mplhs[0] = Mfillm(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 0);
    plhs[0] = mplhs[0];
    mxDestroyArray(mprhs[0]);
}

/*
 * The function "Mfillm" is the implementation version of the "fillm"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\fillm.m" (lines
 * 1-46). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function hndl = fillm(varargin)
 */
static mxArray * Mfillm(int nargout_, mxArray * varargin) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_fillm);
    int nargin_ = mclNargin(-1, varargin, NULL);
    mxArray * hndl = NULL;
    mxArray * msg = NULL;
    mxArray * hndl0 = NULL;
    mxArray * lon = NULL;
    mxArray * lat = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&varargin);
    /*
     * 
     * %FILLM  Project 2D patch objects onto the current map axes
     * %
     * %  FILLM(lat,lon,cdata) projects 2D patch objects onto the current
     * %  map axes.  The input latitude and longitude data must be in the same
     * %  units as specified in the current map axes.  The input cdata defines
     * %  the patch face color.  If the input vectors are NaN clipped, then
     * %  a single patch is drawn with multiple faces.  FILLM will clear the
     * %  current map if the hold state is off.
     * %
     * %  FILLM(lat,lon,'PropertyName',PropertyValue,...) uses the patch
     * %  properties supplied to display the patch.  Except for xdata, ydata
     * %  and zdata, all patch properties available through FILL are supported
     * %  by FILLM.
     * %
     * %  h = FILLM(...) returns the handles to the patch objects drawn.
     * %
     * %  FILLM, without any inputs, activates a GUI for projecting patches
     * %  onto the current axes.
     * %
     * %  See also FILL3M, FILL, PATCHM, PATCH
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:27:28 $
     * 
     * 
     * if nargin == 0
     */
    if (nargin_ == 0) {
        /*
         * patchm;  return
         */
        mclAssignAns(&ans, mlfNPatchm(0, NULL, NULL));
        goto return_;
    /*
     * elseif nargin < 3
     */
    } else if (nargin_ < 3) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * else
     */
    } else {
        /*
         * lat = varargin{1};  lon = varargin{2};   varargin(1:2) = [];
         */
        mlfAssign(
          &lat, mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray2_));
        mlfAssign(
          &lon, mlfIndexRef(mclVa(varargin, "varargin"), "{?}", _mxarray3_));
        mlfIndexDelete(
          &varargin, "(?)", mlfColon(_mxarray2_, _mxarray3_, NULL));
    /*
     * end
     */
    }
    /*
     * 
     * %  Display the map
     * 
     * nextmap;
     */
    mlfNextmap();
    /*
     * [hndl0,msg] = patchm(lat,lon,varargin{:});
     */
    mlfAssign(
      &hndl0,
      mlfNPatchm(
        2,
        &msg,
        mclVv(lat, "lat"),
        mclVv(lon, "lon"),
        mlfIndexRef(mclVa(varargin, "varargin"), "{?}", mlfCreateColonIndex()),
        NULL));
    /*
     * if ~isempty(msg);  error(msg);  end
     */
    if (mclNotBool(mlfIsempty(mclVv(msg, "msg")))) {
        mlfError(mclVv(msg, "msg"), NULL);
    }
    /*
     * 
     * %  Set handle return argument if necessary
     * 
     * if nargout == 1;   hndl = hndl0;   end
     */
    if (nargout_ == 1) {
        mlfAssign(&hndl, mclVv(hndl0, "hndl0"));
    }
    return_:
    mclValidateOutput(hndl, 1, nargout_, "hndl", "fillm");
    mxDestroyArray(ans);
    mxDestroyArray(lat);
    mxDestroyArray(lon);
    mxDestroyArray(hndl0);
    mxDestroyArray(msg);
    mxDestroyArray(varargin);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return hndl;
}
