/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:34 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "geod2rec.h"
#include "almanac.h"
#include "angledim.h"
#include "ecc2n.h"
#include "geoidtst.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;

static mxChar _array4_[7] = { 'd', 'e', 'g', 'r', 'e', 'e', 's' };
static mxArray * _mxarray3_;

static mxChar _array6_[5] = { 'e', 'a', 'r', 't', 'h' };
static mxArray * _mxarray5_;

static mxChar _array8_[5] = { 'g', 'e', 'o', 'i', 'd' };
static mxArray * _mxarray7_;
static mxArray * _mxarray9_;

static mxChar _array11_[62] = { 'A', 'u', 'x', 'i', 'l', 'i', 'a', 'r', 'y',
                                ' ', 's', 'p', 'h', 'e', 'r', 'e', ' ', 'a',
                                'p', 'p', 'r', 'o', 'x', 'i', 'm', 'a', 't',
                                'i', 'o', 'n', ' ', 'w', 'e', 'a', 'k', 'e',
                                'n', 's', ' ', 'w', 'i', 't', 'h', ' ', 'e',
                                'c', 'c', 'e', 'n', 't', 'r', 'i', 'c', 'i',
                                't', 'y', ' ', '>', ' ', '0', '.', '5' };
static mxArray * _mxarray10_;
static mxArray * _mxarray12_;
static mxArray * _mxarray13_;
static mxArray * _mxarray14_;
static mxArray * _mxarray15_;
static mxArray * _mxarray16_;
static mxArray * _mxarray17_;
static mxArray * _mxarray18_;
static mxArray * _mxarray19_;
static mxArray * _mxarray20_;
static mxArray * _mxarray21_;
static mxArray * _mxarray22_;

static mxChar _array24_[7] = { 'r', 'a', 'd', 'i', 'a', 'n', 's' };
static mxArray * _mxarray23_;
static mxArray * _mxarray25_;
static mxArray * _mxarray26_;

void InitializeModule_geod2rec(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray3_ = mclInitializeString(7, _array4_);
    _mxarray5_ = mclInitializeString(5, _array6_);
    _mxarray7_ = mclInitializeString(5, _array8_);
    _mxarray9_ = mclInitializeDouble(.5);
    _mxarray10_ = mclInitializeString(62, _array11_);
    _mxarray12_ = mclInitializeDouble(3.0);
    _mxarray13_ = mclInitializeDouble(2.0);
    _mxarray14_ = mclInitializeDouble(9.0);
    _mxarray15_ = mclInitializeDouble(16.0);
    _mxarray16_ = mclInitializeDouble(15.0);
    _mxarray17_ = mclInitializeDouble(4.0);
    _mxarray18_ = mclInitializeDouble(32.0);
    _mxarray19_ = mclInitializeDouble(35.0);
    _mxarray20_ = mclInitializeDouble(48.0);
    _mxarray21_ = mclInitializeDouble(315.0);
    _mxarray22_ = mclInitializeDouble(512.0);
    _mxarray23_ = mclInitializeString(7, _array24_);
    _mxarray25_ = mclInitializeDouble(6.0);
    _mxarray26_ = mclInitializeDouble(8.0);
}

void TerminateModule_geod2rec(void) {
    mxDestroyArray(_mxarray26_);
    mxDestroyArray(_mxarray25_);
    mxDestroyArray(_mxarray23_);
    mxDestroyArray(_mxarray22_);
    mxDestroyArray(_mxarray21_);
    mxDestroyArray(_mxarray20_);
    mxDestroyArray(_mxarray19_);
    mxDestroyArray(_mxarray18_);
    mxDestroyArray(_mxarray17_);
    mxDestroyArray(_mxarray16_);
    mxDestroyArray(_mxarray15_);
    mxDestroyArray(_mxarray14_);
    mxDestroyArray(_mxarray13_);
    mxDestroyArray(_mxarray12_);
    mxDestroyArray(_mxarray10_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mgeod2rec(int nargout_,
                           mxArray * latin,
                           mxArray * geoid,
                           mxArray * units);

_mexLocalFunctionTable _local_function_table_geod2rec
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfGeod2rec" contains the normal interface for the "geod2rec"
 * M-function from file "c:\matlab6p5\toolbox\map\map\geod2rec.m" (lines 1-81).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfGeod2rec(mxArray * latin, mxArray * geoid, mxArray * units) {
    int nargout = 1;
    mxArray * latout = NULL;
    mlfEnterNewContext(0, 3, latin, geoid, units);
    latout = Mgeod2rec(nargout, latin, geoid, units);
    mlfRestorePreviousContext(0, 3, latin, geoid, units);
    return mlfReturnValue(latout);
}

/*
 * The function "mlxGeod2rec" contains the feval interface for the "geod2rec"
 * M-function from file "c:\matlab6p5\toolbox\map\map\geod2rec.m" (lines 1-81).
 * The feval function calls the implementation version of geod2rec through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxGeod2rec(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[3];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: geod2rec Line: 1 Column:"
            " 1 The function \"geod2rec\" was called with m"
            "ore than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: geod2rec Line: 1 Column:"
            " 1 The function \"geod2rec\" was called with m"
            "ore than the declared number of inputs (3)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 3 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 3; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    mplhs[0] = Mgeod2rec(nlhs, mprhs[0], mprhs[1], mprhs[2]);
    mlfRestorePreviousContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mgeod2rec" is the implementation version of the "geod2rec"
 * M-function from file "c:\matlab6p5\toolbox\map\map\geod2rec.m" (lines 1-81).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function latout = geod2rec(latin,geoid,units)
 */
static mxArray * Mgeod2rec(int nargout_,
                           mxArray * latin,
                           mxArray * geoid,
                           mxArray * units) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_geod2rec);
    int nargin_ = mclNargin(3, latin, geoid, units, NULL);
    mxArray * latout = NULL;
    mxArray * fact4 = NULL;
    mxArray * fact3 = NULL;
    mxArray * fact2 = NULL;
    mxArray * fact1 = NULL;
    mxArray * n = NULL;
    mxArray * e = NULL;
    mxArray * msg = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&latin);
    mclCopyArray(&geoid);
    mclCopyArray(&units);
    /*
     * 
     * %GEOD2REC  Converts from rectifying latitude to geodetic latitude
     * %
     * %  lat = GEOD2REC(lat0) converts from the geodetic latitude to the
     * %  rectifying latitude.  The rectifying latitude is used to map an
     * %  ellipsoid to a sphere in such a way that correct distances along
     * %  meridians are preserved.  Rectifying latitudes are used in place
     * %  of the geodetic latitudes when projecting the ellipsoid using an
     * %  equal distant projection.  The geodetic latitude is the angle which
     * %  a line perpendicular to the surface of the ellipsoid at the given
     * %  point makes with the equatorial plane.
     * %
     * %  lat = GEOD2REC(lat0,geoid) uses the ellipsoid definition given in
     * %  the input vector geoid.  Geoid can be determined from the ALMANAC
     * %  function.  If omitted, the default Earth geoid is assumed.
     * %
     * %  lat = GEOD2REC(lat0,'units') uses the units defined by the input string
     * %  'units'.  If omitted, default units of degrees are assumed.
     * %
     * %  lat = GEOD2REC(lat0,geoid,'units') uses the geoid and 'units'
     * %  definitions provided by the corresponding inputs.
     * %
     * %  To properly project rectified latitudes, the radius must also
     * %  be scaled to assure the equal meridional distance property.
     * %  This is accomplished by RSPHERE.
     * %
     * %  See also:  REC2GEOD, GEOD2AUT, GEOD2CEN, GEOD2CNF,
     * %             GEOD2ISO, GEOD2PAR, ALMANAC
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %  $Revision: 1.11 $    $Date: 2002/03/15 18:28:47 $
     * 
     * %   The formulae employed were taken from:  J. P. Snyder,
     * %   "Map Projections - A Working Manual,"  US Geological
     * %   Survey Professional Paper 1395, US Government Printing
     * %   Office, Washington, DC, 1987, pp. 13-18.
     * 
     * 
     * if nargin == 0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif nargin == 1
     */
    } else if (nargin_ == 1) {
        /*
         * units = [];     geoid = [];
         */
        mlfAssign(&units, _mxarray2_);
        mlfAssign(&geoid, _mxarray2_);
    /*
     * elseif nargin == 2
     */
    } else if (nargin_ == 2) {
        /*
         * if isstr(geoid);    units = geoid;    geoid = [];
         */
        if (mlfTobool(mlfIsstr(mclVa(geoid, "geoid")))) {
            mlfAssign(&units, mclVa(geoid, "geoid"));
            mlfAssign(&geoid, _mxarray2_);
        /*
         * else;          units = 'degrees';
         */
        } else {
            mlfAssign(&units, _mxarray3_);
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * 
     * %  Empty argument tests
     * 
     * if isempty(units);   units = 'degrees';       end
     */
    if (mlfTobool(mlfIsempty(mclVa(units, "units")))) {
        mlfAssign(&units, _mxarray3_);
    }
    /*
     * if isempty(geoid);   geoid = almanac('earth','geoid');  end
     */
    if (mlfTobool(mlfIsempty(mclVa(geoid, "geoid")))) {
        mlfAssign(&geoid, mlfAlmanac(_mxarray5_, _mxarray7_, NULL, NULL));
    }
    /*
     * 
     * %  Test the geoid input
     * 
     * [geoid,msg] = geoidtst(geoid);
     */
    mlfAssign(&geoid, mlfNGeoidtst(2, &msg, mclVa(geoid, "geoid")));
    /*
     * if ~isempty(msg);   error(msg);   end
     */
    if (mclNotBool(mlfIsempty(mclVv(msg, "msg")))) {
        mlfError(mclVv(msg, "msg"), NULL);
    }
    /*
     * e = geoid(2);
     */
    mlfAssign(&e, mclIntArrayRef1(mclVa(geoid, "geoid"), 2));
    /*
     * if e > 0.5
     */
    if (mclGtBool(mclVv(e, "e"), _mxarray9_)) {
        /*
         * warning('Auxiliary sphere approximation weakens with eccentricity > 0.5')
         */
        mclPrintAns(&ans, mlfNWarning(0, NULL, _mxarray10_, NULL));
    /*
     * end
     */
    }
    /*
     * 
     * %  Compute the series expansion terms
     * 
     * n     = ecc2n(e);
     */
    mlfAssign(&n, mlfEcc2n(mclVv(e, "e")));
    /*
     * fact1 = 3*n /2 - 9*n^3 /16;
     */
    mlfAssign(
      &fact1,
      mclMinus(
        mclMrdivide(mclMtimes(_mxarray12_, mclVv(n, "n")), _mxarray13_),
        mclMrdivide(
          mclMtimes(_mxarray14_, mclMpower(mclVv(n, "n"), _mxarray12_)),
          _mxarray15_)));
    /*
     * fact2 = 15*n^2 /16 - 15*n^4 /32;
     */
    mlfAssign(
      &fact2,
      mclMinus(
        mclMrdivide(
          mclMtimes(_mxarray16_, mclMpower(mclVv(n, "n"), _mxarray13_)),
          _mxarray15_),
        mclMrdivide(
          mclMtimes(_mxarray16_, mclMpower(mclVv(n, "n"), _mxarray17_)),
          _mxarray18_)));
    /*
     * fact3 = 35*n^3 /48;
     */
    mlfAssign(
      &fact3,
      mclMrdivide(
        mclMtimes(_mxarray19_, mclMpower(mclVv(n, "n"), _mxarray12_)),
        _mxarray20_));
    /*
     * fact4 = 315*n^4 /512;
     */
    mlfAssign(
      &fact4,
      mclMrdivide(
        mclMtimes(_mxarray21_, mclMpower(mclVv(n, "n"), _mxarray17_)),
        _mxarray22_));
    /*
     * 
     * latin = angledim(latin,units,'radians');   %  Convert to radians
     */
    mlfAssign(
      &latin,
      mlfAngledim(mclVa(latin, "latin"), mclVa(units, "units"), _mxarray23_));
    /*
     * 
     * latout = latin - ...                %  Series expansion for the
     */
    mlfAssign(
      &latout,
      mclPlus(
        mclMinus(
          mclPlus(
            mclMinus(
              mclVa(latin, "latin"),
              mclMtimes(
                mclVv(fact1, "fact1"),
                mlfSin(mclMtimes(_mxarray13_, mclVa(latin, "latin"))))),
            mclMtimes(
              mclVv(fact2, "fact2"),
              mlfSin(mclMtimes(_mxarray17_, mclVa(latin, "latin"))))),
          mclMtimes(
            mclVv(fact3, "fact3"),
            mlfSin(mclMtimes(_mxarray25_, mclVa(latin, "latin"))))),
        mclMtimes(
          mclVv(fact4, "fact4"),
          mlfSin(mclMtimes(_mxarray26_, mclVa(latin, "latin"))))));
    /*
     * fact1*sin(2*latin) + ...   %  transformation.  This is
     * fact2*sin(4*latin) - ...   %  an approximation of an
     * fact3*sin(6*latin) + ...   %  infinite series
     * fact4*sin(8*latin);
     * 
     * latout = angledim(latout,'radians',units);  %  Convert to output units
     */
    mlfAssign(
      &latout,
      mlfAngledim(mclVv(latout, "latout"), _mxarray23_, mclVa(units, "units")));
    mclValidateOutput(latout, 1, nargout_, "latout", "geod2rec");
    mxDestroyArray(ans);
    mxDestroyArray(msg);
    mxDestroyArray(e);
    mxDestroyArray(n);
    mxDestroyArray(fact1);
    mxDestroyArray(fact2);
    mxDestroyArray(fact3);
    mxDestroyArray(fact4);
    mxDestroyArray(units);
    mxDestroyArray(geoid);
    mxDestroyArray(latin);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return latout;
}
