/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:34 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "leadblnk.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;

static mxChar _array4_[1] = { ' ' };
static mxArray * _mxarray3_;
static mxArray * _mxarray5_;
static mxArray * _mxarray6_;

void InitializeModule_leadblnk(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray3_ = mclInitializeString(1, _array4_);
    _mxarray5_ = mclInitializeDouble(0.0);
    _mxarray6_ = mclInitializeDouble(1.0);
}

void TerminateModule_leadblnk(void) {
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mleadblnk(int nargout_, mxArray * str_in, mxArray * char0);

_mexLocalFunctionTable _local_function_table_leadblnk
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfLeadblnk" contains the normal interface for the "leadblnk"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\leadblnk.m" (lines
 * 1-42). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfLeadblnk(mxArray * str_in, mxArray * char0) {
    int nargout = 1;
    mxArray * str = NULL;
    mlfEnterNewContext(0, 2, str_in, char0);
    str = Mleadblnk(nargout, str_in, char0);
    mlfRestorePreviousContext(0, 2, str_in, char0);
    return mlfReturnValue(str);
}

/*
 * The function "mlxLeadblnk" contains the feval interface for the "leadblnk"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\leadblnk.m" (lines
 * 1-42). The feval function calls the implementation version of leadblnk
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxLeadblnk(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: leadblnk Line: 1 Column:"
            " 1 The function \"leadblnk\" was called with m"
            "ore than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: leadblnk Line: 1 Column:"
            " 1 The function \"leadblnk\" was called with m"
            "ore than the declared number of inputs (2)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mleadblnk(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mleadblnk" is the implementation version of the "leadblnk"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\leadblnk.m" (lines
 * 1-42). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function str = leadblnk(str,char)
 */
static mxArray * Mleadblnk(int nargout_, mxArray * str_in, mxArray * char0) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_leadblnk);
    int nargin_ = mclNargin(2, str_in, char0, NULL);
    mxArray * str = NULL;
    mxArray * spaces = NULL;
    mxArray * indx = NULL;
    mxArray * ans = NULL;
    mclCopyInputArg(&str, str_in);
    mclCopyArray(&char0);
    /*
     * 
     * %LEADBLNK  Deletes leading characters common to all rows of a string matrix
     * %
     * %  s = LEADBLNK(s0) deletes the leading spaces common to all
     * %  rows of a string matrix.
     * %
     * %  s = LEADBLNK(s0,char) deletes the leading characters corresponding
     * %  to the scalar char.
     * %
     * %  See also  NUM2STR, SHIFTSPC
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:27:40 $
     * 
     * if nargin < 1
     */
    if (nargin_ < 1) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif nargin == 1
     */
    } else if (nargin_ == 1) {
        /*
         * char = [];
         */
        mlfAssign(&char0, _mxarray2_);
    /*
     * end
     */
    }
    /*
     * 
     * %  Empty argument tests
     * 
     * if isempty(str);    return;       end
     */
    if (mlfTobool(mlfIsempty(mclVa(str, "str")))) {
        goto return_;
    }
    /*
     * if isempty(char);   char = ' ';   end
     */
    if (mlfTobool(mlfIsempty(mclVa(char0, "char")))) {
        mlfAssign(&char0, _mxarray3_);
    }
    /*
     * 
     * %  Eliminate null characters
     * 
     * indx = find(str==0);
     */
    mlfAssign(&indx, mlfFind(NULL, NULL, mclEq(mclVa(str, "str"), _mxarray5_)));
    /*
     * if ~isempty(indx);   str(indx) = char;  end
     */
    if (mclNotBool(mlfIsempty(mclVv(indx, "indx")))) {
        mclArrayAssign1(&str, mclVa(char0, "char"), mclVv(indx, "indx"));
    }
    /*
     * 
     * %  Eliminate leading spaces
     * 
     * if size(str,1) ~= 1;      spaces = sum(str ~= char);    %  Not spaces in each row
     */
    if (mclNeBool(
          mlfSize(mclValueVarargout(), mclVa(str, "str"), _mxarray6_),
          _mxarray6_)) {
        mlfAssign(
          &spaces,
          mlfSum(mclNe(mclVa(str, "str"), mclVa(char0, "char")), NULL));
    /*
     * else;                spaces = (str ~= char);       %  Single string entry
     */
    } else {
        mlfAssign(&spaces, mclNe(mclVa(str, "str"), mclVa(char0, "char")));
    /*
     * end
     */
    }
    /*
     * 
     * indx = min(find(spaces~=0));           %  0 sum column-wise means char is in every row
     */
    mlfAssign(
      &indx,
      mlfMin(
        NULL,
        mlfFind(NULL, NULL, mclNe(mclVv(spaces, "spaces"), _mxarray5_)),
        NULL,
        NULL));
    /*
     * if isempty(indx);  indx = length(spaces)+1;  end    %  All char in matrix
     */
    if (mlfTobool(mlfIsempty(mclVv(indx, "indx")))) {
        mlfAssign(&indx, mlfScalar(mclLengthInt(mclVv(spaces, "spaces")) + 1));
    }
    /*
     * str(:,1:(indx-1)) = [];
     */
    mlfIndexDelete(
      &str,
      "(?,?)",
      mlfCreateColonIndex(),
      mlfColon(_mxarray6_, mclMinus(mclVv(indx, "indx"), _mxarray6_), NULL));
    return_:
    mclValidateOutput(str, 1, nargout_, "str", "leadblnk");
    mxDestroyArray(ans);
    mxDestroyArray(indx);
    mxDestroyArray(spaces);
    mxDestroyArray(char0);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return str;
}
