/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:36 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "mercator.h"
#include "angledim.h"
#include "clipdata.h"
#include "cnf2geod.h"
#include "geod2cnf.h"
#include "libmatlbm.h"
#include "rotatem.h"
#include "trimdata.h"
#include "undoclip.h"
#include "undotrim.h"

static double _array1_[2] = { -86.0, 86.0 };
static mxArray * _mxarray0_;

static mxChar _array3_[7] = { 'd', 'e', 'g', 'r', 'e', 'e', 's' };
static mxArray * _mxarray2_;

static double _array5_[2] = { -180.0, 180.0 };
static mxArray * _mxarray4_;
static mxArray * _mxarray6_;
static mxArray * _mxarray7_;
static mxArray * _mxarray8_;

static mxChar _array10_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c',
                                't', ' ', 'n', 'u', 'm', 'b', 'e', 'r',
                                ' ', 'o', 'f', ' ', 'a', 'r', 'g', 'u',
                                'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray9_;

static mxChar _array12_[7] = { 'r', 'a', 'd', 'i', 'a', 'n', 's' };
static mxArray * _mxarray11_;

static mxChar _array14_[7] = { 'f', 'o', 'r', 'w', 'a', 'r', 'd' };
static mxArray * _mxarray13_;
static mxArray * _mxarray15_;
static mxArray * _mxarray16_;

static mxChar _array18_[6] = { 'n', 'o', 'r', 'm', 'a', 'l' };
static mxArray * _mxarray17_;

static mxChar _array20_[10] = { 't', 'r', 'a', 'n', 's',
                                'v', 'e', 'r', 's', 'e' };
static mxArray * _mxarray19_;

static mxChar _array22_[26] = { 'U', 'n', 'r', 'e', 'c', 'o', 'g', 'n', 'i',
                                'z', 'e', 'd', ' ', 'a', 's', 'p', 'e', 'c',
                                't', ' ', 's', 't', 'r', 'i', 'n', 'g' };
static mxArray * _mxarray21_;

static mxChar _array24_[7] = { 'i', 'n', 'v', 'e', 'r', 's', 'e' };
static mxArray * _mxarray23_;
static mxArray * _mxarray25_;

static mxChar _array27_[29] = { 'U', 'n', 'r', 'e', 'c', 'o', 'g', 'n',
                                'i', 'z', 'e', 'd', ' ', 'd', 'i', 'r',
                                'e', 'c', 't', 'i', 'o', 'n', ' ', 's',
                                't', 'r', 'i', 'n', 'g' };
static mxArray * _mxarray26_;
static double _ieee_nan_;
static mxArray * _mxarray28_;

void InitializeModule_mercator(void) {
    _mxarray0_ = mclInitializeDoubleVector(1, 2, _array1_);
    _mxarray2_ = mclInitializeString(7, _array3_);
    _mxarray4_ = mclInitializeDoubleVector(1, 2, _array5_);
    _mxarray6_ = mclInitializeDouble(0.0);
    _mxarray7_ = mclInitializeDouble(1.0);
    _mxarray8_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray9_ = mclInitializeString(29, _array10_);
    _mxarray11_ = mclInitializeString(7, _array12_);
    _mxarray13_ = mclInitializeString(7, _array14_);
    _mxarray15_ = mclInitializeDouble(.7853981633974483);
    _mxarray16_ = mclInitializeDouble(2.0);
    _mxarray17_ = mclInitializeString(6, _array18_);
    _mxarray19_ = mclInitializeString(10, _array20_);
    _mxarray21_ = mclInitializeString(26, _array22_);
    _mxarray23_ = mclInitializeString(7, _array24_);
    _mxarray25_ = mclInitializeDouble(1.5707963267948966);
    _mxarray26_ = mclInitializeString(29, _array27_);
    _ieee_nan_ = mclGetNaN();
    _mxarray28_ = mclInitializeDouble(_ieee_nan_);
}

void TerminateModule_mercator(void) {
    mxDestroyArray(_mxarray28_);
    mxDestroyArray(_mxarray26_);
    mxDestroyArray(_mxarray25_);
    mxDestroyArray(_mxarray23_);
    mxDestroyArray(_mxarray21_);
    mxDestroyArray(_mxarray19_);
    mxDestroyArray(_mxarray17_);
    mxDestroyArray(_mxarray16_);
    mxDestroyArray(_mxarray15_);
    mxDestroyArray(_mxarray13_);
    mxDestroyArray(_mxarray11_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray8_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mmercator(mxArray * * out2,
                           mxArray * * savepts,
                           int nargout_,
                           mxArray * mstruct,
                           mxArray * in1,
                           mxArray * in2,
                           mxArray * object,
                           mxArray * direction,
                           mxArray * savepts_in);

_mexLocalFunctionTable _local_function_table_mercator
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfMercator" contains the normal interface for the "mercator"
 * M-function from file "c:\matlab6p5\toolbox\map\mapproj\mercator.m" (lines
 * 1-146). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfMercator(mxArray * * out2,
                      mxArray * * savepts,
                      mxArray * mstruct,
                      mxArray * in1,
                      mxArray * in2,
                      mxArray * object,
                      mxArray * direction,
                      mxArray * savepts_in) {
    int nargout = 1;
    mxArray * out1 = NULL;
    mxArray * out2__ = NULL;
    mxArray * savepts__ = NULL;
    mlfEnterNewContext(
      2, 6, out2, savepts, mstruct, in1, in2, object, direction, savepts_in);
    if (out2 != NULL) {
        ++nargout;
    }
    if (savepts != NULL) {
        ++nargout;
    }
    out1
      = Mmercator(
          &out2__,
          &savepts__,
          nargout,
          mstruct,
          in1,
          in2,
          object,
          direction,
          savepts_in);
    mlfRestorePreviousContext(
      2, 6, out2, savepts, mstruct, in1, in2, object, direction, savepts_in);
    if (out2 != NULL) {
        mclCopyOutputArg(out2, out2__);
    } else {
        mxDestroyArray(out2__);
    }
    if (savepts != NULL) {
        mclCopyOutputArg(savepts, savepts__);
    } else {
        mxDestroyArray(savepts__);
    }
    return mlfReturnValue(out1);
}

/*
 * The function "mlxMercator" contains the feval interface for the "mercator"
 * M-function from file "c:\matlab6p5\toolbox\map\mapproj\mercator.m" (lines
 * 1-146). The feval function calls the implementation version of mercator
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxMercator(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[6];
    mxArray * mplhs[3];
    int i;
    if (nlhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: mercator Line: 1 Column:"
            " 1 The function \"mercator\" was called with m"
            "ore than the declared number of outputs (3)."),
          NULL);
    }
    if (nrhs > 6) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: mercator Line: 1 Column:"
            " 1 The function \"mercator\" was called with m"
            "ore than the declared number of inputs (6)."),
          NULL);
    }
    for (i = 0; i < 3; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 6 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 6; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(
      0, 6, mprhs[0], mprhs[1], mprhs[2], mprhs[3], mprhs[4], mprhs[5]);
    mplhs[0]
      = Mmercator(
          &mplhs[1],
          &mplhs[2],
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2],
          mprhs[3],
          mprhs[4],
          mprhs[5]);
    mlfRestorePreviousContext(
      0, 6, mprhs[0], mprhs[1], mprhs[2], mprhs[3], mprhs[4], mprhs[5]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 3 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 3; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}

/*
 * The function "Mmercator" is the implementation version of the "mercator"
 * M-function from file "c:\matlab6p5\toolbox\map\mapproj\mercator.m" (lines
 * 1-146). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function [out1,out2,savepts] = mercator(mstruct,in1,in2,object,direction,savepts)
 */
static mxArray * Mmercator(mxArray * * out2,
                           mxArray * * savepts,
                           int nargout_,
                           mxArray * mstruct,
                           mxArray * in1,
                           mxArray * in2,
                           mxArray * object,
                           mxArray * direction,
                           mxArray * savepts_in) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_mercator);
    int nargin_
      = mclNargin(6, mstruct, in1, in2, object, direction, savepts_in, NULL);
    mxArray * out1 = NULL;
    mxArray * indx = NULL;
    mxArray * y = NULL;
    mxArray * x = NULL;
    mxArray * trimmed = NULL;
    mxArray * clipped = NULL;
    mxArray * long0 = NULL;
    mxArray * lat = NULL;
    mxArray * falsenorthing = NULL;
    mxArray * falseeasting = NULL;
    mxArray * scalefactor = NULL;
    mxArray * trimlon = NULL;
    mxArray * trimlat = NULL;
    mxArray * origin = NULL;
    mxArray * parallels = NULL;
    mxArray * aspect = NULL;
    mxArray * geoid = NULL;
    mxArray * units = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&mstruct);
    mclCopyArray(&in1);
    mclCopyArray(&in2);
    mclCopyArray(&object);
    mclCopyArray(&direction);
    mclCopyInputArg(savepts, savepts_in);
    /*
     * 
     * %MERCATOR  Mercator Cylindrical Projection
     * %
     * %  This is a projection with parallel spacing calculated to maintain
     * %  conformality.  It is not equal area, equidistant, or perspective.
     * %  Scale is true along the standard parallels and constant between
     * %  two parallels equidistant from the Equator.  It is also constant
     * %  in all directions near any given point.  Scale becomes infinite
     * %  at the poles.  The appearance of the Mercator projection is
     * %  unaffected by the selection of the standard parallels;  they
     * %  serve only to define the latitude of true scale.
     * %
     * %  The Mercator, which may be the most famous of all projections, has
     * %  the special feature that all rhumb lines, or loxodromes (lines that
     * %  make equal angles with all meridians, i.e. lines of constant heading)
     * %  are straight lines.  This makes it an excellent projection for
     * %  navigational purposes.
     * %
     * %  The transverse and oblique aspects of the projection are often
     * %  used for topographic mapping and atlas maps.  Its normal aspect
     * %  is often used for maps of the entire world, for which it is
     * %  really quite inappropriate.
     * %
     * %  The Mercator projection is named for Geradus Mercator, who presented
     * %  it "for navigation" in 1569.  It is now known to have been used for
     * %  the Tunhuang star chart as early as 940 by Ch'ien Lo-Chih.  It was
     * %  first used in Europe by Erhard Etzlaub in 1511.  It is also, but
     * %  rarely, called the Wright projection, after Edward Wright, who
     * %  developed the mathematics behind the projection in 1599.
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * % $Revision: 1.9 $
     * %  Written by:  E. Byrns, E. Brown
     * 
     * 
     * if nargin == 1                  %  Set the default structure entries
     */
    if (nargin_ == 1) {
        /*
         * mstruct.trimlat = angledim([ -86  86],'degrees',mstruct.angleunits);
         */
        mlfIndexAssign(
          &mstruct,
          ".trimlat",
          mclFeval(
            mclValueVarargout(),
            mlxAngledim,
            _mxarray0_,
            _mxarray2_,
            mlfIndexRef(mclVa(mstruct, "mstruct"), ".angleunits"),
            NULL));
        /*
         * mstruct.trimlon = angledim([-180 180],'degrees',mstruct.angleunits);
         */
        mlfIndexAssign(
          &mstruct,
          ".trimlon",
          mclFeval(
            mclValueVarargout(),
            mlxAngledim,
            _mxarray4_,
            _mxarray2_,
            mlfIndexRef(mclVa(mstruct, "mstruct"), ".angleunits"),
            NULL));
        /*
         * mstruct.mapparallels = 0;
         */
        mlfIndexAssign(&mstruct, ".mapparallels", _mxarray6_);
        /*
         * mstruct.nparallels   = 1;
         */
        mlfIndexAssign(&mstruct, ".nparallels", _mxarray7_);
        /*
         * mstruct.fixedorient  = [];
         */
        mlfIndexAssign(&mstruct, ".fixedorient", _mxarray8_);
        /*
         * out1 = mstruct;     return
         */
        mlfAssign(&out1, mclVa(mstruct, "mstruct"));
        goto return_;
    /*
     * elseif nargin ~= 5 & nargin ~= 6
     */
    } else if (nargin_ != 5 && nargin_ != 6) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray9_, NULL);
    /*
     * end
     */
    }
    /*
     * 
     * %  Extract the necessary projection data and convert to radians
     * 
     * units     = mstruct.angleunits;
     */
    mlfAssign(&units, mlfIndexRef(mclVa(mstruct, "mstruct"), ".angleunits"));
    /*
     * geoid     = mstruct.geoid;
     */
    mlfAssign(&geoid, mlfIndexRef(mclVa(mstruct, "mstruct"), ".geoid"));
    /*
     * aspect    = mstruct.aspect;
     */
    mlfAssign(&aspect, mlfIndexRef(mclVa(mstruct, "mstruct"), ".aspect"));
    /*
     * parallels = angledim(mstruct.mapparallels,units,'radians');
     */
    mlfAssign(
      &parallels,
      mclFeval(
        mclValueVarargout(),
        mlxAngledim,
        mlfIndexRef(mclVa(mstruct, "mstruct"), ".mapparallels"),
        mclVv(units, "units"),
        _mxarray11_,
        NULL));
    /*
     * origin    = angledim(mstruct.origin,units,'radians');
     */
    mlfAssign(
      &origin,
      mclFeval(
        mclValueVarargout(),
        mlxAngledim,
        mlfIndexRef(mclVa(mstruct, "mstruct"), ".origin"),
        mclVv(units, "units"),
        _mxarray11_,
        NULL));
    /*
     * trimlat   = angledim(mstruct.flatlimit,units,'radians');
     */
    mlfAssign(
      &trimlat,
      mclFeval(
        mclValueVarargout(),
        mlxAngledim,
        mlfIndexRef(mclVa(mstruct, "mstruct"), ".flatlimit"),
        mclVv(units, "units"),
        _mxarray11_,
        NULL));
    /*
     * trimlon   = angledim(mstruct.flonlimit,units,'radians');
     */
    mlfAssign(
      &trimlon,
      mclFeval(
        mclValueVarargout(),
        mlxAngledim,
        mlfIndexRef(mclVa(mstruct, "mstruct"), ".flonlimit"),
        mclVv(units, "units"),
        _mxarray11_,
        NULL));
    /*
     * scalefactor = mstruct.scalefactor;
     */
    mlfAssign(
      &scalefactor, mlfIndexRef(mclVa(mstruct, "mstruct"), ".scalefactor"));
    /*
     * falseeasting = mstruct.falseeasting;
     */
    mlfAssign(
      &falseeasting, mlfIndexRef(mclVa(mstruct, "mstruct"), ".falseeasting"));
    /*
     * falsenorthing = mstruct.falsenorthing;
     */
    mlfAssign(
      &falsenorthing, mlfIndexRef(mclVa(mstruct, "mstruct"), ".falsenorthing"));
    /*
     * 
     * 
     * 
     * %  Adjust the origin latitude to the auxiliary sphere
     * 
     * origin(1) = geod2cnf(origin(1),mstruct.geoid,'radians');
     */
    mclIntArrayAssign1(
      &origin,
      mclFeval(
        mclValueVarargout(),
        mlxGeod2cnf,
        mclIntArrayRef1(mclVv(origin, "origin"), 1),
        mlfIndexRef(mclVa(mstruct, "mstruct"), ".geoid"),
        _mxarray11_,
        NULL),
      1);
    /*
     * trimlat   = geod2cnf(trimlat  ,mstruct.geoid,'radians');
     */
    mlfAssign(
      &trimlat,
      mclFeval(
        mclValueVarargout(),
        mlxGeod2cnf,
        mclVv(trimlat, "trimlat"),
        mlfIndexRef(mclVa(mstruct, "mstruct"), ".geoid"),
        _mxarray11_,
        NULL));
    /*
     * parallels = geod2cnf(parallels,mstruct.geoid,'radians');
     */
    mlfAssign(
      &parallels,
      mclFeval(
        mclValueVarargout(),
        mlxGeod2cnf,
        mclVv(parallels, "parallels"),
        mlfIndexRef(mclVa(mstruct, "mstruct"), ".geoid"),
        _mxarray11_,
        NULL));
    /*
     * 
     * 
     * switch direction
     */
    {
        mxArray * v_ = mclInitialize(mclVa(direction, "direction"));
        if (mclSwitchCompare(v_, _mxarray13_)) {
            /*
             * case 'forward'
             * 
             * lat  = angledim(in1,units,'radians');   %  Convert to radians
             */
            mlfAssign(
              &lat,
              mlfAngledim(
                mclVa(in1, "in1"), mclVv(units, "units"), _mxarray11_));
            /*
             * lat  = geod2cnf(lat,mstruct.geoid,'radians');
             */
            mlfAssign(
              &lat,
              mclFeval(
                mclValueVarargout(),
                mlxGeod2cnf,
                mclVv(lat, "lat"),
                mlfIndexRef(mclVa(mstruct, "mstruct"), ".geoid"),
                _mxarray11_,
                NULL));
            /*
             * long = angledim(in2,units,'radians');
             */
            mlfAssign(
              &long0,
              mlfAngledim(
                mclVa(in2, "in2"), mclVv(units, "units"), _mxarray11_));
            /*
             * 
             * [lat,long] = rotatem(lat,long,origin,direction);   %  Rotate to new origin
             */
            mlfAssign(
              &lat,
              mlfRotatem(
                &long0,
                mclVv(lat, "lat"),
                mclVv(long0, "long"),
                mclVv(origin, "origin"),
                mclVa(direction, "direction"),
                NULL));
            /*
             * [lat,long,clipped] = clipdata(lat,long,object);    %  Clip at the date line
             */
            mlfAssign(
              &lat,
              mlfClipdata(
                &long0,
                &clipped,
                mclVv(lat, "lat"),
                mclVv(long0, "long"),
                mclVa(object, "object")));
            /*
             * [lat,long,trimmed] = trimdata(lat,trimlat,long,trimlon,object);
             */
            mlfAssign(
              &lat,
              mlfTrimdata(
                &long0,
                &trimmed,
                mclVv(lat, "lat"),
                mclVv(trimlat, "trimlat"),
                mclVv(long0, "long"),
                mclVv(trimlon, "trimlon"),
                mclVa(object, "object")));
            /*
             * 
             * %  Construct the structure of altered points
             * 
             * savepts.trimmed = trimmed;
             */
            mlfIndexAssign(savepts, ".trimmed", mclVv(trimmed, "trimmed"));
            /*
             * savepts.clipped = clipped;
             */
            mlfIndexAssign(savepts, ".clipped", mclVv(clipped, "clipped"));
            /*
             * 
             * %  Perform the projection calculations
             * 
             * x = geoid(1) * long * cos(parallels(1));
             */
            mlfAssign(
              &x,
              mclMtimes(
                mclMtimes(
                  mclIntArrayRef1(mclVv(geoid, "geoid"), 1),
                  mclVv(long0, "long")),
                mlfCos(mclIntArrayRef1(mclVv(parallels, "parallels"), 1))));
            /*
             * y = geoid(1) * log(tan(pi/4+lat/2)) * cos(parallels(1));
             */
            mlfAssign(
              &y,
              mclMtimes(
                mclMtimes(
                  mclIntArrayRef1(mclVv(geoid, "geoid"), 1),
                  mlfLog(
                    mlfTan(
                      mclPlus(
                        _mxarray15_,
                        mclMrdivide(mclVv(lat, "lat"), _mxarray16_))))),
                mlfCos(mclIntArrayRef1(mclVv(parallels, "parallels"), 1))));
            /*
             * 
             * %  Apply scale factor, false easting, northing
             * 
             * x = x*scalefactor+falseeasting;
             */
            mlfAssign(
              &x,
              mclPlus(
                mclMtimes(mclVv(x, "x"), mclVv(scalefactor, "scalefactor")),
                mclVv(falseeasting, "falseeasting")));
            /*
             * y = y*scalefactor+falsenorthing;
             */
            mlfAssign(
              &y,
              mclPlus(
                mclMtimes(mclVv(y, "y"), mclVv(scalefactor, "scalefactor")),
                mclVv(falsenorthing, "falsenorthing")));
            /*
             * 
             * %  Set the output variables
             * 
             * switch  aspect
             */
            {
                mxArray * v_0 = mclInitialize(mclVv(aspect, "aspect"));
                if (mclSwitchCompare(v_0, _mxarray17_)) {
                    /*
                     * case 'normal',         out1 = x;      out2 = y;
                     */
                    mlfAssign(&out1, mclVv(x, "x"));
                    mlfAssign(out2, mclVv(y, "y"));
                /*
                 * case 'transverse',	   out1 = y;      out2 = -x;
                 */
                } else if (mclSwitchCompare(v_0, _mxarray19_)) {
                    mlfAssign(&out1, mclVv(y, "y"));
                    mlfAssign(out2, mclUminus(mclVv(x, "x")));
                /*
                 * otherwise,             error('Unrecognized aspect string')
                 */
                } else {
                    mlfError(_mxarray21_, NULL);
                /*
                 * end
                 */
                }
                mxDestroyArray(v_0);
            }
        /*
         * 
         * 
         * case 'inverse'
         */
        } else if (mclSwitchCompare(v_, _mxarray23_)) {
            /*
             * 
             * switch  aspect
             */
            mxArray * v_1 = mclInitialize(mclVv(aspect, "aspect"));
            if (mclSwitchCompare(v_1, _mxarray17_)) {
                /*
                 * case 'normal',         x = in1;    y = in2;
                 */
                mlfAssign(&x, mclVa(in1, "in1"));
                mlfAssign(&y, mclVa(in2, "in2"));
            /*
             * case 'transverse',	   x = -in2;   y = in1;
             */
            } else if (mclSwitchCompare(v_1, _mxarray19_)) {
                mlfAssign(&x, mclUminus(mclVa(in2, "in2")));
                mlfAssign(&y, mclVa(in1, "in1"));
            /*
             * otherwise,             error('Unrecognized aspect string')
             */
            } else {
                mlfError(_mxarray21_, NULL);
            /*
             * end
             */
            }
            mxDestroyArray(v_1);
            /*
             * 
             * %  Apply scale factor, false easting, northing
             * 
             * x = (x-falseeasting)/scalefactor;
             */
            mlfAssign(
              &x,
              mclMrdivide(
                mclMinus(mclVv(x, "x"), mclVv(falseeasting, "falseeasting")),
                mclVv(scalefactor, "scalefactor")));
            /*
             * y = (y-falsenorthing)/scalefactor;
             */
            mlfAssign(
              &y,
              mclMrdivide(
                mclMinus(mclVv(y, "y"), mclVv(falsenorthing, "falsenorthing")),
                mclVv(scalefactor, "scalefactor")));
            /*
             * 
             * % Inverse projection
             * 
             * long = x / (geoid(1) * cos(parallels(1)) );
             */
            mlfAssign(
              &long0,
              mclMrdivide(
                mclVv(x, "x"),
                mclMtimes(
                  mclIntArrayRef1(mclVv(geoid, "geoid"), 1),
                  mlfCos(mclIntArrayRef1(mclVv(parallels, "parallels"), 1)))));
            /*
             * lat  = pi/2 - 2*atan(exp(-y/  (geoid(1) * cos(parallels(1)) )  ));
             */
            mlfAssign(
              &lat,
              mclMinus(
                _mxarray25_,
                mclMtimes(
                  _mxarray16_,
                  mlfAtan(
                    mlfExp(
                      mclMrdivide(
                        mclUminus(mclVv(y, "y")),
                        mclMtimes(
                          mclIntArrayRef1(mclVv(geoid, "geoid"), 1),
                          mlfCos(
                            mclIntArrayRef1(
                              mclVv(parallels, "parallels"), 1)))))))));
            /*
             * 
             * %  Undo trims and clips
             * 
             * [lat,long] = undotrim(lat,long,savepts.trimmed,object);
             */
            mclFeval(
              mlfVarargout(&lat, &long0, NULL),
              mlxUndotrim,
              mclVv(lat, "lat"),
              mclVv(long0, "long"),
              mlfIndexRef(mclVa(*savepts, "savepts"), ".trimmed"),
              mclVa(object, "object"),
              NULL);
            /*
             * [lat,long] = undoclip(lat,long,savepts.clipped,object);
             */
            mclFeval(
              mlfVarargout(&lat, &long0, NULL),
              mlxUndoclip,
              mclVv(lat, "lat"),
              mclVv(long0, "long"),
              mlfIndexRef(mclVa(*savepts, "savepts"), ".clipped"),
              mclVa(object, "object"),
              NULL);
            /*
             * 
             * [lat,long] = rotatem(lat,long,origin,direction);  %  Rotate back to Greenwich
             */
            mlfAssign(
              &lat,
              mlfRotatem(
                &long0,
                mclVv(lat, "lat"),
                mclVv(long0, "long"),
                mclVv(origin, "origin"),
                mclVa(direction, "direction"),
                NULL));
            /*
             * lat        = cnf2geod(lat,mstruct.geoid,'radians');
             */
            mlfAssign(
              &lat,
              mclFeval(
                mclValueVarargout(),
                mlxCnf2geod,
                mclVv(lat, "lat"),
                mlfIndexRef(mclVa(mstruct, "mstruct"), ".geoid"),
                _mxarray11_,
                NULL));
            /*
             * 
             * out1 = angledim(lat, 'radians', units);   %  Transform units
             */
            mlfAssign(
              &out1,
              mlfAngledim(
                mclVv(lat, "lat"), _mxarray11_, mclVv(units, "units")));
            /*
             * out2 = angledim(long,'radians', units);
             */
            mlfAssign(
              out2,
              mlfAngledim(
                mclVv(long0, "long"), _mxarray11_, mclVv(units, "units")));
        /*
         * 
         * otherwise
         */
        } else {
            /*
             * error('Unrecognized direction string')
             */
            mlfError(_mxarray26_, NULL);
        /*
         * end
         */
        }
        mxDestroyArray(v_);
    }
    /*
     * 
     * %  Some operations on NaNs produce NaN + NaNi.  However operations
     * %  outside the map may product complex results and we don't want
     * %  to destroy this indicator.
     * 
     * indx = find(isnan(out1) | isnan(out2));
     */
    mlfAssign(
      &indx,
      mlfFind(
        NULL,
        NULL,
        mclOr(mlfIsnan(mclVv(out1, "out1")), mlfIsnan(mclVv(*out2, "out2")))));
    /*
     * out1(indx) = NaN;   out2(indx) = NaN;
     */
    mclArrayAssign1(&out1, _mxarray28_, mclVv(indx, "indx"));
    mclArrayAssign1(out2, _mxarray28_, mclVv(indx, "indx"));
    /*
     * 
     * 
     */
    return_:
    mclValidateOutput(out1, 1, nargout_, "out1", "mercator");
    mclValidateOutput(*out2, 2, nargout_, "out2", "mercator");
    mclValidateOutput(*savepts, 3, nargout_, "savepts", "mercator");
    mxDestroyArray(ans);
    mxDestroyArray(units);
    mxDestroyArray(geoid);
    mxDestroyArray(aspect);
    mxDestroyArray(parallels);
    mxDestroyArray(origin);
    mxDestroyArray(trimlat);
    mxDestroyArray(trimlon);
    mxDestroyArray(scalefactor);
    mxDestroyArray(falseeasting);
    mxDestroyArray(falsenorthing);
    mxDestroyArray(lat);
    mxDestroyArray(long0);
    mxDestroyArray(clipped);
    mxDestroyArray(trimmed);
    mxDestroyArray(x);
    mxDestroyArray(y);
    mxDestroyArray(indx);
    mxDestroyArray(direction);
    mxDestroyArray(object);
    mxDestroyArray(in2);
    mxDestroyArray(in1);
    mxDestroyArray(mstruct);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return out1;
}
