/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:36 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "merccalc.h"
#include "angledim.h"
#include "defaultm.h"
#include "geoidtst.h"
#include "libmatlbm.h"
#include "mercator.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;
static mxArray * _mxarray2_;

static mxChar _array4_[7] = { 'd', 'e', 'g', 'r', 'e', 'e', 's' };
static mxArray * _mxarray3_;

static double _array6_[2] = { 1.0, 0.0 };
static mxArray * _mxarray5_;

static mxChar _array8_[33] = { 'I', 'n', 'c', 'o', 'n', 's', 'i', 's', 't',
                               'e', 'n', 't', ' ', 'd', 'i', 'm', 'e', 'n',
                               's', 'i', 'o', 'n', 's', ' ', 'o', 'n', ' ',
                               'i', 'n', 'p', 'u', 't', 's' };
static mxArray * _mxarray7_;

static mxChar _array10_[8] = { 'm', 'e', 'r', 'c', 'a', 't', 'o', 'r' };
static mxArray * _mxarray9_;

static double _array12_[2] = { 0.0, 0.0 };
static mxArray * _mxarray11_;

static double _array14_[3] = { 0.0, 0.0, 0.0 };
static mxArray * _mxarray13_;

static mxChar _array16_[6] = { 'n', 'o', 'r', 'm', 'a', 'l' };
static mxArray * _mxarray15_;

static double _array18_[2] = { -90.0, 90.0 };
static mxArray * _mxarray17_;

static double _array20_[2] = { -180.0, 180.0 };
static mxArray * _mxarray19_;

static double _array22_[2] = { -89.9, 89.9 };
static mxArray * _mxarray21_;

static mxChar _array24_[4] = { 't', 'e', 'x', 't' };
static mxArray * _mxarray23_;

void InitializeModule_merccalc(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray3_ = mclInitializeString(7, _array4_);
    _mxarray5_ = mclInitializeDoubleVector(1, 2, _array6_);
    _mxarray7_ = mclInitializeString(33, _array8_);
    _mxarray9_ = mclInitializeString(8, _array10_);
    _mxarray11_ = mclInitializeDoubleVector(1, 2, _array12_);
    _mxarray13_ = mclInitializeDoubleVector(1, 3, _array14_);
    _mxarray15_ = mclInitializeString(6, _array16_);
    _mxarray17_ = mclInitializeDoubleVector(1, 2, _array18_);
    _mxarray19_ = mclInitializeDoubleVector(1, 2, _array20_);
    _mxarray21_ = mclInitializeDoubleVector(1, 2, _array22_);
    _mxarray23_ = mclInitializeString(4, _array24_);
}

void TerminateModule_merccalc(void) {
    mxDestroyArray(_mxarray23_);
    mxDestroyArray(_mxarray21_);
    mxDestroyArray(_mxarray19_);
    mxDestroyArray(_mxarray17_);
    mxDestroyArray(_mxarray15_);
    mxDestroyArray(_mxarray13_);
    mxDestroyArray(_mxarray11_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mmerccalc(mxArray * * out2,
                           int nargout_,
                           mxArray * in1,
                           mxArray * in2,
                           mxArray * direction,
                           mxArray * units,
                           mxArray * geoid);

_mexLocalFunctionTable _local_function_table_merccalc
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfMerccalc" contains the normal interface for the "merccalc"
 * M-function from file "c:\matlab6p5\toolbox\map\map\merccalc.m" (lines 1-86).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfMerccalc(mxArray * * out2,
                      mxArray * in1,
                      mxArray * in2,
                      mxArray * direction,
                      mxArray * units,
                      mxArray * geoid) {
    int nargout = 1;
    mxArray * out1 = NULL;
    mxArray * out2__ = NULL;
    mlfEnterNewContext(1, 5, out2, in1, in2, direction, units, geoid);
    if (out2 != NULL) {
        ++nargout;
    }
    out1 = Mmerccalc(&out2__, nargout, in1, in2, direction, units, geoid);
    mlfRestorePreviousContext(1, 5, out2, in1, in2, direction, units, geoid);
    if (out2 != NULL) {
        mclCopyOutputArg(out2, out2__);
    } else {
        mxDestroyArray(out2__);
    }
    return mlfReturnValue(out1);
}

/*
 * The function "mlxMerccalc" contains the feval interface for the "merccalc"
 * M-function from file "c:\matlab6p5\toolbox\map\map\merccalc.m" (lines 1-86).
 * The feval function calls the implementation version of merccalc through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxMerccalc(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[5];
    mxArray * mplhs[2];
    int i;
    if (nlhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: merccalc Line: 1 Column:"
            " 1 The function \"merccalc\" was called with m"
            "ore than the declared number of outputs (2)."),
          NULL);
    }
    if (nrhs > 5) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: merccalc Line: 1 Column:"
            " 1 The function \"merccalc\" was called with m"
            "ore than the declared number of inputs (5)."),
          NULL);
    }
    for (i = 0; i < 2; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 5 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 5; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 5, mprhs[0], mprhs[1], mprhs[2], mprhs[3], mprhs[4]);
    mplhs[0]
      = Mmerccalc(
          &mplhs[1], nlhs, mprhs[0], mprhs[1], mprhs[2], mprhs[3], mprhs[4]);
    mlfRestorePreviousContext(
      0, 5, mprhs[0], mprhs[1], mprhs[2], mprhs[3], mprhs[4]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 2 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 2; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}

/*
 * The function "Mmerccalc" is the implementation version of the "merccalc"
 * M-function from file "c:\matlab6p5\toolbox\map\map\merccalc.m" (lines 1-86).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function [out1,out2] = merccalc(in1,in2,direction,units,geoid)
 */
static mxArray * Mmerccalc(mxArray * * out2,
                           int nargout_,
                           mxArray * in1,
                           mxArray * in2,
                           mxArray * direction,
                           mxArray * units,
                           mxArray * geoid) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_merccalc);
    int nargin_ = mclNargin(5, in1, in2, direction, units, geoid, NULL);
    mxArray * out1 = NULL;
    mxArray * savepts = NULL;
    mxArray * object = NULL;
    mxArray * mstruct = NULL;
    mxArray * msg = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&in1);
    mclCopyArray(&in2);
    mclCopyArray(&direction);
    mclCopyArray(&units);
    mclCopyArray(&geoid);
    /*
     * 
     * %MERCCALC  Transformation of data to and from a Mercator space
     * %
     * %  [x,y] = MERCCALC(lat,lon,'forward') transforms Greenwich
     * %  coordinate data to a Mercator space.  This transformation is
     * %  useful when manipulating data for heading calculations,
     * %  navigation calculations, etc.  This allows data to be operated
     * %  on in the workspace, independent of a map axes.
     * %
     * %  [x,y] = MERCCALC(lat,lon,'forward',geoid) transforms the Greenwich
     * %  coordinate data on the ellipsoid defined by the input geoid. The
     * %  geoid vector is of the form [semimajor axes, eccentricity].  If
     * %  omitted, the unit sphere, geoid = [1 0], is assumed.
     * %
     * %  [x,y] = MERCCALC(lat,lon,'forward','units') and
     * %  [x,y] = MERCCALC(lat,lon,'forward','units',geoid) uses the input
     * %  'units' to define the angle units of the input data.  If omitted,
     * %  'degrees' are assumed.
     * %
     * %  [lat,lon] = MERCCALC(x,y,'inverse') transforms from the Mercator
     * %  space to the Greenwich coordinate frame.
     * %
     * %  [lat,lon] = MERCCALC(x,y,'inverse',geoid),
     * %  [lat,lon] = MERCCALC(x,y,'inverse','units') and
     * %  [lat,lon] = MERCCALC(x,y,'inverse','units',geoid) are all valid
     * %  calling forms.
     * %
     * %  See also  EQACALC
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * % $Revision: 1.10 $
     * %  Written by:  E. Byrns, E. Brown
     * 
     * 
     * if nargin < 3
     */
    if (nargin_ < 3) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif nargin == 3
     */
    } else if (nargin_ == 3) {
        /*
         * units = [];     geoid = [];
         */
        mlfAssign(&units, _mxarray2_);
        mlfAssign(&geoid, _mxarray2_);
    /*
     * elseif nargin == 4 & isstr(units)
     */
    } else {
        mxArray * a_ = mclInitialize(mclBoolToArray(nargin_ == 4));
        if (mlfTobool(a_)
            && mlfTobool(mclAnd(a_, mlfIsstr(mclVa(units, "units"))))) {
            mxDestroyArray(a_);
            /*
             * geoid = [];
             */
            mlfAssign(&geoid, _mxarray2_);
        /*
         * elseif nargin == 4 & ~isstr(units)
         */
        } else {
            mxDestroyArray(a_);
            {
                mxArray * a_0 = mclInitialize(mclBoolToArray(nargin_ == 4));
                if (mlfTobool(a_0)
                    && mlfTobool(
                         mclAnd(
                           a_0, mclNot(mlfIsstr(mclVa(units, "units")))))) {
                    mxDestroyArray(a_0);
                    /*
                     * geoid = units;     units = [];
                     */
                    mlfAssign(&geoid, mclVa(units, "units"));
                    mlfAssign(&units, _mxarray2_);
                } else {
                    mxDestroyArray(a_0);
                }
            }
        }
    /*
     * end
     */
    }
    /*
     * 
     * %  Set default data if necessary
     * 
     * if isempty(units);  units = 'degrees';   end
     */
    if (mlfTobool(mlfIsempty(mclVa(units, "units")))) {
        mlfAssign(&units, _mxarray3_);
    }
    /*
     * if isempty(geoid);  geoid = [1 0];       end
     */
    if (mlfTobool(mlfIsempty(mclVa(geoid, "geoid")))) {
        mlfAssign(&geoid, _mxarray5_);
    }
    /*
     * 
     * %  Dimension tests
     * 
     * if ~isequal(size(in1),size(in2))
     */
    if (mclNotBool(
          mlfIsequal(
            mlfSize(mclValueVarargout(), mclVa(in1, "in1"), NULL),
            mlfSize(mclValueVarargout(), mclVa(in2, "in2"), NULL), NULL))) {
        /*
         * error('Inconsistent dimensions on inputs')
         */
        mlfError(_mxarray7_, NULL);
    /*
     * end
     */
    }
    /*
     * 
     * %  Test the geoid input
     * 
     * [geoid,msg] = geoidtst(geoid);
     */
    mlfAssign(&geoid, mlfNGeoidtst(2, &msg, mclVa(geoid, "geoid")));
    /*
     * if ~isempty(msg);   error(msg);   end
     */
    if (mclNotBool(mlfIsempty(mclVv(msg, "msg")))) {
        mlfError(mclVv(msg, "msg"), NULL);
    }
    /*
     * 
     * %  Construct the necessary map structure
     * 
     * mstruct = defaultm('mercator');
     */
    mlfAssign(&mstruct, mlfNDefaultm(1, NULL, _mxarray9_));
    /*
     * 
     * mstruct.geoid        = geoid;
     */
    mlfIndexAssign(&mstruct, ".geoid", mclVa(geoid, "geoid"));
    /*
     * mstruct.angleunits   = units;
     */
    mlfIndexAssign(&mstruct, ".angleunits", mclVa(units, "units"));
    /*
     * mstruct.mapparallels = [0 0];        %  Hard code some options used
     */
    mlfIndexAssign(&mstruct, ".mapparallels", _mxarray11_);
    /*
     * mstruct.origin       = [0 0 0];      %  in mercator.m
     */
    mlfIndexAssign(&mstruct, ".origin", _mxarray13_);
    /*
     * mstruct.aspect       = 'normal';
     */
    mlfIndexAssign(&mstruct, ".aspect", _mxarray15_);
    /*
     * mstruct.flatlimit    = angledim([-90 90],'degrees',units);
     */
    mlfIndexAssign(
      &mstruct,
      ".flatlimit",
      mlfAngledim(_mxarray17_, _mxarray3_, mclVa(units, "units")));
    /*
     * mstruct.flonlimit    = angledim([-180 180],'degrees',units);
     */
    mlfIndexAssign(
      &mstruct,
      ".flonlimit",
      mlfAngledim(_mxarray19_, _mxarray3_, mclVa(units, "units")));
    /*
     * 
     * mstruct.trimlat = angledim([-89.9 89.9],'degrees',units);
     */
    mlfIndexAssign(
      &mstruct,
      ".trimlat",
      mlfAngledim(_mxarray21_, _mxarray3_, mclVa(units, "units")));
    /*
     * 
     * mstruct = defaultm(mercator(mstruct));
     */
    mlfAssign(
      &mstruct,
      mlfNDefaultm(
        1,
        NULL,
        mlfMercator(
          NULL,
          NULL,
          mclVv(mstruct, "mstruct"),
          NULL,
          NULL,
          NULL,
          NULL,
          NULL)));
    /*
     * 
     * %  Set some interface variables for mercator
     * 
     * object = 'text';           %  Suppress all clips and trims
     */
    mlfAssign(&object, _mxarray23_);
    /*
     * savepts.trimmed = [];      %  Savepts needed in inverse direction
     */
    mlfIndexAssign(&savepts, ".trimmed", _mxarray2_);
    /*
     * savepts.clipped = [];
     */
    mlfIndexAssign(&savepts, ".clipped", _mxarray2_);
    /*
     * 
     * [out1,out2] = mercator(mstruct,in1,in2,object,direction,savepts);
     */
    mlfAssign(
      &out1,
      mlfMercator(
        out2,
        NULL,
        mclVv(mstruct, "mstruct"),
        mclVa(in1, "in1"),
        mclVa(in2, "in2"),
        mclVv(object, "object"),
        mclVa(direction, "direction"),
        mclVv(savepts, "savepts")));
    mclValidateOutput(out1, 1, nargout_, "out1", "merccalc");
    mclValidateOutput(*out2, 2, nargout_, "out2", "merccalc");
    mxDestroyArray(ans);
    mxDestroyArray(msg);
    mxDestroyArray(mstruct);
    mxDestroyArray(object);
    mxDestroyArray(savepts);
    mxDestroyArray(geoid);
    mxDestroyArray(units);
    mxDestroyArray(direction);
    mxDestroyArray(in2);
    mxDestroyArray(in1);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return out1;
    /*
     * 
     */
}
