/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:29 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "nextmap.h"
#include "clmo.h"
#include "ismap.h"
#include "libmatlbm.h"
#include "libmmfile.h"

static mxChar _array1_[8] = { 'N', 'e', 'x', 't', 'P', 'l', 'o', 't' };
static mxArray * _mxarray0_;

static mxChar _array3_[7] = { 'r', 'e', 'p', 'l', 'a', 'c', 'e' };
static mxArray * _mxarray2_;

static mxChar _array5_[3] = { 'm', 'a', 'p' };
static mxArray * _mxarray4_;

void InitializeModule_nextmap(void) {
    _mxarray0_ = mclInitializeString(8, _array1_);
    _mxarray2_ = mclInitializeString(7, _array3_);
    _mxarray4_ = mclInitializeString(3, _array5_);
}

void TerminateModule_nextmap(void) {
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static void Mnextmap(void);

_mexLocalFunctionTable _local_function_table_nextmap
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfNextmap" contains the normal interface for the "nextmap"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\nextmap.m" (lines
 * 1-23). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlfNextmap(void) {
    mlfEnterNewContext(0, 0);
    Mnextmap();
    mlfRestorePreviousContext(0, 0);
}

/*
 * The function "mlxNextmap" contains the feval interface for the "nextmap"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\nextmap.m" (lines
 * 1-23). The feval function calls the implementation version of nextmap
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxNextmap(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    if (nlhs > 0) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: nextmap Line: 1 Column: "
            "1 The function \"nextmap\" was called with mor"
            "e than the declared number of outputs (0)."),
          NULL);
    }
    if (nrhs > 0) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: nextmap Line: 1 Column:"
            " 1 The function \"nextmap\" was called with m"
            "ore than the declared number of inputs (0)."),
          NULL);
    }
    mlfEnterNewContext(0, 0);
    Mnextmap();
    mlfRestorePreviousContext(0, 0);
}

/*
 * The function "Mnextmap" is the implementation version of the "nextmap"
 * M-function from file "c:\matlab6p5\toolbox\map\mapdisp\nextmap.m" (lines
 * 1-23). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function nextmap
 */
static void Mnextmap(void) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_nextmap);
    mxArray * ans = NULL;
    /*
     * 
     * %NEXTMAP  Readies a map axes for the next object
     * %
     * %  NEXTMAP readies a map axes for the next map object.
     * %  If the hold state is off, NEXTMAP will also clear
     * %  the current map before the next object is displayed.
     * %
     * %  See also CLMA
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.10 $    $Date: 2002/03/20 21:27:53 $
     * 
     * 
     * %  Clear the map, but not the frame,
     * %  if a hold on has not been issued
     * 
     * if ismap
     */
    if (mlfTobool(mlfIsmap(NULL, NULL))) {
        /*
         * if strcmp(get(gca,'NextPlot'),'replace');    clmo('map');    end
         */
        if (mlfTobool(
              mlfStrcmp(
                mlfNGet(1, mlfGca(NULL), _mxarray0_, NULL), _mxarray2_))) {
            mlfClmo(_mxarray4_);
        }
    /*
     * end
     */
    }
    mxDestroyArray(ans);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    /*
     * 
     */
}
