/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:37 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "polyjoin.h"
#include "libmatlbm.h"
#include "libmmfile.h"

static mxChar _array1_[36] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't',
                               ' ', 'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o',
                               'f', ' ', 'i', 'n', 'p', 'u', 't', ' ', 'a',
                               'r', 'g', 'u', 'm', 'e', 'n', 't', 's', '.' };
static mxArray * _mxarray0_;

static mxChar _array3_[27] = { 'I', 'n', 'p', 'u', 't', 's', ' ', 'm', 'u',
                               's', 't', ' ', 'b', 'e', ' ', 'c', 'e', 'l',
                               'l', ' ', 'a', 'r', 'r', 'a', 'y', 's', '.' };
static mxArray * _mxarray2_;
static mxArray * _mxarray4_;
static mxArray * _mxarray5_;
static double _ieee_nan_;
static mxArray * _mxarray6_;

void InitializeModule_polyjoin(void) {
    _mxarray0_ = mclInitializeString(36, _array1_);
    _mxarray2_ = mclInitializeString(27, _array3_);
    _mxarray4_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray5_ = mclInitializeDouble(1.0);
    _ieee_nan_ = mclGetNaN();
    _mxarray6_ = mclInitializeDouble(_ieee_nan_);
}

void TerminateModule_polyjoin(void) {
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mpolyjoin(mxArray * * lon2,
                           int nargout_,
                           mxArray * latcells,
                           mxArray * loncells);

_mexLocalFunctionTable _local_function_table_polyjoin
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfPolyjoin" contains the normal interface for the "polyjoin"
 * M-function from file "c:\matlab6p5\toolbox\map\map\polyjoin.m" (lines 1-39).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfPolyjoin(mxArray * * lon2,
                      mxArray * latcells,
                      mxArray * loncells) {
    int nargout = 1;
    mxArray * lat2 = NULL;
    mxArray * lon2__ = NULL;
    mlfEnterNewContext(1, 2, lon2, latcells, loncells);
    if (lon2 != NULL) {
        ++nargout;
    }
    lat2 = Mpolyjoin(&lon2__, nargout, latcells, loncells);
    mlfRestorePreviousContext(1, 2, lon2, latcells, loncells);
    if (lon2 != NULL) {
        mclCopyOutputArg(lon2, lon2__);
    } else {
        mxDestroyArray(lon2__);
    }
    return mlfReturnValue(lat2);
}

/*
 * The function "mlxPolyjoin" contains the feval interface for the "polyjoin"
 * M-function from file "c:\matlab6p5\toolbox\map\map\polyjoin.m" (lines 1-39).
 * The feval function calls the implementation version of polyjoin through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxPolyjoin(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[2];
    int i;
    if (nlhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: polyjoin Line: 1 Column:"
            " 1 The function \"polyjoin\" was called with m"
            "ore than the declared number of outputs (2)."),
          NULL);
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: polyjoin Line: 1 Column:"
            " 1 The function \"polyjoin\" was called with m"
            "ore than the declared number of inputs (2)."),
          NULL);
    }
    for (i = 0; i < 2; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mpolyjoin(&mplhs[1], nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 2 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 2; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}

/*
 * The function "Mpolyjoin" is the implementation version of the "polyjoin"
 * M-function from file "c:\matlab6p5\toolbox\map\map\polyjoin.m" (lines 1-39).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function [lat2,lon2] = polyjoin(latcells,loncells)
 */
static mxArray * Mpolyjoin(mxArray * * lon2,
                           int nargout_,
                           mxArray * latcells,
                           mxArray * loncells) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_polyjoin);
    int nargin_ = mclNargin(2, latcells, loncells, NULL);
    mxArray * lat2 = NULL;
    mxArray * i = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&latcells);
    mclCopyArray(&loncells);
    /*
     * % POLYJOIN convert polygon segments from cell array to vector format
     * % 
     * % [lat2,lon2] = POLYJOIN(latcells,loncells) converts polygons from cell
     * % array format to vector format. In cell array format, each element of 
     * % the cell array is a separate polygon. Each polygon may consist of an 
     * % outer contour followed by holes separated with NaNs. In vector format, 
     * % each vector may contain multiple faces separated by NaNs. There is no
     * % distinction between outer contours and holes.
     * %
     * % See also POLYSPLIT, POLYBOOL, POLYCUT
     * 
     * %  Written by: W. Stumpf
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  $Revision: 1.4 $    $Date: 2002/03/20 21:26:08 $
     * 
     * if nargin<2, error('Incorrect number of input arguments.'), end
     */
    if (nargin_ < 2) {
        mlfError(_mxarray0_, NULL);
    }
    /*
     * 
     * if ~iscell(latcells) | ~iscell(loncells)
     */
    {
        mxArray * a_
          = mclInitialize(mclNot(mlfIscell(mclVa(latcells, "latcells"))));
        if (mlfTobool(a_)
            || mlfTobool(
                 mclOr(a_, mclNot(mlfIscell(mclVa(loncells, "loncells")))))) {
            mxDestroyArray(a_);
            /*
             * error('Inputs must be cell arrays.')
             */
            mlfError(_mxarray2_, NULL);
        } else {
            mxDestroyArray(a_);
        }
    /*
     * end
     */
    }
    /*
     * 
     * if isempty(latcells);
     */
    if (mlfTobool(mlfIsempty(mclVa(latcells, "latcells")))) {
        /*
         * 
         * [lat2,lon2] = deal([],[]);
         */
        mlfNDeal(
          0, mlfVarargout(&lat2, lon2, NULL), _mxarray4_, _mxarray4_, NULL);
        /*
         * return
         */
        goto return_;
    /*
     * 
     * else
     */
    } else {
        /*
         * 
         * [lat2,lon2] = deal(latcells{1},loncells{1});
         */
        mlfNDeal(
          0,
          mlfVarargout(&lat2, lon2, NULL),
          mlfIndexRef(mclVa(latcells, "latcells"), "{?}", _mxarray5_),
          mlfIndexRef(mclVa(loncells, "loncells"), "{?}", _mxarray5_),
          NULL);
    /*
     * 
     * end
     */
    }
    /*
     * 
     * for i=2:length(latcells)
     */
    {
        int v_ = mclForIntStart(2);
        int e_ = mclLengthInt(mclVa(latcells, "latcells"));
        if (v_ > e_) {
            mlfAssign(&i, _mxarray4_);
        } else {
            /*
             * [lat2,lon2] = deal([lat2;NaN;latcells{i}], [lon2;NaN;loncells{i}]);
             * end
             */
            for (; ; ) {
                mlfNDeal(
                  0,
                  mlfVarargout(&lat2, lon2, NULL),
                  mlfVertcat(
                    mclVv(lat2, "lat2"),
                    _mxarray6_,
                    mlfHorzcat(
                      mlfIndexRef(
                        mclVa(latcells, "latcells"), "{?}", mlfScalar(v_)),
                      NULL),
                    NULL),
                  mlfVertcat(
                    mclVv(*lon2, "lon2"),
                    _mxarray6_,
                    mlfHorzcat(
                      mlfIndexRef(
                        mclVa(loncells, "loncells"), "{?}", mlfScalar(v_)),
                      NULL),
                    NULL),
                  NULL);
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            mlfAssign(&i, mlfScalar(v_));
        }
    }
    /*
     * 
     * 
     */
    return_:
    mclValidateOutput(lat2, 1, nargout_, "lat2", "polyjoin");
    mclValidateOutput(*lon2, 2, nargout_, "lon2", "polyjoin");
    mxDestroyArray(ans);
    mxDestroyArray(i);
    mxDestroyArray(loncells);
    mxDestroyArray(latcells);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return lat2;
}
