/*
 * MATLAB Compiler: 3.0
 * Date: Tue Feb 15 16:13:30 2005
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-B" "sgl" "-m" "-W"
 * "main" "-L" "C" "-t" "-T" "link:exe" "-h" "libmmfile.mlib" "-W" "mainhg"
 * "libmwsglm.mlib" "-d" "c:\tmargolina\drifters\RAFOSgui\" "traj" 
 */
#include "rad2deg.h"
#include "libmatlbm.h"

static mxChar _array1_[29] = { 'I', 'n', 'c', 'o', 'r', 'r', 'e', 'c', 't', ' ',
                               'n', 'u', 'm', 'b', 'e', 'r', ' ', 'o', 'f', ' ',
                               'a', 'r', 'g', 'u', 'm', 'e', 'n', 't', 's' };
static mxArray * _mxarray0_;

static mxChar _array3_[49] = { 'I', 'm', 'a', 'g', 'i', 'n', 'a', 'r', 'y', ' ',
                               'p', 'a', 'r', 't', 's', ' ', 'o', 'f', ' ', 'c',
                               'o', 'm', 'p', 'l', 'e', 'x', ' ', 'A', 'N', 'G',
                               'L', 'E', ' ', 'a', 'r', 'g', 'u', 'm', 'e', 'n',
                               't', ' ', 'i', 'g', 'n', 'o', 'r', 'e', 'd' };
static mxArray * _mxarray2_;
static mxArray * _mxarray4_;
static mxArray * _mxarray5_;

void InitializeModule_rad2deg(void) {
    _mxarray0_ = mclInitializeString(29, _array1_);
    _mxarray2_ = mclInitializeString(49, _array3_);
    _mxarray4_ = mclInitializeDouble(180.0);
    _mxarray5_ = mclInitializeDouble(3.141592653589793);
}

void TerminateModule_rad2deg(void) {
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mrad2deg(int nargout_, mxArray * R);

_mexLocalFunctionTable _local_function_table_rad2deg
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfRad2deg" contains the normal interface for the "rad2deg"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rad2deg.m" (lines 1-21).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfRad2deg(mxArray * R) {
    int nargout = 1;
    mxArray * D = NULL;
    mlfEnterNewContext(0, 1, R);
    D = Mrad2deg(nargout, R);
    mlfRestorePreviousContext(0, 1, R);
    return mlfReturnValue(D);
}

/*
 * The function "mlxRad2deg" contains the feval interface for the "rad2deg"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rad2deg.m" (lines 1-21).
 * The feval function calls the implementation version of rad2deg through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxRad2deg(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: rad2deg Line: 1 Column: "
            "1 The function \"rad2deg\" was called with mor"
            "e than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: rad2deg Line: 1 Column:"
            " 1 The function \"rad2deg\" was called with m"
            "ore than the declared number of inputs (1)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mrad2deg(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mrad2deg" is the implementation version of the "rad2deg"
 * M-function from file "c:\matlab6p5\toolbox\map\map\rad2deg.m" (lines 1-21).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function D=rad2deg(R)
 */
static mxArray * Mrad2deg(int nargout_, mxArray * R) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_rad2deg);
    int nargin_ = mclNargin(1, R, NULL);
    mxArray * D = NULL;
    mxArray * ans = NULL;
    mclCopyArray(&R);
    /*
     * 
     * %RAD2DEG Converts angles from radians to degrees
     * %
     * %  deg = RAD2DEG(rad) converts angles from radians to degrees.
     * %
     * %  See also DEG2RAD, RAD2DMS, ANGLEDIM, ANGL2STR
     * 
     * %  Copyright 1996-2002 Systems Planning and Analysis, Inc. and The MathWorks, Inc.
     * %  Written by:  E. Byrns, E. Brown
     * %   $Revision: 1.9 $    $Date: 2002/03/20 21:26:11 $
     * 
     * if nargin==0
     */
    if (nargin_ == 0) {
        /*
         * error('Incorrect number of arguments')
         */
        mlfError(_mxarray0_, NULL);
    /*
     * elseif ~isreal(R)
     */
    } else if (mclNotBool(mlfIsreal(mclVa(R, "R")))) {
        /*
         * warning('Imaginary parts of complex ANGLE argument ignored')
         */
        mclPrintAns(&ans, mlfNWarning(0, NULL, _mxarray2_, NULL));
        /*
         * R = real(R);
         */
        mlfAssign(&R, mlfReal(mclVa(R, "R")));
    /*
     * end
     */
    }
    /*
     * 
     * D = R*180/pi;
     */
    mlfAssign(
      &D, mclMrdivide(mclMtimes(mclVa(R, "R"), _mxarray4_), _mxarray5_));
    mclValidateOutput(D, 1, nargout_, "D", "rad2deg");
    mxDestroyArray(ans);
    mxDestroyArray(R);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return D;
}
